/* Composer.c generated by valac 0.56.17, the Vala compiler
 * generated from Composer.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2017-2023 elementary, Inc. (https://elementary.io)
 *
 * Authored by: David Hewitt <davidmhewitt@gmail.com>
 */

#include <handy.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <camel/camel.h>
#include <webkit2/webkit2.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <libedataserver/libedataserver.h>
#include <glib/gstdio.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#define MAIL_COMPOSER_ACTION_GROUP_PREFIX "win"
#define MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_GROUP_PREFIX "."
#define MAIL_COMPOSER_ACTION_ADD_ATTACHMENT "add-attachment"
#define MAIL_COMPOSER_ACTION_INSERT_IMAGE "insert-image"
#define MAIL_COMPOSER_ACTION_INSERT_SIGNATURE "insert-signature"
#define MAIL_COMPOSER_ACTION_DISCARD "discard"
#define MAIL_COMPOSER_ACTION_SEND "send"
#define MAIL_COMPOSER_ATTACHMENT_DISPOSITION_ATTACHMENT "attachment"
#define MAIL_COMPOSER_ATTACHMENT_DISPOSITION_INLINE "inline"
#define MAIL_APPLICATION_ACTION_GROUP_PREFIX "app"
#define MAIL_APPLICATION_ACTION_PREFIX MAIL_APPLICATION_ACTION_GROUP_PREFIX "."
#define MAIL_APPLICATION_ACTION_MANAGE_SIGNATURES "manage-signatures"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MAIL_TYPE_COMPOSER (mail_composer_get_type ())
#define MAIL_COMPOSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_COMPOSER, MailComposer))
#define MAIL_COMPOSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_COMPOSER, MailComposerClass))
#define MAIL_IS_COMPOSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_COMPOSER))
#define MAIL_IS_COMPOSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_COMPOSER))
#define MAIL_COMPOSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_COMPOSER, MailComposerClass))

typedef struct _MailComposer MailComposer;
typedef struct _MailComposerClass MailComposerClass;
typedef struct _MailComposerPrivate MailComposerPrivate;

#define MAIL_TYPE_WEB_VIEW (mail_web_view_get_type ())
#define MAIL_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_WEB_VIEW, MailWebView))
#define MAIL_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_WEB_VIEW, MailWebViewClass))
#define MAIL_IS_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_WEB_VIEW))
#define MAIL_IS_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_WEB_VIEW))
#define MAIL_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_WEB_VIEW, MailWebViewClass))

typedef struct _MailWebView MailWebView;
typedef struct _MailWebViewClass MailWebViewClass;
enum  {
	MAIL_COMPOSER_0_PROPERTY,
	MAIL_COMPOSER_HAS_RECIPIENTS_PROPERTY,
	MAIL_COMPOSER_TO_PROPERTY,
	MAIL_COMPOSER_MAILTO_QUERY_PROPERTY,
	MAIL_COMPOSER_NUM_PROPERTIES
};
static GParamSpec* mail_composer_properties[MAIL_COMPOSER_NUM_PROPERTIES];
typedef enum  {
	MAIL_COMPOSER_TYPE_REPLY,
	MAIL_COMPOSER_TYPE_REPLY_ALL,
	MAIL_COMPOSER_TYPE_FORWARD,
	MAIL_COMPOSER_TYPE_DRAFT
} MailComposerType;

#define MAIL_COMPOSER_TYPE_TYPE (mail_composer_type_get_type ())
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define MAIL_COMPOSER_TYPE_ATTACHMENT (mail_composer_attachment_get_type ())
#define MAIL_COMPOSER_ATTACHMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_COMPOSER_TYPE_ATTACHMENT, MailComposerAttachment))
#define MAIL_COMPOSER_ATTACHMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_COMPOSER_TYPE_ATTACHMENT, MailComposerAttachmentClass))
#define MAIL_COMPOSER_IS_ATTACHMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_COMPOSER_TYPE_ATTACHMENT))
#define MAIL_COMPOSER_IS_ATTACHMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_COMPOSER_TYPE_ATTACHMENT))
#define MAIL_COMPOSER_ATTACHMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_COMPOSER_TYPE_ATTACHMENT, MailComposerAttachmentClass))

typedef struct _MailComposerAttachment MailComposerAttachment;
typedef struct _MailComposerAttachmentClass MailComposerAttachmentClass;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;

#define MAIL_BACKEND_TYPE_SESSION (mail_backend_session_get_type ())
#define MAIL_BACKEND_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_BACKEND_TYPE_SESSION, MailBackendSession))
#define MAIL_BACKEND_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_BACKEND_TYPE_SESSION, MailBackendSessionClass))
#define MAIL_BACKEND_IS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_BACKEND_TYPE_SESSION))
#define MAIL_BACKEND_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_BACKEND_TYPE_SESSION))
#define MAIL_BACKEND_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_BACKEND_TYPE_SESSION, MailBackendSessionClass))

typedef struct _MailBackendSession MailBackendSession;
typedef struct _MailBackendSessionClass MailBackendSessionClass;
typedef struct _Block9Data Block9Data;
typedef gboolean (*MailUtilsAcceptAddress) (const gchar* address, gpointer user_data);
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _MailComposerGetAttachmentsData MailComposerGetAttachmentsData;
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
typedef struct _Block12Data Block12Data;
typedef struct _Block13Data Block13Data;
typedef struct _Block14Data Block14Data;
typedef struct _MailComposerSendMessageData MailComposerSendMessageData;

#define MAIL_TYPE_CONTACT_MANAGER (mail_contact_manager_get_type ())
#define MAIL_CONTACT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_CONTACT_MANAGER, MailContactManager))
#define MAIL_CONTACT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_CONTACT_MANAGER, MailContactManagerClass))
#define MAIL_IS_CONTACT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_CONTACT_MANAGER))
#define MAIL_IS_CONTACT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_CONTACT_MANAGER))
#define MAIL_CONTACT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_CONTACT_MANAGER, MailContactManagerClass))

typedef struct _MailContactManager MailContactManager;
typedef struct _MailContactManagerClass MailContactManagerClass;
typedef struct _MailComposerRememberRecipientsData MailComposerRememberRecipientsData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block15Data Block15Data;
typedef struct _Block16Data Block16Data;
typedef struct _MailComposerSaveDraftData MailComposerSaveDraftData;
typedef struct _MailComposerAttachmentPrivate MailComposerAttachmentPrivate;
enum  {
	MAIL_COMPOSER_ATTACHMENT_0_PROPERTY,
	MAIL_COMPOSER_ATTACHMENT_FILE_PROPERTY,
	MAIL_COMPOSER_ATTACHMENT_DISPOSITION_PROPERTY,
	MAIL_COMPOSER_ATTACHMENT_CID_PROPERTY,
	MAIL_COMPOSER_ATTACHMENT_URI_PROPERTY,
	MAIL_COMPOSER_ATTACHMENT_NUM_PROPERTIES
};
static GParamSpec* mail_composer_attachment_properties[MAIL_COMPOSER_ATTACHMENT_NUM_PROPERTIES];

#define MAIL_COMPOSER_TYPE_ENTRY_GRID (mail_composer_entry_grid_get_type ())
#define MAIL_COMPOSER_ENTRY_GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_COMPOSER_TYPE_ENTRY_GRID, MailComposerEntryGrid))
#define MAIL_COMPOSER_ENTRY_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_COMPOSER_TYPE_ENTRY_GRID, MailComposerEntryGridClass))
#define MAIL_COMPOSER_IS_ENTRY_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_COMPOSER_TYPE_ENTRY_GRID))
#define MAIL_COMPOSER_IS_ENTRY_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_COMPOSER_TYPE_ENTRY_GRID))
#define MAIL_COMPOSER_ENTRY_GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_COMPOSER_TYPE_ENTRY_GRID, MailComposerEntryGridClass))

typedef struct _MailComposerEntryGrid MailComposerEntryGrid;
typedef struct _MailComposerEntryGridClass MailComposerEntryGridClass;
typedef struct _MailComposerEntryGridPrivate MailComposerEntryGridPrivate;
enum  {
	MAIL_COMPOSER_ENTRY_GRID_0_PROPERTY,
	MAIL_COMPOSER_ENTRY_GRID_NUM_PROPERTIES
};
static GParamSpec* mail_composer_entry_grid_properties[MAIL_COMPOSER_ENTRY_GRID_NUM_PROPERTIES];
typedef struct _Block17Data Block17Data;

#define MAIL_TYPE_MAIN_WINDOW (mail_main_window_get_type ())
#define MAIL_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_MAIN_WINDOW, MailMainWindow))
#define MAIL_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_MAIN_WINDOW, MailMainWindowClass))
#define MAIL_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_MAIN_WINDOW))
#define MAIL_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_MAIN_WINDOW))
#define MAIL_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_MAIN_WINDOW, MailMainWindowClass))

typedef struct _MailMainWindow MailMainWindow;
typedef struct _MailMainWindowClass MailMainWindowClass;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

#define TYPE_EDITOR_TOOLBAR (editor_toolbar_get_type ())
#define EDITOR_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EDITOR_TOOLBAR, EditorToolbar))
#define EDITOR_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EDITOR_TOOLBAR, EditorToolbarClass))
#define IS_EDITOR_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EDITOR_TOOLBAR))
#define IS_EDITOR_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EDITOR_TOOLBAR))
#define EDITOR_TOOLBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EDITOR_TOOLBAR, EditorToolbarClass))

typedef struct _EditorToolbar EditorToolbar;
typedef struct _EditorToolbarClass EditorToolbarClass;
enum  {
	MAIL_COMPOSER_FINISHED_SIGNAL,
	MAIL_COMPOSER_NUM_SIGNALS
};
static guint mail_composer_signals[MAIL_COMPOSER_NUM_SIGNALS] = {0};

struct _MailComposer {
	HdyApplicationWindow parent_instance;
	MailComposerPrivate * priv;
};

struct _MailComposerClass {
	HdyApplicationWindowClass parent_class;
};

struct _MailComposerPrivate {
	gboolean _has_recipients;
	gchar* _to;
	gchar* _mailto_query;
	gboolean discard_draft;
	CamelMessageInfo* ancestor_message_info;
	MailWebView* web_view;
	GtkEntry* to_val;
	GtkEntry* cc_val;
	GtkEntry* bcc_val;
	GtkFlowBox* attachment_box;
	GtkRevealer* cc_revealer;
	GtkRevealer* bcc_revealer;
	GtkToggleButton* cc_button;
	GraniteWidgetsOverlayBar* message_url_overlay;
	GtkComboBoxText* from_combo;
	GtkEntry* subject_val;
};

struct _Block4Data {
	int _ref_count_;
	MailComposer* self;
	GtkFileChooserNative* filechooser;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	MailComposerAttachment* attachment;
	gulong handler;
};

struct _Block6Data {
	int _ref_count_;
	Block4Data * _data4_;
	GraniteMessageDialog* error_dialog;
};

struct _Block7Data {
	int _ref_count_;
	MailComposer* self;
	gboolean found;
};

struct _Block8Data {
	int _ref_count_;
	Block7Data * _data7_;
	const gchar* address;
};

struct _Block9Data {
	int _ref_count_;
	Block7Data * _data7_;
	gchar* identity_address;
};

struct _MailComposerGetAttachmentsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailComposer* self;
	CamelDataWrapper* message_content;
	GFile* tmp_dir;
	CamelMultipart* content;
	guint i;
	gboolean _tmp0_;
	guint _tmp1_;
	CamelMultipart* _tmp2_;
	CamelMimePart* part;
	CamelMultipart* _tmp3_;
	CamelMimePart* _tmp4_;
	CamelContentType* field;
	CamelMimePart* _tmp5_;
	CamelContentType* _tmp6_;
	CamelMimePart* _tmp7_;
	CamelContentDisposition* _tmp8_;
	CamelMimePart* _tmp9_;
	CamelContentType* _tmp10_;
	GFile* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* file;
	GFile* _tmp15_;
	CamelMimePart* _tmp16_;
	const gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	GFileOutputStream* output_stream;
	GFile* _tmp20_;
	GFileOutputStream* _tmp21_;
	CamelMimePart* _tmp22_;
	CamelDataWrapper* _tmp23_;
	CamelDataWrapper* _tmp24_;
	GFileOutputStream* _tmp25_;
	GtkFlowBox* _tmp26_;
	GFile* _tmp27_;
	MailComposerAttachment* _tmp28_;
	MailComposerAttachment* _tmp29_;
	GtkFlowBox* _tmp30_;
	GError* e;
	GError* _tmp31_;
	const gchar* _tmp32_;
	CamelContentType* _tmp33_;
	const gchar* _tmp34_;
	CamelMimePart* _tmp35_;
	CamelDataWrapper* _tmp36_;
	CamelDataWrapper* _tmp37_;
	GError* _inner_error0_;
};

struct _Block10Data {
	int _ref_count_;
	MailComposer* self;
	GraniteMessageDialog* discard_dialog;
};

struct _Block11Data {
	int _ref_count_;
	MailComposer* self;
	gpointer _async_data_;
};

struct _Block12Data {
	int _ref_count_;
	Block11Data * _data11_;
	GraniteMessageDialog* no_subject_dialog;
};

struct _Block13Data {
	int _ref_count_;
	Block11Data * _data11_;
	GraniteMessageDialog* warning_dialog;
};

struct _Block14Data {
	int _ref_count_;
	Block11Data * _data11_;
	GraniteMessageDialog* error_dialog;
};

struct _MailComposerSendMessageData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailComposer* self;
	Block11Data* _data11_;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	Block12Data* _data12_;
	GraniteMessageDialog* _tmp3_;
	GraniteMessageDialog* _tmp4_;
	GraniteMessageDialog* _tmp5_;
	GraniteMessageDialog* _tmp6_;
	GtkWidget* send_anyway;
	GraniteMessageDialog* _tmp7_;
	GtkWidget* _tmp8_;
	GtkWidget* _tmp9_;
	GtkWidget* _tmp10_;
	GtkStyleContext* _tmp11_;
	GraniteMessageDialog* _tmp12_;
	GraniteMessageDialog* _tmp13_;
	MailBackendSession* session;
	MailBackendSession* _tmp14_;
	gchar* body_html;
	MailWebView* _tmp15_;
	gchar* _tmp16_;
	CamelMimeMessage* message;
	CamelMimeMessage* _tmp17_;
	CamelInternetAddress* sender;
	GtkComboBoxText* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	CamelInternetAddress* _tmp21_;
	CamelInternetAddress* _tmp22_;
	CamelInternetAddress* recipients;
	GtkEntry* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	GtkEntry* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	GtkEntry* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	CamelInternetAddress* _tmp32_;
	gboolean sent_message_saved;
	Block13Data* _data13_;
	GThemedIcon* _tmp33_;
	GThemedIcon* _tmp34_;
	GThemedIcon* _tmp35_;
	GraniteMessageDialog* _tmp36_;
	GraniteMessageDialog* _tmp37_;
	GraniteMessageDialog* _tmp38_;
	GraniteMessageDialog* _tmp39_;
	GError* e;
	Block14Data* _data14_;
	GThemedIcon* _tmp40_;
	GThemedIcon* _tmp41_;
	GThemedIcon* _tmp42_;
	GraniteMessageDialog* _tmp43_;
	GraniteMessageDialog* _tmp44_;
	GraniteMessageDialog* _tmp45_;
	GError* _tmp46_;
	const gchar* _tmp47_;
	GraniteMessageDialog* _tmp48_;
	GraniteMessageDialog* _tmp49_;
	GError* _inner_error1_;
	GError* _inner_error0_;
};

struct _MailComposerRememberRecipientsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailComposer* self;
	CamelInternetAddress* recipients;
	MailContactManager* contact_manager;
	MailContactManager* _tmp0_;
	MailContactManager* _tmp1_;
	gint i;
	gboolean _tmp2_;
	gint _tmp3_;
	gchar* name;
	gchar* address;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	MailContactManager* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
};

struct _Block15Data {
	int _ref_count_;
	MailComposer* self;
	MailBackendSession* session;
};

struct _Block16Data {
	int _ref_count_;
	MailComposer* self;
	GraniteMessageDialog* error_dialog;
};

struct _MailComposerSaveDraftData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailComposer* self;
	gboolean result;
	gboolean _tmp0_;
	MailWebView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* body_html;
	MailWebView* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	MailBackendSession* session;
	MailBackendSession* _tmp7_;
	CamelMimeMessage* message;
	const gchar* _tmp8_;
	CamelMimeMessage* _tmp9_;
	CamelInternetAddress* sender;
	CamelMimeMessage* _tmp10_;
	GtkComboBoxText* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	CamelInternetAddress* _tmp14_;
	CamelInternetAddress* _tmp15_;
	CamelInternetAddress* recipients;
	CamelMimeMessage* _tmp16_;
	GtkEntry* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GtkEntry* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GtkEntry* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	CamelInternetAddress* _tmp26_;
	MailBackendSession* _tmp27_;
	CamelMimeMessage* _tmp28_;
	CamelInternetAddress* _tmp29_;
	CamelInternetAddress* _tmp30_;
	CamelMessageInfo* _tmp31_;
	GError* e;
	Block16Data* _data16_;
	GThemedIcon* _tmp32_;
	GThemedIcon* _tmp33_;
	GThemedIcon* _tmp34_;
	GraniteMessageDialog* _tmp35_;
	GraniteMessageDialog* _tmp36_;
	GraniteMessageDialog* _tmp37_;
	GError* _tmp38_;
	const gchar* _tmp39_;
	GraniteMessageDialog* _tmp40_;
	GraniteMessageDialog* _tmp41_;
	GError* _inner_error0_;
};

struct _MailComposerAttachment {
	GtkFlowBoxChild parent_instance;
	MailComposerAttachmentPrivate * priv;
};

struct _MailComposerAttachmentClass {
	GtkFlowBoxChildClass parent_class;
};

struct _MailComposerAttachmentPrivate {
	GFile* _file;
	gchar* _disposition;
	gchar* _cid;
	gchar* _uri;
	GFileInfo* info;
};

struct _MailComposerEntryGrid {
	GtkGrid parent_instance;
	MailComposerEntryGridPrivate * priv;
};

struct _MailComposerEntryGridClass {
	GtkGridClass parent_class;
};

struct _Block17Data {
	int _ref_count_;
	MailComposer* self;
	GtkToggleButton* bcc_button;
	MailComposerEntryGrid* to_grid;
	GMenu* signature_menu;
};

static gint MailComposer_private_offset;
static gpointer mail_composer_parent_class = NULL;
static gint MailComposerAttachment_private_offset;
static gpointer mail_composer_attachment_parent_class = NULL;
static gpointer mail_composer_entry_grid_parent_class = NULL;

VALA_EXTERN GType mail_composer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailComposer, g_object_unref)
VALA_EXTERN GType mail_web_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailWebView, g_object_unref)
VALA_EXTERN GType mail_composer_type_get_type (void) G_GNUC_CONST ;
static void mail_composer_on_add_attachment (MailComposer* self);
static void _mail_composer_on_add_attachment_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void mail_composer_on_insert_image (MailComposer* self);
static void _mail_composer_on_insert_image_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void mail_composer_on_insert_signature (MailComposer* self,
                                        GAction* action,
                                        GVariant* parameter);
static void _mail_composer_on_insert_signature_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void mail_composer_on_discard (MailComposer* self);
static void _mail_composer_on_discard_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self);
static void mail_composer_on_send (MailComposer* self);
static void _mail_composer_on_send_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self);
VALA_EXTERN MailComposer* mail_composer_new (const gchar* to,
                                 const gchar* mailto_query);
VALA_EXTERN MailComposer* mail_composer_construct (GType object_type,
                                       const gchar* to,
                                       const gchar* mailto_query);
VALA_EXTERN MailComposer* mail_composer_new_with_quote (MailComposerType type,
                                            CamelMessageInfo* info,
                                            CamelMimeMessage* message,
                                            const gchar* content);
VALA_EXTERN MailComposer* mail_composer_construct_with_quote (GType object_type,
                                                  MailComposerType type,
                                                  CamelMessageInfo* info,
                                                  CamelMimeMessage* message,
                                                  const gchar* content);
VALA_EXTERN void mail_composer_quote_content (MailComposer* self,
                                  MailComposerType type,
                                  CamelMessageInfo* info,
                                  CamelMimeMessage* message,
                                  const gchar* content_to_quote);
static void mail_composer_on_sanitize_recipient_entry (MailComposer* self,
                                                GtkEntry* entry);
static MailComposerAttachment* mail_composer_attachment_new (GFile* file,
                                                      const gchar* disposition);
static MailComposerAttachment* mail_composer_attachment_construct (GType object_type,
                                                            GFile* file,
                                                            const gchar* disposition);
static GType mail_composer_attachment_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailComposerAttachment, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda87_ (Block4Data* _data4_,
                  gint response);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN void mail_web_view_add_internal_resource (MailWebView* self,
                                          const gchar* uri,
                                          GInputStream* data);
static const gchar* mail_composer_attachment_get_uri (MailComposerAttachment* self);
VALA_EXTERN void mail_web_view_execute_editor_command (MailWebView* self,
                                           const gchar* command,
                                           const gchar* argument);
static void ____lambda88_ (Block5Data* _data5_,
                    const gchar* uri);
static void _____lambda88__mail_web_view_image_removed (MailWebView* _sender,
                                                 const gchar* uri,
                                                 gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ____lambda89_ (Block6Data* _data6_);
static void _____lambda89__gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self);
static void ___lambda87__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                              gint response_id,
                                              gpointer self);
static void mail_composer_on_mouse_target_changed (MailComposer* self,
                                            WebKitWebView* web_view,
                                            WebKitHitTestResult* hit_test,
                                            guint mods);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean _____lambda98_ (Block8Data* _data8_,
                         GtkTreeModel* model,
                         GtkTreePath* path,
                         GtkTreeIter* iter);
static gboolean ______lambda98__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                      GtkTreePath* path,
                                                      GtkTreeIter* iter,
                                                      gpointer self);
VALA_EXTERN GType mail_backend_session_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailBackendSession, g_object_unref)
VALA_EXTERN MailBackendSession* mail_backend_session_get_default (void);
VALA_EXTERN ESource* mail_backend_session_ref_source (MailBackendSession* self,
                                          const gchar* source_uid);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gboolean ________lambda99_ (Block9Data* _data9_,
                            GtkTreeModel* model,
                            GtkTreePath* path,
                            GtkTreeIter* iter);
static gboolean _________lambda99__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                         GtkTreePath* path,
                                                         GtkTreeIter* iter,
                                                         gpointer self);
VALA_EXTERN void mail_web_view_set_content_of_element (MailWebView* self,
                                           const gchar* element,
                                           const gchar* content);
VALA_EXTERN gchar* mail_utils_get_reply_addresses (const gchar* raw_addresses,
                                       MailUtilsAcceptAddress should_add,
                                       gpointer should_add_target);
static gboolean ______lambda100_ (MailComposer* self,
                           const gchar* address);
static gboolean _______lambda100__mail_utils_accept_address (const gchar* address,
                                                      gpointer self);
static gboolean _______lambda101_ (MailComposer* self,
                            const gchar* address);
static gboolean ________lambda101__mail_utils_accept_address (const gchar* address,
                                                       gpointer self);
VALA_EXTERN gchar* mail_utils_escape_html_tags (const gchar* input);
static void mail_composer_get_attachments (MailComposer* self,
                                    CamelDataWrapper* message_content,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static void mail_composer_get_attachments_finish (MailComposer* self,
                                           GAsyncResult* _res_);
static void mail_composer_get_attachments_data_free (gpointer _data);
static gboolean mail_composer_get_attachments_co (MailComposerGetAttachmentsData* _data_);
static void mail_composer_get_attachments_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda91_ (Block10Data* _data10_,
                  gint response);
static void ___lambda91__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void mail_composer_send_message (MailComposer* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
static void mail_composer_send_message_finish (MailComposer* self,
                                        GAsyncResult* _res_);
static void mail_composer_send_message_data_free (gpointer _data);
static gboolean mail_composer_send_message_co (MailComposerSendMessageData* _data_);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void ___lambda92_ (Block12Data* _data12_,
                   gint response);
static void ____lambda92__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
VALA_EXTERN void mail_web_view_get_body_html (MailWebView* self,
                                  gboolean clean_for_sending,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
VALA_EXTERN gchar* mail_web_view_get_body_html_finish (MailWebView* self,
                                           GAsyncResult* _res_);
static void mail_composer_send_message_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static CamelMimeMessage* mail_composer_build_message (MailComposer* self,
                                               const gchar* body_html);
static CamelInternetAddress* mail_composer_build_sender (MailComposer* self,
                                                  CamelMimeMessage* message,
                                                  const gchar* from);
static CamelInternetAddress* mail_composer_build_recipients (MailComposer* self,
                                                      CamelMimeMessage* message,
                                                      const gchar* to,
                                                      const gchar* cc,
                                                      const gchar* bcc);
static void mail_composer_remember_recipients (MailComposer* self,
                                        CamelInternetAddress* recipients,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static void mail_composer_remember_recipients_finish (MailComposer* self,
                                               GAsyncResult* _res_);
VALA_EXTERN void mail_backend_session_send_email (MailBackendSession* self,
                                      CamelMimeMessage* message,
                                      CamelInternetAddress* from,
                                      CamelAddress* recipients,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gboolean mail_backend_session_send_email_finish (MailBackendSession* self,
                                                 GAsyncResult* _res_,
                                                 GError** error);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static void ____lambda96_ (Block13Data* _data13_);
static void _____lambda96__gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void ___lambda97_ (Block14Data* _data14_);
static void ____lambda97__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
static CamelMimePart* mail_composer_attachment_get_mime_part (MailComposerAttachment* self);
static void mail_composer_remember_recipients_data_free (gpointer _data);
static gboolean mail_composer_remember_recipients_co (MailComposerRememberRecipientsData* _data_);
VALA_EXTERN GType mail_contact_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailContactManager, g_object_unref)
VALA_EXTERN MailContactManager* mail_contact_manager_get_default (void);
VALA_EXTERN void mail_contact_manager_remember_mail_address (MailContactManager* self,
                                                 const gchar* address,
                                                 const gchar* name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
VALA_EXTERN void mail_contact_manager_remember_mail_address_finish (MailContactManager* self,
                                                        GAsyncResult* _res_);
static void mail_composer_remember_recipients_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void mail_composer_load_from_combobox (MailComposer* self);
VALA_EXTERN GeeArrayList* mail_backend_session_get_own_addresses (MailBackendSession* self);
static void mail_composer_populate_signature_menu (MailComposer* self,
                                            GMenu* menu);
static GVariant* _variant_new1 (const gchar* value);
VALA_EXTERN GList* mail_backend_session_get_all_signature_sources (MailBackendSession* self);
static GVariant* _variant_new2 (const gchar* value);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
VALA_EXTERN void mail_backend_session_get_signature_for_uid (MailBackendSession* self,
                                                 const gchar* uid,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
VALA_EXTERN gchar* mail_backend_session_get_signature_for_uid_finish (MailBackendSession* self,
                                                          GAsyncResult* _res_);
static void __lambda90_ (Block15Data* _data15_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda90__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void mail_composer_set_default_signature_for_sender (MailComposer* self);
VALA_EXTERN gchar* mail_backend_session_get_signature_uid_for_sender (MailBackendSession* self,
                                                          const gchar* sender);
static GVariant* _variant_new3 (gchar* value);
static void mail_composer_save_draft_data_free (gpointer _data);
VALA_EXTERN void mail_composer_save_draft (MailComposer* self,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN gboolean mail_composer_save_draft_finish (MailComposer* self,
                                          GAsyncResult* _res_);
static gboolean mail_composer_save_draft_co (MailComposerSaveDraftData* _data_);
VALA_EXTERN gboolean mail_web_view_get_body_html_changed (MailWebView* self);
static void mail_composer_save_draft_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
VALA_EXTERN void mail_backend_session_save_draft (MailBackendSession* self,
                                      CamelMimeMessage* message,
                                      CamelInternetAddress* from,
                                      CamelAddress* recipients,
                                      CamelMessageInfo* ancestor_message_info,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN void mail_backend_session_save_draft_finish (MailBackendSession* self,
                                             GAsyncResult* _res_,
                                             GError** error);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void ____lambda102_ (Block16Data* _data16_);
static void _____lambda102__gtk_dialog_response (GtkDialog* _sender,
                                          gint response_id,
                                          gpointer self);
VALA_EXTERN gboolean mail_composer_get_has_recipients (MailComposer* self);
VALA_EXTERN void mail_composer_set_has_recipients (MailComposer* self,
                                       gboolean value);
VALA_EXTERN const gchar* mail_composer_get_to (MailComposer* self);
static void mail_composer_set_to (MailComposer* self,
                           const gchar* value);
VALA_EXTERN const gchar* mail_composer_get_mailto_query (MailComposer* self);
static void mail_composer_set_mailto_query (MailComposer* self,
                                     const gchar* value);
static GFile* mail_composer_attachment_get_file (MailComposerAttachment* self);
static const gchar* mail_composer_attachment_get_cid (MailComposerAttachment* self);
static const gchar* mail_composer_attachment_get_disposition (MailComposerAttachment* self);
static void mail_composer_attachment_set_file (MailComposerAttachment* self,
                                        GFile* value);
static void mail_composer_attachment_set_disposition (MailComposerAttachment* self,
                                               const gchar* value);
static void mail_composer_attachment_set_cid (MailComposerAttachment* self,
                                       const gchar* value);
static void mail_composer_attachment_set_uri (MailComposerAttachment* self,
                                       const gchar* value);
static GObject * mail_composer_attachment_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _mail_composer_attachment___lambda86_ (MailComposerAttachment* self);
static void __mail_composer_attachment___lambda86__gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void mail_composer_attachment_finalize (GObject * obj);
static GType mail_composer_attachment_get_type_once (void);
static void _vala_mail_composer_attachment_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_mail_composer_attachment_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static GType mail_composer_entry_grid_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailComposerEntryGrid, g_object_unref)
static MailComposerEntryGrid* mail_composer_entry_grid_new (void);
static MailComposerEntryGrid* mail_composer_entry_grid_construct (GType object_type);
static GType mail_composer_entry_grid_get_type_once (void);
static GObject * mail_composer_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
VALA_EXTERN GType mail_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailMainWindow, g_object_unref)
static void _mail_composer___lambda103_ (MailComposer* self);
static void __mail_composer___lambda103__gtk_editable_changed (GtkEditable* _sender,
                                                        gpointer self);
VALA_EXTERN MailWebView* mail_web_view_new (void);
VALA_EXTERN MailWebView* mail_web_view_construct (GType object_type);
VALA_EXTERN void mail_web_view_load_html (MailWebView* self,
                              const gchar* body);
static void _mail_composer_on_mouse_target_changed_webkit_web_view_mouse_target_changed (WebKitWebView* _sender,
                                                                                  WebKitHitTestResult* hit_test_result,
                                                                                  guint modifiers,
                                                                                  gpointer self);
VALA_EXTERN GType editor_toolbar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditorToolbar, g_object_unref)
VALA_EXTERN EditorToolbar* editor_toolbar_new (MailWebView* web_view);
VALA_EXTERN EditorToolbar* editor_toolbar_construct (GType object_type,
                                         MailWebView* web_view);
static gboolean _mail_composer___lambda112_ (MailComposer* self);
static void __lambda113_ (MailComposer* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda113__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static gboolean __mail_composer___lambda112__gtk_widget_delete_event (GtkWidget* _sender,
                                                               GdkEventAny* event,
                                                               gpointer self);
VALA_EXTERN void mail_contact_manager_setup_entry (MailContactManager* self,
                                       GtkEntry* entry);
static void _mail_composer___lambda114_ (MailComposer* self);
static void __mail_composer___lambda114__gtk_combo_box_changed (GtkComboBox* _sender,
                                                         gpointer self);
static void _mail_composer___lambda115_ (MailComposer* self);
static void __mail_composer___lambda115__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void _mail_composer___lambda116_ (MailComposer* self);
static void __mail_composer___lambda116__gtk_editable_changed (GtkEditable* _sender,
                                                        gpointer self);
static void _mail_composer___lambda117_ (Block17Data* _data17_);
static void __mail_composer___lambda117__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void _mail_composer___lambda118_ (Block17Data* _data17_);
static void __mail_composer___lambda118__gtk_editable_changed (GtkEditable* _sender,
                                                        gpointer self);
static void _mail_composer___lambda119_ (MailComposer* self);
static void __mail_composer___lambda119__gtk_combo_box_changed (GtkComboBox* _sender,
                                                         gpointer self);
static void _mail_composer___lambda120_ (MailComposer* self);
static void __mail_composer___lambda120__gtk_editable_changed (GtkEditable* _sender,
                                                        gpointer self);
static void _mail_composer___lambda121_ (Block17Data* _data17_);
static void __mail_composer___lambda121__gtk_style_context_changed (GtkStyleContext* _sender,
                                                             gpointer self);
static void _mail_composer___lambda122_ (Block17Data* _data17_);
static void __mail_composer___lambda122__mail_backend_session_signature_changed (MailBackendSession* _sender,
                                                                          gpointer self);
static void mail_composer_finalize (GObject * obj);
static GType mail_composer_get_type_once (void);
static void _vala_mail_composer_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_mail_composer_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GActionEntry MAIL_COMPOSER_ACTION_ENTRIES[5] = {{MAIL_COMPOSER_ACTION_ADD_ATTACHMENT, _mail_composer_on_add_attachment_gsimple_action_activate_callback}, {MAIL_COMPOSER_ACTION_INSERT_IMAGE, _mail_composer_on_insert_image_gsimple_action_activate_callback}, {MAIL_COMPOSER_ACTION_INSERT_SIGNATURE, _mail_composer_on_insert_signature_gsimple_action_activate_callback, "s"}, {MAIL_COMPOSER_ACTION_DISCARD, _mail_composer_on_discard_gsimple_action_activate_callback}, {MAIL_COMPOSER_ACTION_SEND, _mail_composer_on_send_gsimple_action_activate_callback}};

static inline gpointer
mail_composer_get_instance_private (MailComposer* self)
{
	return G_STRUCT_MEMBER_P (self, MailComposer_private_offset);
}

static GType
mail_composer_type_get_type_once (void)
{
	static const GEnumValue values[] = {{MAIL_COMPOSER_TYPE_REPLY, "MAIL_COMPOSER_TYPE_REPLY", "reply"}, {MAIL_COMPOSER_TYPE_REPLY_ALL, "MAIL_COMPOSER_TYPE_REPLY_ALL", "reply-all"}, {MAIL_COMPOSER_TYPE_FORWARD, "MAIL_COMPOSER_TYPE_FORWARD", "forward"}, {MAIL_COMPOSER_TYPE_DRAFT, "MAIL_COMPOSER_TYPE_DRAFT", "draft"}, {0, NULL, NULL}};
	GType mail_composer_type_type_id;
	mail_composer_type_type_id = g_enum_register_static ("MailComposerType", values);
	return mail_composer_type_type_id;
}

GType
mail_composer_type_get_type (void)
{
	static volatile gsize mail_composer_type_type_id__once = 0;
	if (g_once_init_enter (&mail_composer_type_type_id__once)) {
		GType mail_composer_type_type_id;
		mail_composer_type_type_id = mail_composer_type_get_type_once ();
		g_once_init_leave (&mail_composer_type_type_id__once, mail_composer_type_type_id);
	}
	return mail_composer_type_type_id__once;
}

static void
_mail_composer_on_add_attachment_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 46 "../src/Composer.vala"
	mail_composer_on_add_attachment ((MailComposer*) self);
#line 999 "Composer.c"
}

static void
_mail_composer_on_insert_image_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 46 "../src/Composer.vala"
	mail_composer_on_insert_image ((MailComposer*) self);
#line 1009 "Composer.c"
}

static void
_mail_composer_on_insert_signature_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 46 "../src/Composer.vala"
	mail_composer_on_insert_signature ((MailComposer*) self, action, parameter);
#line 1019 "Composer.c"
}

static void
_mail_composer_on_discard_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self)
{
#line 46 "../src/Composer.vala"
	mail_composer_on_discard ((MailComposer*) self);
#line 1029 "Composer.c"
}

static void
_mail_composer_on_send_gsimple_action_activate_callback (GSimpleAction* action,
                                                         GVariant* parameter,
                                                         gpointer self)
{
#line 46 "../src/Composer.vala"
	mail_composer_on_send ((MailComposer*) self);
#line 1039 "Composer.c"
}

MailComposer*
mail_composer_construct (GType object_type,
                         const gchar* to,
                         const gchar* mailto_query)
{
	MailComposer * self = NULL;
#line 55 "../src/Composer.vala"
	self = (MailComposer*) g_object_new (object_type, "to", to, "mailto-query", mailto_query, NULL);
#line 54 "../src/Composer.vala"
	return self;
#line 1052 "Composer.c"
}

MailComposer*
mail_composer_new (const gchar* to,
                   const gchar* mailto_query)
{
#line 54 "../src/Composer.vala"
	return mail_composer_construct (MAIL_TYPE_COMPOSER, to, mailto_query);
#line 1061 "Composer.c"
}

MailComposer*
mail_composer_construct_with_quote (GType object_type,
                                    MailComposerType type,
                                    CamelMessageInfo* info,
                                    CamelMimeMessage* message,
                                    const gchar* content)
{
	MailComposer * self = NULL;
#line 61 "../src/Composer.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 61 "../src/Composer.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 62 "../src/Composer.vala"
	self = (MailComposer*) g_object_new (object_type, "has-recipients", TRUE, NULL);
#line 63 "../src/Composer.vala"
	mail_composer_quote_content (self, type, info, message, content);
#line 61 "../src/Composer.vala"
	return self;
#line 1082 "Composer.c"
}

MailComposer*
mail_composer_new_with_quote (MailComposerType type,
                              CamelMessageInfo* info,
                              CamelMimeMessage* message,
                              const gchar* content)
{
#line 61 "../src/Composer.vala"
	return mail_composer_construct_with_quote (MAIL_TYPE_COMPOSER, type, info, message, content);
#line 1093 "Composer.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1112 "Composer.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1134 "Composer.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1138 "Composer.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1144 "Composer.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1148 "Composer.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1152 "Composer.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1160 "Composer.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1188 "Composer.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1197 "Composer.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1211 "Composer.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1220 "Composer.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1234 "Composer.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1243 "Composer.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1252 "Composer.c"
}

static void
mail_composer_on_sanitize_recipient_entry (MailComposer* self,
                                           GtkEntry* entry)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 426 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 426 "../src/Composer.vala"
	g_return_if_fail (entry != NULL);
#line 427 "../src/Composer.vala"
	_tmp0_ = gtk_entry_get_text (entry);
#line 427 "../src/Composer.vala"
	_tmp1_ = _tmp0_;
#line 427 "../src/Composer.vala"
	if (g_strcmp0 (_tmp1_, "") == 0) {
#line 428 "../src/Composer.vala"
		return;
#line 1277 "Composer.c"
	}
#line 431 "../src/Composer.vala"
	_tmp2_ = gtk_entry_get_text (entry);
#line 431 "../src/Composer.vala"
	_tmp3_ = _tmp2_;
#line 431 "../src/Composer.vala"
	if (string_contains (_tmp3_, "\n")) {
#line 1285 "Composer.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 432 "../src/Composer.vala"
		_tmp4_ = gtk_entry_get_text (entry);
#line 432 "../src/Composer.vala"
		_tmp5_ = _tmp4_;
#line 432 "../src/Composer.vala"
		_tmp6_ = string_replace (_tmp5_, "\n", ", ");
#line 432 "../src/Composer.vala"
		_tmp7_ = _tmp6_;
#line 432 "../src/Composer.vala"
		gtk_entry_set_text (entry, _tmp7_);
#line 432 "../src/Composer.vala"
		_g_free0 (_tmp7_);
#line 1302 "Composer.c"
	}
#line 435 "../src/Composer.vala"
	_tmp8_ = gtk_entry_get_text (entry);
#line 435 "../src/Composer.vala"
	_tmp9_ = _tmp8_;
#line 435 "../src/Composer.vala"
	if (string_contains (_tmp9_, "\r")) {
#line 1310 "Composer.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 436 "../src/Composer.vala"
		_tmp10_ = gtk_entry_get_text (entry);
#line 436 "../src/Composer.vala"
		_tmp11_ = _tmp10_;
#line 436 "../src/Composer.vala"
		_tmp12_ = string_replace (_tmp11_, "\r", ", ");
#line 436 "../src/Composer.vala"
		_tmp13_ = _tmp12_;
#line 436 "../src/Composer.vala"
		gtk_entry_set_text (entry, _tmp13_);
#line 436 "../src/Composer.vala"
		_g_free0 (_tmp13_);
#line 1327 "Composer.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 451 "../src/Composer.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1336 "Composer.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 451 "../src/Composer.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1344 "Composer.c"
}

static void
mail_composer_on_add_attachment (MailComposer* self)
{
	GtkFileChooserNative* filechooser = NULL;
	GtkWidget* _tmp0_;
	GtkFileChooserNative* _tmp1_;
	GtkFileChooserNative* _tmp2_;
	GtkFileChooserNative* _tmp11_;
#line 440 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 441 "../src/Composer.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 441 "../src/Composer.vala"
	_tmp1_ = gtk_file_chooser_native_new (_ ("Choose a file"), G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow), GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Attach"), _ ("Cancel"));
#line 441 "../src/Composer.vala"
	filechooser = _tmp1_;
#line 449 "../src/Composer.vala"
	_tmp2_ = filechooser;
#line 449 "../src/Composer.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp2_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1367 "Composer.c"
		GtkFileChooserNative* _tmp3_;
		GtkFileChooserNative* _tmp4_;
		GSList* _tmp5_;
		GtkFlowBox* _tmp10_;
#line 450 "../src/Composer.vala"
		_tmp3_ = filechooser;
#line 450 "../src/Composer.vala"
		gtk_native_dialog_hide ((GtkNativeDialog*) _tmp3_);
#line 451 "../src/Composer.vala"
		_tmp4_ = filechooser;
#line 451 "../src/Composer.vala"
		_tmp5_ = gtk_file_chooser_get_files ((GtkFileChooser*) _tmp4_);
#line 1380 "Composer.c"
		{
			GSList* file_collection = NULL;
			GSList* file_it = NULL;
#line 451 "../src/Composer.vala"
			file_collection = _tmp5_;
#line 451 "../src/Composer.vala"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 1388 "Composer.c"
				GFile* file = NULL;
#line 451 "../src/Composer.vala"
				file = (GFile*) file_it->data;
#line 1392 "Composer.c"
				{
					GtkFlowBox* _tmp6_;
					GFile* _tmp7_;
					MailComposerAttachment* _tmp8_;
					MailComposerAttachment* _tmp9_;
#line 452 "../src/Composer.vala"
					_tmp6_ = self->priv->attachment_box;
#line 452 "../src/Composer.vala"
					_tmp7_ = file;
#line 452 "../src/Composer.vala"
					_tmp8_ = mail_composer_attachment_new (_tmp7_, MAIL_COMPOSER_ATTACHMENT_DISPOSITION_ATTACHMENT);
#line 452 "../src/Composer.vala"
					g_object_ref_sink (_tmp8_);
#line 452 "../src/Composer.vala"
					_tmp9_ = _tmp8_;
#line 452 "../src/Composer.vala"
					gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp9_);
#line 452 "../src/Composer.vala"
					_g_object_unref0 (_tmp9_);
#line 1412 "Composer.c"
				}
			}
#line 451 "../src/Composer.vala"
			(file_collection == NULL) ? NULL : (file_collection = (_g_slist_free__g_object_unref0_ (file_collection), NULL));
#line 1417 "Composer.c"
		}
#line 454 "../src/Composer.vala"
		_tmp10_ = self->priv->attachment_box;
#line 454 "../src/Composer.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 1423 "Composer.c"
	}
#line 457 "../src/Composer.vala"
	_tmp11_ = filechooser;
#line 457 "../src/Composer.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp11_);
#line 440 "../src/Composer.vala"
	_g_object_unref0 (filechooser);
#line 1431 "Composer.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 460 "../src/Composer.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 460 "../src/Composer.vala"
	return _data4_;
#line 1441 "Composer.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 460 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1451 "Composer.c"
		MailComposer* self;
#line 460 "../src/Composer.vala"
		self = _data4_->self;
#line 460 "../src/Composer.vala"
		_g_object_unref0 (_data4_->filechooser);
#line 460 "../src/Composer.vala"
		_g_object_unref0 (self);
#line 460 "../src/Composer.vala"
		g_slice_free (Block4Data, _data4_);
#line 1461 "Composer.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 465 "../src/Composer.vala"
	return self ? g_object_ref (self) : NULL;
#line 1470 "Composer.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 480 "../src/Composer.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 480 "../src/Composer.vala"
	return _data5_;
#line 1480 "Composer.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 480 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1490 "Composer.c"
		MailComposer* self;
#line 480 "../src/Composer.vala"
		self = _data5_->_data4_->self;
#line 480 "../src/Composer.vala"
		_g_object_unref0 (_data5_->attachment);
#line 480 "../src/Composer.vala"
		block4_data_unref (_data5_->_data4_);
#line 480 "../src/Composer.vala"
		_data5_->_data4_ = NULL;
#line 480 "../src/Composer.vala"
		g_slice_free (Block5Data, _data5_);
#line 1502 "Composer.c"
	}
}

static void
____lambda88_ (Block5Data* _data5_,
               const gchar* uri)
{
	Block4Data* _data4_;
	MailComposer* self;
	MailComposerAttachment* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 490 "../src/Composer.vala"
	_data4_ = _data5_->_data4_;
#line 490 "../src/Composer.vala"
	self = _data4_->self;
#line 490 "../src/Composer.vala"
	g_return_if_fail (uri != NULL);
#line 491 "../src/Composer.vala"
	_tmp0_ = _data5_->attachment;
#line 491 "../src/Composer.vala"
	_tmp1_ = mail_composer_attachment_get_uri (_tmp0_);
#line 491 "../src/Composer.vala"
	_tmp2_ = _tmp1_;
#line 491 "../src/Composer.vala"
	if (g_strcmp0 (uri, _tmp2_) == 0) {
#line 1529 "Composer.c"
		MailComposerAttachment* _tmp3_;
		MailWebView* _tmp4_;
#line 492 "../src/Composer.vala"
		_tmp3_ = _data5_->attachment;
#line 492 "../src/Composer.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp3_);
#line 493 "../src/Composer.vala"
		_tmp4_ = self->priv->web_view;
#line 493 "../src/Composer.vala"
		g_signal_handler_disconnect ((GObject*) _tmp4_, _data5_->handler);
#line 1540 "Composer.c"
	}
}

static void
_____lambda88__mail_web_view_image_removed (MailWebView* _sender,
                                            const gchar* uri,
                                            gpointer self)
{
#line 490 "../src/Composer.vala"
	____lambda88_ (self, uri);
#line 1551 "Composer.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 480 "../src/Composer.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 480 "../src/Composer.vala"
	return _data6_;
#line 1561 "Composer.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 480 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 1571 "Composer.c"
		MailComposer* self;
#line 480 "../src/Composer.vala"
		self = _data6_->_data4_->self;
#line 480 "../src/Composer.vala"
		_g_object_unref0 (_data6_->error_dialog);
#line 480 "../src/Composer.vala"
		block4_data_unref (_data6_->_data4_);
#line 480 "../src/Composer.vala"
		_data6_->_data4_ = NULL;
#line 480 "../src/Composer.vala"
		g_slice_free (Block6Data, _data6_);
#line 1583 "Composer.c"
	}
}

static void
____lambda89_ (Block6Data* _data6_)
{
	Block4Data* _data4_;
	MailComposer* self;
	GraniteMessageDialog* _tmp0_;
#line 507 "../src/Composer.vala"
	_data4_ = _data6_->_data4_;
#line 507 "../src/Composer.vala"
	self = _data4_->self;
#line 507 "../src/Composer.vala"
	_tmp0_ = _data6_->error_dialog;
#line 507 "../src/Composer.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 1601 "Composer.c"
}

static void
_____lambda89__gtk_dialog_response (GtkDialog* _sender,
                                    gint response_id,
                                    gpointer self)
{
#line 507 "../src/Composer.vala"
	____lambda89_ (self);
#line 1611 "Composer.c"
}

static void
__lambda87_ (Block4Data* _data4_,
             gint response)
{
	MailComposer* self;
	GError* _inner_error0_ = NULL;
#line 476 "../src/Composer.vala"
	self = _data4_->self;
#line 477 "../src/Composer.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1624 "Composer.c"
		GFile* file = NULL;
		GFile* _tmp0_;
#line 478 "../src/Composer.vala"
		_tmp0_ = gtk_file_chooser_get_file ((GtkFileChooser*) _data4_->filechooser);
#line 478 "../src/Composer.vala"
		file = _tmp0_;
#line 1631 "Composer.c"
		{
			Block5Data* _data5_;
			GFileInputStream* inpustream = NULL;
			GFile* _tmp1_;
			GFileInputStream* _tmp2_;
			GFile* _tmp3_;
			MailComposerAttachment* _tmp4_;
			GtkFlowBox* _tmp5_;
			MailComposerAttachment* _tmp6_;
			MailWebView* _tmp7_;
			MailComposerAttachment* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			GFileInputStream* _tmp11_;
			MailWebView* _tmp12_;
			MailComposerAttachment* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			MailWebView* _tmp16_;
			gulong _tmp17_;
#line 480 "../src/Composer.vala"
			_data5_ = g_slice_new0 (Block5Data);
#line 480 "../src/Composer.vala"
			_data5_->_ref_count_ = 1;
#line 480 "../src/Composer.vala"
			_data5_->_data4_ = block4_data_ref (_data4_);
#line 481 "../src/Composer.vala"
			_tmp1_ = file;
#line 481 "../src/Composer.vala"
			_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
#line 481 "../src/Composer.vala"
			inpustream = _tmp2_;
#line 481 "../src/Composer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "../src/Composer.vala"
				block5_data_unref (_data5_);
#line 481 "../src/Composer.vala"
				_data5_ = NULL;
#line 1670 "Composer.c"
				goto __catch0_g_error;
			}
#line 483 "../src/Composer.vala"
			_tmp3_ = file;
#line 483 "../src/Composer.vala"
			_tmp4_ = mail_composer_attachment_new (_tmp3_, MAIL_COMPOSER_ATTACHMENT_DISPOSITION_INLINE);
#line 483 "../src/Composer.vala"
			g_object_ref_sink (_tmp4_);
#line 483 "../src/Composer.vala"
			_data5_->attachment = _tmp4_;
#line 484 "../src/Composer.vala"
			_tmp5_ = self->priv->attachment_box;
#line 484 "../src/Composer.vala"
			_tmp6_ = _data5_->attachment;
#line 484 "../src/Composer.vala"
			gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 486 "../src/Composer.vala"
			_tmp7_ = self->priv->web_view;
#line 486 "../src/Composer.vala"
			_tmp8_ = _data5_->attachment;
#line 486 "../src/Composer.vala"
			_tmp9_ = mail_composer_attachment_get_uri (_tmp8_);
#line 486 "../src/Composer.vala"
			_tmp10_ = _tmp9_;
#line 486 "../src/Composer.vala"
			_tmp11_ = inpustream;
#line 486 "../src/Composer.vala"
			mail_web_view_add_internal_resource (_tmp7_, _tmp10_, (GInputStream*) _tmp11_);
#line 487 "../src/Composer.vala"
			_tmp12_ = self->priv->web_view;
#line 487 "../src/Composer.vala"
			_tmp13_ = _data5_->attachment;
#line 487 "../src/Composer.vala"
			_tmp14_ = mail_composer_attachment_get_uri (_tmp13_);
#line 487 "../src/Composer.vala"
			_tmp15_ = _tmp14_;
#line 487 "../src/Composer.vala"
			mail_web_view_execute_editor_command (_tmp12_, "insertImage", _tmp15_);
#line 489 "../src/Composer.vala"
			_data5_->handler = (gulong) 0;
#line 490 "../src/Composer.vala"
			_tmp16_ = self->priv->web_view;
#line 490 "../src/Composer.vala"
			_tmp17_ = g_signal_connect_data (_tmp16_, "image-removed", (GCallback) _____lambda88__mail_web_view_image_removed, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 490 "../src/Composer.vala"
			_data5_->handler = _tmp17_;
#line 480 "../src/Composer.vala"
			_g_object_unref0 (inpustream);
#line 480 "../src/Composer.vala"
			block5_data_unref (_data5_);
#line 480 "../src/Composer.vala"
			_data5_ = NULL;
#line 1723 "Composer.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			Block6Data* _data6_;
			GThemedIcon* _tmp18_;
			GThemedIcon* _tmp19_;
			GThemedIcon* _tmp20_;
			GraniteMessageDialog* _tmp21_ = NULL;
			GraniteMessageDialog* _tmp22_;
			GraniteMessageDialog* _tmp23_;
			GError* _tmp24_;
			const gchar* _tmp25_;
			GraniteMessageDialog* _tmp26_;
			GraniteMessageDialog* _tmp27_;
#line 480 "../src/Composer.vala"
			e = _inner_error0_;
#line 480 "../src/Composer.vala"
			_inner_error0_ = NULL;
#line 480 "../src/Composer.vala"
			_data6_ = g_slice_new0 (Block6Data);
#line 480 "../src/Composer.vala"
			_data6_->_ref_count_ = 1;
#line 480 "../src/Composer.vala"
			_data6_->_data4_ = block4_data_ref (_data4_);
#line 497 "../src/Composer.vala"
			_tmp18_ = (GThemedIcon*) g_themed_icon_new ("insert-image");
#line 497 "../src/Composer.vala"
			_tmp19_ = _tmp18_;
#line 497 "../src/Composer.vala"
			_tmp20_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 497 "../src/Composer.vala"
			_tmp21_ = granite_message_dialog_new (_ ("Unable to insert image"), _ ("There was an unexpected error while trying to insert the image."), (GIcon*) _tmp19_, GTK_BUTTONS_CLOSE);
#line 497 "../src/Composer.vala"
			granite_message_dialog_set_badge_icon (_tmp21_, (GIcon*) _tmp20_);
#line 497 "../src/Composer.vala"
			_g_object_unref0 (_tmp20_);
#line 497 "../src/Composer.vala"
			g_object_ref_sink (_tmp21_);
#line 497 "../src/Composer.vala"
			_tmp22_ = _tmp21_;
#line 497 "../src/Composer.vala"
			_g_object_unref0 (_tmp19_);
#line 497 "../src/Composer.vala"
			_data6_->error_dialog = _tmp22_;
#line 505 "../src/Composer.vala"
			_tmp23_ = _data6_->error_dialog;
#line 505 "../src/Composer.vala"
			_tmp24_ = e;
#line 505 "../src/Composer.vala"
			_tmp25_ = _tmp24_->message;
#line 505 "../src/Composer.vala"
			granite_message_dialog_show_error_details (_tmp23_, _tmp25_);
#line 506 "../src/Composer.vala"
			_tmp26_ = _data6_->error_dialog;
#line 506 "../src/Composer.vala"
			gtk_window_present ((GtkWindow*) _tmp26_);
#line 507 "../src/Composer.vala"
			_tmp27_ = _data6_->error_dialog;
#line 507 "../src/Composer.vala"
			g_signal_connect_data ((GtkDialog*) _tmp27_, "response", (GCallback) _____lambda89__gtk_dialog_response, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 480 "../src/Composer.vala"
			_g_error_free0 (e);
#line 480 "../src/Composer.vala"
			block6_data_unref (_data6_);
#line 480 "../src/Composer.vala"
			_data6_ = NULL;
#line 1792 "Composer.c"
		}
		__finally0:
#line 480 "../src/Composer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 480 "../src/Composer.vala"
			_g_object_unref0 (file);
#line 480 "../src/Composer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 480 "../src/Composer.vala"
			g_clear_error (&_inner_error0_);
#line 480 "../src/Composer.vala"
			return;
#line 1805 "Composer.c"
		}
#line 477 "../src/Composer.vala"
		_g_object_unref0 (file);
#line 1809 "Composer.c"
	}
#line 511 "../src/Composer.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _data4_->filechooser);
#line 1813 "Composer.c"
}

static void
___lambda87__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
#line 476 "../src/Composer.vala"
	__lambda87_ (self, response_id);
#line 1823 "Composer.c"
}

static void
mail_composer_on_insert_image (MailComposer* self)
{
	Block4Data* _data4_;
	GtkFileFilter* image_filter = NULL;
	GtkFileFilter* _tmp0_;
	GtkWidget* _tmp1_;
	GtkFileFilter* _tmp2_;
	GtkFileChooserNative* _tmp3_ = NULL;
#line 460 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 460 "../src/Composer.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 460 "../src/Composer.vala"
	_data4_->_ref_count_ = 1;
#line 460 "../src/Composer.vala"
	_data4_->self = g_object_ref (self);
#line 461 "../src/Composer.vala"
	_tmp0_ = gtk_file_filter_new ();
#line 461 "../src/Composer.vala"
	g_object_ref_sink (_tmp0_);
#line 461 "../src/Composer.vala"
	image_filter = _tmp0_;
#line 462 "../src/Composer.vala"
	gtk_file_filter_set_name (image_filter, _ ("Images"));
#line 463 "../src/Composer.vala"
	gtk_file_filter_add_mime_type (image_filter, "image/*");
#line 465 "../src/Composer.vala"
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 465 "../src/Composer.vala"
	_tmp2_ = _g_object_ref0 (image_filter);
#line 465 "../src/Composer.vala"
	_tmp3_ = gtk_file_chooser_native_new (_ ("Choose an image"), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow), GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Insert"), _ ("Cancel"));
#line 465 "../src/Composer.vala"
	gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp3_, _tmp2_);
#line 465 "../src/Composer.vala"
	_g_object_unref0 (_tmp2_);
#line 465 "../src/Composer.vala"
	gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _tmp3_, FALSE);
#line 465 "../src/Composer.vala"
	_data4_->filechooser = _tmp3_;
#line 476 "../src/Composer.vala"
	g_signal_connect_data ((GtkNativeDialog*) _data4_->filechooser, "response", (GCallback) ___lambda87__gtk_native_dialog_response, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 514 "../src/Composer.vala"
	gtk_native_dialog_show ((GtkNativeDialog*) _data4_->filechooser);
#line 460 "../src/Composer.vala"
	_g_object_unref0 (image_filter);
#line 460 "../src/Composer.vala"
	block4_data_unref (_data4_);
#line 460 "../src/Composer.vala"
	_data4_ = NULL;
#line 1877 "Composer.c"
}

static void
mail_composer_on_mouse_target_changed (MailComposer* self,
                                       WebKitWebView* web_view,
                                       WebKitHitTestResult* hit_test,
                                       guint mods)
{
#line 517 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 517 "../src/Composer.vala"
	g_return_if_fail (web_view != NULL);
#line 517 "../src/Composer.vala"
	g_return_if_fail (hit_test != NULL);
#line 518 "../src/Composer.vala"
	if (webkit_hit_test_result_context_is_link (hit_test)) {
#line 1894 "Composer.c"
		gchar* url = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
		const gchar* _tmp3_;
		gchar* hover_url = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 519 "../src/Composer.vala"
		_tmp0_ = webkit_hit_test_result_get_link_uri (hit_test);
#line 519 "../src/Composer.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 519 "../src/Composer.vala"
		url = _tmp1_;
#line 521 "../src/Composer.vala"
		_tmp3_ = url;
#line 521 "../src/Composer.vala"
		if (_tmp3_ != NULL) {
#line 1913 "Composer.c"
			const gchar* _tmp4_;
			gchar* _tmp5_;
#line 521 "../src/Composer.vala"
			_tmp4_ = url;
#line 521 "../src/Composer.vala"
			_tmp5_ = g_uri_unescape_string (_tmp4_, NULL);
#line 521 "../src/Composer.vala"
			_g_free0 (_tmp2_);
#line 521 "../src/Composer.vala"
			_tmp2_ = _tmp5_;
#line 1924 "Composer.c"
		} else {
#line 521 "../src/Composer.vala"
			_g_free0 (_tmp2_);
#line 521 "../src/Composer.vala"
			_tmp2_ = NULL;
#line 1930 "Composer.c"
		}
#line 521 "../src/Composer.vala"
		_tmp6_ = g_strdup (_tmp2_);
#line 521 "../src/Composer.vala"
		hover_url = _tmp6_;
#line 526 "../src/Composer.vala"
		_tmp7_ = hover_url;
#line 526 "../src/Composer.vala"
		if (_tmp7_ == NULL) {
#line 1940 "Composer.c"
			GraniteWidgetsOverlayBar* _tmp8_;
#line 527 "../src/Composer.vala"
			_tmp8_ = self->priv->message_url_overlay;
#line 527 "../src/Composer.vala"
			gtk_widget_hide ((GtkWidget*) _tmp8_);
#line 1946 "Composer.c"
		} else {
			GraniteWidgetsOverlayBar* _tmp9_;
			const gchar* _tmp10_;
			GraniteWidgetsOverlayBar* _tmp11_;
			GraniteWidgetsOverlayBar* _tmp12_;
#line 529 "../src/Composer.vala"
			_tmp9_ = self->priv->message_url_overlay;
#line 529 "../src/Composer.vala"
			_tmp10_ = hover_url;
#line 529 "../src/Composer.vala"
			granite_widgets_overlay_bar_set_label (_tmp9_, _tmp10_);
#line 530 "../src/Composer.vala"
			_tmp11_ = self->priv->message_url_overlay;
#line 530 "../src/Composer.vala"
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp11_, FALSE);
#line 531 "../src/Composer.vala"
			_tmp12_ = self->priv->message_url_overlay;
#line 531 "../src/Composer.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp12_);
#line 1966 "Composer.c"
		}
#line 518 "../src/Composer.vala"
		_g_free0 (hover_url);
#line 518 "../src/Composer.vala"
		_g_free0 (_tmp2_);
#line 518 "../src/Composer.vala"
		_g_free0 (url);
#line 1974 "Composer.c"
	} else {
		GraniteWidgetsOverlayBar* _tmp13_;
#line 534 "../src/Composer.vala"
		_tmp13_ = self->priv->message_url_overlay;
#line 534 "../src/Composer.vala"
		gtk_widget_hide ((GtkWidget*) _tmp13_);
#line 1981 "Composer.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 553 "../src/Composer.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 553 "../src/Composer.vala"
	return _data7_;
#line 1992 "Composer.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 553 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2002 "Composer.c"
		MailComposer* self;
#line 553 "../src/Composer.vala"
		self = _data7_->self;
#line 553 "../src/Composer.vala"
		_g_object_unref0 (self);
#line 553 "../src/Composer.vala"
		g_slice_free (Block7Data, _data7_);
#line 2010 "Composer.c"
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 556 "../src/Composer.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 556 "../src/Composer.vala"
	return _data8_;
#line 2021 "Composer.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 556 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 2031 "Composer.c"
		MailComposer* self;
#line 556 "../src/Composer.vala"
		self = _data8_->_data7_->self;
#line 556 "../src/Composer.vala"
		block7_data_unref (_data8_->_data7_);
#line 556 "../src/Composer.vala"
		_data8_->_data7_ = NULL;
#line 556 "../src/Composer.vala"
		g_slice_free (Block8Data, _data8_);
#line 2041 "Composer.c"
	}
}

static gboolean
_____lambda98_ (Block8Data* _data8_,
                GtkTreeModel* model,
                GtkTreePath* path,
                GtkTreeIter* iter)
{
	Block7Data* _data7_;
	MailComposer* self;
	GValue value = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean result;
#line 578 "../src/Composer.vala"
	_data7_ = _data8_->_data7_;
#line 578 "../src/Composer.vala"
	self = _data7_->self;
#line 578 "../src/Composer.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 578 "../src/Composer.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 578 "../src/Composer.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 580 "../src/Composer.vala"
	_tmp0_ = *iter;
#line 580 "../src/Composer.vala"
	gtk_tree_model_get_value (model, &_tmp0_, 0, &_tmp1_);
#line 580 "../src/Composer.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 580 "../src/Composer.vala"
	value = _tmp1_;
#line 582 "../src/Composer.vala"
	_tmp2_ = g_value_get_string (&value);
#line 582 "../src/Composer.vala"
	_tmp3_ = _data8_->address;
#line 582 "../src/Composer.vala"
	if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 2083 "Composer.c"
		GtkComboBoxText* _tmp4_;
		GtkTreeIter _tmp5_;
#line 583 "../src/Composer.vala"
		_tmp4_ = self->priv->from_combo;
#line 583 "../src/Composer.vala"
		_tmp5_ = *iter;
#line 583 "../src/Composer.vala"
		gtk_combo_box_set_active_iter ((GtkComboBox*) _tmp4_, &_tmp5_);
#line 584 "../src/Composer.vala"
		_data7_->found = TRUE;
#line 585 "../src/Composer.vala"
		result = TRUE;
#line 585 "../src/Composer.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 585 "../src/Composer.vala"
		return result;
#line 2100 "Composer.c"
	}
#line 588 "../src/Composer.vala"
	result = FALSE;
#line 588 "../src/Composer.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 588 "../src/Composer.vala"
	return result;
#line 2108 "Composer.c"
}

static gboolean
______lambda98__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                             GtkTreePath* path,
                                             GtkTreeIter* iter,
                                             gpointer self)
{
	gboolean result;
	result = _____lambda98_ (self, model, path, iter);
#line 578 "../src/Composer.vala"
	return result;
#line 2121 "Composer.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 607 "../src/Composer.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 607 "../src/Composer.vala"
	return _data9_;
#line 2131 "Composer.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 607 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 2141 "Composer.c"
		MailComposer* self;
#line 607 "../src/Composer.vala"
		self = _data9_->_data7_->self;
#line 607 "../src/Composer.vala"
		_g_free0 (_data9_->identity_address);
#line 607 "../src/Composer.vala"
		block7_data_unref (_data9_->_data7_);
#line 607 "../src/Composer.vala"
		_data9_->_data7_ = NULL;
#line 607 "../src/Composer.vala"
		g_slice_free (Block9Data, _data9_);
#line 2153 "Composer.c"
	}
}

static gboolean
________lambda99_ (Block9Data* _data9_,
                   GtkTreeModel* model,
                   GtkTreePath* path,
                   GtkTreeIter* iter)
{
	Block7Data* _data7_;
	MailComposer* self;
	GValue value = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean result;
#line 612 "../src/Composer.vala"
	_data7_ = _data9_->_data7_;
#line 612 "../src/Composer.vala"
	self = _data7_->self;
#line 612 "../src/Composer.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 612 "../src/Composer.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 612 "../src/Composer.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 614 "../src/Composer.vala"
	_tmp0_ = *iter;
#line 614 "../src/Composer.vala"
	gtk_tree_model_get_value (model, &_tmp0_, 0, &_tmp1_);
#line 614 "../src/Composer.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 614 "../src/Composer.vala"
	value = _tmp1_;
#line 616 "../src/Composer.vala"
	_tmp2_ = g_value_get_string (&value);
#line 616 "../src/Composer.vala"
	_tmp3_ = _data9_->identity_address;
#line 616 "../src/Composer.vala"
	if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 2195 "Composer.c"
		GtkComboBoxText* _tmp4_;
		GtkTreeIter _tmp5_;
#line 617 "../src/Composer.vala"
		_tmp4_ = self->priv->from_combo;
#line 617 "../src/Composer.vala"
		_tmp5_ = *iter;
#line 617 "../src/Composer.vala"
		gtk_combo_box_set_active_iter ((GtkComboBox*) _tmp4_, &_tmp5_);
#line 618 "../src/Composer.vala"
		result = TRUE;
#line 618 "../src/Composer.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 618 "../src/Composer.vala"
		return result;
#line 2210 "Composer.c"
	}
#line 621 "../src/Composer.vala"
	result = FALSE;
#line 621 "../src/Composer.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 621 "../src/Composer.vala"
	return result;
#line 2218 "Composer.c"
}

static gboolean
_________lambda99__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                GtkTreePath* path,
                                                GtkTreeIter* iter,
                                                gpointer self)
{
	gboolean result;
	result = ________lambda99_ (self, model, path, iter);
#line 612 "../src/Composer.vala"
	return result;
#line 2231 "Composer.c"
}

static gboolean
______lambda100_ (MailComposer* self,
                  const gchar* address)
{
	gboolean result;
#line 677 "../src/Composer.vala"
	g_return_val_if_fail (address != NULL, FALSE);
#line 677 "../src/Composer.vala"
	result = TRUE;
#line 677 "../src/Composer.vala"
	return result;
#line 2245 "Composer.c"
}

static gboolean
_______lambda100__mail_utils_accept_address (const gchar* address,
                                             gpointer self)
{
	gboolean result;
	result = ______lambda100_ ((MailComposer*) self, address);
#line 677 "../src/Composer.vala"
	return result;
#line 2256 "Composer.c"
}

static gboolean
_______lambda101_ (MailComposer* self,
                   const gchar* address)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 681 "../src/Composer.vala"
	g_return_val_if_fail (address != NULL, FALSE);
#line 682 "../src/Composer.vala"
	_tmp0_ = self->priv->to_val;
#line 682 "../src/Composer.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 682 "../src/Composer.vala"
	_tmp2_ = _tmp1_;
#line 682 "../src/Composer.vala"
	if (string_contains (_tmp2_, address)) {
#line 683 "../src/Composer.vala"
		result = FALSE;
#line 683 "../src/Composer.vala"
		return result;
#line 2281 "Composer.c"
	}
#line 686 "../src/Composer.vala"
	result = TRUE;
#line 686 "../src/Composer.vala"
	return result;
#line 2287 "Composer.c"
}

static gboolean
________lambda101__mail_utils_accept_address (const gchar* address,
                                              gpointer self)
{
	gboolean result;
	result = _______lambda101_ ((MailComposer*) self, address);
#line 681 "../src/Composer.vala"
	return result;
#line 2298 "Composer.c"
}

void
mail_composer_quote_content (MailComposer* self,
                             MailComposerType type,
                             CamelMessageInfo* info,
                             CamelMimeMessage* message,
                             const gchar* content_to_quote)
{
	const gchar* _tmp0_;
	GtkComboBoxText* _tmp16_;
	GtkTreeModel* _tmp17_;
	GtkTreeModel* _tmp18_;
#line 538 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 538 "../src/Composer.vala"
	g_return_if_fail (info != NULL);
#line 538 "../src/Composer.vala"
	g_return_if_fail (message != NULL);
#line 539 "../src/Composer.vala"
	_tmp0_ = camel_mime_message_get_subject (message);
#line 539 "../src/Composer.vala"
	if (_tmp0_ != NULL) {
#line 2322 "Composer.c"
		GtkEntry* _tmp1_;
		const gchar* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 540 "../src/Composer.vala"
		_tmp1_ = self->priv->subject_val;
#line 540 "../src/Composer.vala"
		_tmp2_ = camel_mime_message_get_subject (message);
#line 540 "../src/Composer.vala"
		gtk_entry_set_text (_tmp1_, _tmp2_);
#line 542 "../src/Composer.vala"
		if (type == MAIL_COMPOSER_TYPE_REPLY) {
#line 542 "../src/Composer.vala"
			_tmp3_ = TRUE;
#line 2336 "Composer.c"
		} else {
#line 542 "../src/Composer.vala"
			_tmp3_ = type == MAIL_COMPOSER_TYPE_REPLY_ALL;
#line 2340 "Composer.c"
		}
#line 542 "../src/Composer.vala"
		if (_tmp3_) {
#line 2344 "Composer.c"
			GtkEntry* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gboolean _tmp9_;
#line 547 "../src/Composer.vala"
			_tmp4_ = self->priv->subject_val;
#line 547 "../src/Composer.vala"
			_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 547 "../src/Composer.vala"
			_tmp6_ = _tmp5_;
#line 547 "../src/Composer.vala"
			_tmp7_ = g_utf8_strup (_tmp6_, (gssize) -1);
#line 547 "../src/Composer.vala"
			_tmp8_ = _tmp7_;
#line 547 "../src/Composer.vala"
			_tmp9_ = !string_contains (_tmp8_, "RE: ");
#line 547 "../src/Composer.vala"
			_g_free0 (_tmp8_);
#line 547 "../src/Composer.vala"
			if (_tmp9_) {
#line 2367 "Composer.c"
				GtkEntry* _tmp10_;
				GtkEntry* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 548 "../src/Composer.vala"
				_tmp10_ = self->priv->subject_val;
#line 548 "../src/Composer.vala"
				_tmp11_ = self->priv->subject_val;
#line 548 "../src/Composer.vala"
				_tmp12_ = gtk_entry_get_text (_tmp11_);
#line 548 "../src/Composer.vala"
				_tmp13_ = _tmp12_;
#line 548 "../src/Composer.vala"
				_tmp14_ = g_strdup_printf ("Re: %s", _tmp13_);
#line 548 "../src/Composer.vala"
				_tmp15_ = _tmp14_;
#line 548 "../src/Composer.vala"
				gtk_entry_set_text (_tmp10_, _tmp15_);
#line 548 "../src/Composer.vala"
				_g_free0 (_tmp15_);
#line 2390 "Composer.c"
			}
		}
	}
#line 553 "../src/Composer.vala"
	_tmp16_ = self->priv->from_combo;
#line 553 "../src/Composer.vala"
	_tmp17_ = gtk_combo_box_get_model ((GtkComboBox*) _tmp16_);
#line 553 "../src/Composer.vala"
	_tmp18_ = _tmp17_;
#line 553 "../src/Composer.vala"
	if (gtk_tree_model_iter_n_children (_tmp18_, NULL) > 1) {
#line 2402 "Composer.c"
		Block7Data* _data7_;
#line 553 "../src/Composer.vala"
		_data7_ = g_slice_new0 (Block7Data);
#line 553 "../src/Composer.vala"
		_data7_->_ref_count_ = 1;
#line 553 "../src/Composer.vala"
		_data7_->self = g_object_ref (self);
#line 554 "../src/Composer.vala"
		_data7_->found = FALSE;
#line 556 "../src/Composer.vala"
		if (type != MAIL_COMPOSER_TYPE_DRAFT) {
#line 2414 "Composer.c"
			Block8Data* _data8_;
			CamelInternetAddress* recipients = NULL;
			CamelInternetAddress* _tmp19_;
			CamelInternetAddress* to_recipients = NULL;
			CamelInternetAddress* _tmp20_;
			CamelInternetAddress* _tmp21_;
			CamelInternetAddress* cc_recipients = NULL;
			CamelInternetAddress* _tmp24_;
			CamelInternetAddress* _tmp25_;
			CamelInternetAddress* bcc_recipients = NULL;
			CamelInternetAddress* _tmp28_;
			CamelInternetAddress* _tmp29_;
			gint i = 0;
#line 556 "../src/Composer.vala"
			_data8_ = g_slice_new0 (Block8Data);
#line 556 "../src/Composer.vala"
			_data8_->_ref_count_ = 1;
#line 556 "../src/Composer.vala"
			_data8_->_data7_ = block7_data_ref (_data7_);
#line 559 "../src/Composer.vala"
			_tmp19_ = camel_internet_address_new ();
#line 559 "../src/Composer.vala"
			recipients = _tmp19_;
#line 561 "../src/Composer.vala"
			_tmp20_ = camel_mime_message_get_recipients (message, CAMEL_RECIPIENT_TYPE_TO);
#line 561 "../src/Composer.vala"
			to_recipients = _tmp20_;
#line 562 "../src/Composer.vala"
			_tmp21_ = to_recipients;
#line 562 "../src/Composer.vala"
			if (_tmp21_ != NULL) {
#line 2446 "Composer.c"
				CamelInternetAddress* _tmp22_;
				CamelInternetAddress* _tmp23_;
#line 563 "../src/Composer.vala"
				_tmp22_ = recipients;
#line 563 "../src/Composer.vala"
				_tmp23_ = to_recipients;
#line 563 "../src/Composer.vala"
				camel_address_cat ((CamelAddress*) _tmp22_, (CamelAddress*) _tmp23_);
#line 2455 "Composer.c"
			}
#line 565 "../src/Composer.vala"
			_tmp24_ = camel_mime_message_get_recipients (message, CAMEL_RECIPIENT_TYPE_CC);
#line 565 "../src/Composer.vala"
			cc_recipients = _tmp24_;
#line 566 "../src/Composer.vala"
			_tmp25_ = cc_recipients;
#line 566 "../src/Composer.vala"
			if (_tmp25_ != NULL) {
#line 2465 "Composer.c"
				CamelInternetAddress* _tmp26_;
				CamelInternetAddress* _tmp27_;
#line 567 "../src/Composer.vala"
				_tmp26_ = recipients;
#line 567 "../src/Composer.vala"
				_tmp27_ = cc_recipients;
#line 567 "../src/Composer.vala"
				camel_address_cat ((CamelAddress*) _tmp26_, (CamelAddress*) _tmp27_);
#line 2474 "Composer.c"
			}
#line 569 "../src/Composer.vala"
			_tmp28_ = camel_mime_message_get_recipients (message, CAMEL_RECIPIENT_TYPE_BCC);
#line 569 "../src/Composer.vala"
			bcc_recipients = _tmp28_;
#line 570 "../src/Composer.vala"
			_tmp29_ = bcc_recipients;
#line 570 "../src/Composer.vala"
			if (_tmp29_ != NULL) {
#line 2484 "Composer.c"
				CamelInternetAddress* _tmp30_;
				CamelInternetAddress* _tmp31_;
#line 571 "../src/Composer.vala"
				_tmp30_ = recipients;
#line 571 "../src/Composer.vala"
				_tmp31_ = bcc_recipients;
#line 571 "../src/Composer.vala"
				camel_address_cat ((CamelAddress*) _tmp30_, (CamelAddress*) _tmp31_);
#line 2493 "Composer.c"
			}
#line 574 "../src/Composer.vala"
			i = 0;
#line 576 "../src/Composer.vala"
			while (TRUE) {
#line 2499 "Composer.c"
				gboolean _tmp32_ = FALSE;
				CamelInternetAddress* _tmp33_;
				const gchar* _tmp34_ = NULL;
				gboolean _tmp35_;
				gint _tmp36_;
				GtkComboBoxText* _tmp37_;
				GtkTreeModel* _tmp38_;
				GtkTreeModel* _tmp39_;
#line 576 "../src/Composer.vala"
				_tmp33_ = recipients;
#line 576 "../src/Composer.vala"
				_tmp35_ = camel_internet_address_get (_tmp33_, i, NULL, &_tmp34_);
#line 576 "../src/Composer.vala"
				_data8_->address = _tmp34_;
#line 576 "../src/Composer.vala"
				if (_tmp35_) {
#line 576 "../src/Composer.vala"
					_tmp32_ = !_data7_->found;
#line 2518 "Composer.c"
				} else {
#line 576 "../src/Composer.vala"
					_tmp32_ = FALSE;
#line 2522 "Composer.c"
				}
#line 576 "../src/Composer.vala"
				if (!_tmp32_) {
#line 576 "../src/Composer.vala"
					break;
#line 2528 "Composer.c"
				}
#line 577 "../src/Composer.vala"
				_tmp36_ = i;
#line 577 "../src/Composer.vala"
				i = _tmp36_ + 1;
#line 578 "../src/Composer.vala"
				_tmp37_ = self->priv->from_combo;
#line 578 "../src/Composer.vala"
				_tmp38_ = gtk_combo_box_get_model ((GtkComboBox*) _tmp37_);
#line 578 "../src/Composer.vala"
				_tmp39_ = _tmp38_;
#line 578 "../src/Composer.vala"
				gtk_tree_model_foreach (_tmp39_, ______lambda98__gtk_tree_model_foreach_func, _data8_);
#line 2542 "Composer.c"
			}
#line 556 "../src/Composer.vala"
			_g_object_unref0 (recipients);
#line 556 "../src/Composer.vala"
			block8_data_unref (_data8_);
#line 556 "../src/Composer.vala"
			_data8_ = NULL;
#line 2550 "Composer.c"
		}
#line 595 "../src/Composer.vala"
		if (!_data7_->found) {
#line 2554 "Composer.c"
			MailBackendSession* session = NULL;
			MailBackendSession* _tmp40_;
			const gchar* account_source_uid = NULL;
			const gchar* _tmp41_;
			ESource* account_source = NULL;
			MailBackendSession* _tmp42_;
			const gchar* _tmp43_;
			ESource* _tmp44_;
			gboolean _tmp45_ = FALSE;
			ESource* _tmp46_;
#line 596 "../src/Composer.vala"
			_tmp40_ = mail_backend_session_get_default ();
#line 596 "../src/Composer.vala"
			session = _tmp40_;
#line 597 "../src/Composer.vala"
			_tmp41_ = camel_mime_message_get_source (message);
#line 597 "../src/Composer.vala"
			account_source_uid = _tmp41_;
#line 598 "../src/Composer.vala"
			_tmp42_ = session;
#line 598 "../src/Composer.vala"
			_tmp43_ = account_source_uid;
#line 598 "../src/Composer.vala"
			_tmp44_ = mail_backend_session_ref_source (_tmp42_, _tmp43_);
#line 598 "../src/Composer.vala"
			account_source = _tmp44_;
#line 600 "../src/Composer.vala"
			_tmp46_ = account_source;
#line 600 "../src/Composer.vala"
			if (_tmp46_ != NULL) {
#line 2585 "Composer.c"
				ESource* _tmp47_;
#line 600 "../src/Composer.vala"
				_tmp47_ = account_source;
#line 600 "../src/Composer.vala"
				_tmp45_ = e_source_has_extension (_tmp47_, E_SOURCE_EXTENSION_MAIL_ACCOUNT);
#line 2591 "Composer.c"
			} else {
#line 600 "../src/Composer.vala"
				_tmp45_ = FALSE;
#line 2595 "Composer.c"
			}
#line 600 "../src/Composer.vala"
			if (_tmp45_) {
#line 2599 "Composer.c"
				ESourceMailAccount* account_extension = NULL;
				ESource* _tmp48_;
				ESourceExtension* _tmp49_;
				gchar* identity_uid = NULL;
				ESourceMailAccount* _tmp50_;
				const gchar* _tmp51_;
				const gchar* _tmp52_;
				gchar* _tmp53_;
				gboolean _tmp54_ = FALSE;
				const gchar* _tmp55_;
#line 601 "../src/Composer.vala"
				_tmp48_ = account_source;
#line 601 "../src/Composer.vala"
				_tmp49_ = e_source_get_extension (_tmp48_, E_SOURCE_EXTENSION_MAIL_ACCOUNT);
#line 601 "../src/Composer.vala"
				account_extension = G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, e_source_mail_account_get_type (), ESourceMailAccount);
#line 603 "../src/Composer.vala"
				_tmp50_ = account_extension;
#line 603 "../src/Composer.vala"
				_tmp51_ = e_source_mail_account_get_identity_uid (_tmp50_);
#line 603 "../src/Composer.vala"
				_tmp52_ = _tmp51_;
#line 603 "../src/Composer.vala"
				_tmp53_ = g_strdup (_tmp52_);
#line 603 "../src/Composer.vala"
				identity_uid = _tmp53_;
#line 604 "../src/Composer.vala"
				_tmp55_ = identity_uid;
#line 604 "../src/Composer.vala"
				if (_tmp55_ != NULL) {
#line 2630 "Composer.c"
					const gchar* _tmp56_;
#line 604 "../src/Composer.vala"
					_tmp56_ = identity_uid;
#line 604 "../src/Composer.vala"
					_tmp54_ = g_strcmp0 (_tmp56_, "") != 0;
#line 2636 "Composer.c"
				} else {
#line 604 "../src/Composer.vala"
					_tmp54_ = FALSE;
#line 2640 "Composer.c"
				}
#line 604 "../src/Composer.vala"
				if (_tmp54_) {
#line 2644 "Composer.c"
					ESource* identity_source = NULL;
					MailBackendSession* _tmp57_;
					const gchar* _tmp58_;
					ESource* _tmp59_;
					gboolean _tmp60_ = FALSE;
					ESource* _tmp61_;
#line 605 "../src/Composer.vala"
					_tmp57_ = session;
#line 605 "../src/Composer.vala"
					_tmp58_ = identity_uid;
#line 605 "../src/Composer.vala"
					_tmp59_ = mail_backend_session_ref_source (_tmp57_, _tmp58_);
#line 605 "../src/Composer.vala"
					identity_source = _tmp59_;
#line 607 "../src/Composer.vala"
					_tmp61_ = identity_source;
#line 607 "../src/Composer.vala"
					if (_tmp61_ != NULL) {
#line 2663 "Composer.c"
						ESource* _tmp62_;
#line 607 "../src/Composer.vala"
						_tmp62_ = identity_source;
#line 607 "../src/Composer.vala"
						_tmp60_ = e_source_has_extension (_tmp62_, E_SOURCE_EXTENSION_MAIL_IDENTITY);
#line 2669 "Composer.c"
					} else {
#line 607 "../src/Composer.vala"
						_tmp60_ = FALSE;
#line 2673 "Composer.c"
					}
#line 607 "../src/Composer.vala"
					if (_tmp60_) {
#line 2677 "Composer.c"
						Block9Data* _data9_;
						ESourceMailIdentity* identity_extension = NULL;
						ESource* _tmp63_;
						ESourceExtension* _tmp64_;
						ESourceMailIdentity* _tmp65_;
						const gchar* _tmp66_;
						gchar* _tmp67_;
						const gchar* _tmp68_;
#line 607 "../src/Composer.vala"
						_data9_ = g_slice_new0 (Block9Data);
#line 607 "../src/Composer.vala"
						_data9_->_ref_count_ = 1;
#line 607 "../src/Composer.vala"
						_data9_->_data7_ = block7_data_ref (_data7_);
#line 608 "../src/Composer.vala"
						_tmp63_ = identity_source;
#line 608 "../src/Composer.vala"
						_tmp64_ = e_source_get_extension (_tmp63_, E_SOURCE_EXTENSION_MAIL_IDENTITY);
#line 608 "../src/Composer.vala"
						identity_extension = G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, e_source_mail_identity_get_type (), ESourceMailIdentity);
#line 610 "../src/Composer.vala"
						_tmp65_ = identity_extension;
#line 610 "../src/Composer.vala"
						_tmp66_ = e_source_mail_identity_get_address (_tmp65_);
#line 610 "../src/Composer.vala"
						_tmp67_ = g_strdup (_tmp66_);
#line 610 "../src/Composer.vala"
						_data9_->identity_address = _tmp67_;
#line 611 "../src/Composer.vala"
						_tmp68_ = _data9_->identity_address;
#line 611 "../src/Composer.vala"
						if (g_strcmp0 (_tmp68_, "") != 0) {
#line 2710 "Composer.c"
							GtkComboBoxText* _tmp69_;
							GtkTreeModel* _tmp70_;
							GtkTreeModel* _tmp71_;
#line 612 "../src/Composer.vala"
							_tmp69_ = self->priv->from_combo;
#line 612 "../src/Composer.vala"
							_tmp70_ = gtk_combo_box_get_model ((GtkComboBox*) _tmp69_);
#line 612 "../src/Composer.vala"
							_tmp71_ = _tmp70_;
#line 612 "../src/Composer.vala"
							gtk_tree_model_foreach (_tmp71_, _________lambda99__gtk_tree_model_foreach_func, _data9_);
#line 2722 "Composer.c"
						}
#line 607 "../src/Composer.vala"
						block9_data_unref (_data9_);
#line 607 "../src/Composer.vala"
						_data9_ = NULL;
#line 2728 "Composer.c"
					}
#line 604 "../src/Composer.vala"
					_g_object_unref0 (identity_source);
#line 2732 "Composer.c"
				}
#line 600 "../src/Composer.vala"
				_g_free0 (identity_uid);
#line 2736 "Composer.c"
			}
#line 595 "../src/Composer.vala"
			_g_object_unref0 (account_source);
#line 2740 "Composer.c"
		}
#line 553 "../src/Composer.vala"
		block7_data_unref (_data7_);
#line 553 "../src/Composer.vala"
		_data7_ = NULL;
#line 2746 "Composer.c"
	}
#line 630 "../src/Composer.vala"
	if (content_to_quote != NULL) {
#line 631 "../src/Composer.vala"
		if (type == MAIL_COMPOSER_TYPE_DRAFT) {
#line 2752 "Composer.c"
			CamelMessageInfo* _tmp72_;
			CamelInternetAddress* to = NULL;
			CamelInternetAddress* _tmp75_;
			CamelInternetAddress* _tmp76_;
			CamelInternetAddress* cc = NULL;
			CamelInternetAddress* _tmp81_;
			CamelInternetAddress* _tmp82_;
			CamelInternetAddress* bcc = NULL;
			CamelInternetAddress* _tmp93_;
			CamelInternetAddress* _tmp94_;
#line 632 "../src/Composer.vala"
			_tmp72_ = _g_object_ref0 (info);
#line 632 "../src/Composer.vala"
			_g_object_unref0 (self->priv->ancestor_message_info);
#line 632 "../src/Composer.vala"
			self->priv->ancestor_message_info = _tmp72_;
#line 634 "../src/Composer.vala"
			if (string_contains (content_to_quote, "elementary-message-body")) {
#line 2771 "Composer.c"
				MailWebView* _tmp73_;
#line 638 "../src/Composer.vala"
				_tmp73_ = self->priv->web_view;
#line 638 "../src/Composer.vala"
				mail_web_view_set_content_of_element (_tmp73_, "body", content_to_quote);
#line 2777 "Composer.c"
			} else {
				MailWebView* _tmp74_;
#line 640 "../src/Composer.vala"
				_tmp74_ = self->priv->web_view;
#line 640 "../src/Composer.vala"
				mail_web_view_set_content_of_element (_tmp74_, "#elementary-message-body", content_to_quote);
#line 2784 "Composer.c"
			}
#line 643 "../src/Composer.vala"
			_tmp75_ = camel_mime_message_get_recipients (message, CAMEL_RECIPIENT_TYPE_TO);
#line 643 "../src/Composer.vala"
			to = _tmp75_;
#line 644 "../src/Composer.vala"
			_tmp76_ = to;
#line 644 "../src/Composer.vala"
			if (_tmp76_ != NULL) {
#line 2794 "Composer.c"
				GtkEntry* _tmp77_;
				CamelInternetAddress* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
#line 645 "../src/Composer.vala"
				_tmp77_ = self->priv->to_val;
#line 645 "../src/Composer.vala"
				_tmp78_ = to;
#line 645 "../src/Composer.vala"
				_tmp79_ = camel_address_format ((CamelAddress*) _tmp78_);
#line 645 "../src/Composer.vala"
				_tmp80_ = _tmp79_;
#line 645 "../src/Composer.vala"
				gtk_entry_set_text (_tmp77_, _tmp80_);
#line 645 "../src/Composer.vala"
				_g_free0 (_tmp80_);
#line 2811 "Composer.c"
			}
#line 648 "../src/Composer.vala"
			_tmp81_ = camel_mime_message_get_recipients (message, CAMEL_RECIPIENT_TYPE_CC);
#line 648 "../src/Composer.vala"
			cc = _tmp81_;
#line 649 "../src/Composer.vala"
			_tmp82_ = cc;
#line 649 "../src/Composer.vala"
			if (_tmp82_ != NULL) {
#line 2821 "Composer.c"
				GtkEntry* _tmp83_;
				CamelInternetAddress* _tmp84_;
				gchar* _tmp85_;
				gchar* _tmp86_;
				GtkEntry* _tmp87_;
				const gchar* _tmp88_;
				const gchar* _tmp89_;
				gint _tmp90_;
				gint _tmp91_;
#line 650 "../src/Composer.vala"
				_tmp83_ = self->priv->cc_val;
#line 650 "../src/Composer.vala"
				_tmp84_ = cc;
#line 650 "../src/Composer.vala"
				_tmp85_ = camel_address_format ((CamelAddress*) _tmp84_);
#line 650 "../src/Composer.vala"
				_tmp86_ = _tmp85_;
#line 650 "../src/Composer.vala"
				gtk_entry_set_text (_tmp83_, _tmp86_);
#line 650 "../src/Composer.vala"
				_g_free0 (_tmp86_);
#line 652 "../src/Composer.vala"
				_tmp87_ = self->priv->cc_val;
#line 652 "../src/Composer.vala"
				_tmp88_ = gtk_entry_get_text (_tmp87_);
#line 652 "../src/Composer.vala"
				_tmp89_ = _tmp88_;
#line 652 "../src/Composer.vala"
				_tmp90_ = strlen (_tmp89_);
#line 652 "../src/Composer.vala"
				_tmp91_ = _tmp90_;
#line 652 "../src/Composer.vala"
				if (_tmp91_ > 0) {
#line 2855 "Composer.c"
					GtkRevealer* _tmp92_;
#line 653 "../src/Composer.vala"
					_tmp92_ = self->priv->cc_revealer;
#line 653 "../src/Composer.vala"
					gtk_revealer_set_reveal_child (_tmp92_, TRUE);
#line 2861 "Composer.c"
				}
			}
#line 657 "../src/Composer.vala"
			_tmp93_ = camel_mime_message_get_recipients (message, CAMEL_RECIPIENT_TYPE_BCC);
#line 657 "../src/Composer.vala"
			bcc = _tmp93_;
#line 658 "../src/Composer.vala"
			_tmp94_ = bcc;
#line 658 "../src/Composer.vala"
			if (_tmp94_ != NULL) {
#line 2872 "Composer.c"
				GtkEntry* _tmp95_;
				CamelInternetAddress* _tmp96_;
				gchar* _tmp97_;
				gchar* _tmp98_;
				GtkEntry* _tmp99_;
				const gchar* _tmp100_;
				const gchar* _tmp101_;
				gint _tmp102_;
				gint _tmp103_;
#line 659 "../src/Composer.vala"
				_tmp95_ = self->priv->bcc_val;
#line 659 "../src/Composer.vala"
				_tmp96_ = bcc;
#line 659 "../src/Composer.vala"
				_tmp97_ = camel_address_format ((CamelAddress*) _tmp96_);
#line 659 "../src/Composer.vala"
				_tmp98_ = _tmp97_;
#line 659 "../src/Composer.vala"
				gtk_entry_set_text (_tmp95_, _tmp98_);
#line 659 "../src/Composer.vala"
				_g_free0 (_tmp98_);
#line 661 "../src/Composer.vala"
				_tmp99_ = self->priv->bcc_val;
#line 661 "../src/Composer.vala"
				_tmp100_ = gtk_entry_get_text (_tmp99_);
#line 661 "../src/Composer.vala"
				_tmp101_ = _tmp100_;
#line 661 "../src/Composer.vala"
				_tmp102_ = strlen (_tmp101_);
#line 661 "../src/Composer.vala"
				_tmp103_ = _tmp102_;
#line 661 "../src/Composer.vala"
				if (_tmp103_ > 0) {
#line 2906 "Composer.c"
					GtkRevealer* _tmp104_;
#line 662 "../src/Composer.vala"
					_tmp104_ = self->priv->bcc_revealer;
#line 662 "../src/Composer.vala"
					gtk_revealer_set_reveal_child (_tmp104_, TRUE);
#line 2912 "Composer.c"
				}
			}
		} else {
			gchar* message_content = NULL;
			gchar* _tmp105_;
			gchar* date_format = NULL;
			gchar* _tmp106_;
			gboolean _tmp107_ = FALSE;
			MailWebView* _tmp227_;
			const gchar* _tmp228_;
#line 666 "../src/Composer.vala"
			_tmp105_ = g_strdup ("");
#line 666 "../src/Composer.vala"
			message_content = _tmp105_;
#line 667 "../src/Composer.vala"
			_tmp106_ = g_strdup (_ ("%a, %b %-e, %Y at %-l:%M %p"));
#line 667 "../src/Composer.vala"
			date_format = _tmp106_;
#line 668 "../src/Composer.vala"
			if (type == MAIL_COMPOSER_TYPE_REPLY) {
#line 668 "../src/Composer.vala"
				_tmp107_ = TRUE;
#line 2935 "Composer.c"
			} else {
#line 668 "../src/Composer.vala"
				_tmp107_ = type == MAIL_COMPOSER_TYPE_REPLY_ALL;
#line 2939 "Composer.c"
			}
#line 668 "../src/Composer.vala"
			if (_tmp107_) {
#line 2943 "Composer.c"
				CamelInternetAddress* reply_to = NULL;
				CamelInternetAddress* _tmp108_;
				CamelInternetAddress* _tmp109_;
				CamelInternetAddress* _tmp110_;
				gchar* when = NULL;
				gint64 _tmp144_;
				gint64 _tmp145_;
				GDateTime* _tmp146_;
				GDateTime* _tmp147_;
				const gchar* _tmp148_;
				gchar* _tmp149_;
				gchar* _tmp150_;
				gchar* who = NULL;
				CamelInternetAddress* _tmp151_;
				gchar* _tmp152_;
				gchar* _tmp153_;
				gchar* _tmp154_;
				gchar* _tmp155_;
				const gchar* _tmp156_;
				const gchar* _tmp157_;
				const gchar* _tmp158_;
				gchar* _tmp159_;
				gchar* _tmp160_;
				gchar* _tmp161_;
				const gchar* _tmp162_;
				gchar* _tmp163_;
				const gchar* _tmp164_;
				gchar* _tmp165_;
				gchar* _tmp166_;
				gchar* _tmp167_;
#line 669 "../src/Composer.vala"
				_tmp108_ = camel_mime_message_get_reply_to (message);
#line 669 "../src/Composer.vala"
				_tmp109_ = _g_object_ref0 (_tmp108_);
#line 669 "../src/Composer.vala"
				reply_to = _tmp109_;
#line 670 "../src/Composer.vala"
				_tmp110_ = reply_to;
#line 670 "../src/Composer.vala"
				if (_tmp110_ != NULL) {
#line 2984 "Composer.c"
					GtkEntry* _tmp111_;
					CamelInternetAddress* _tmp112_;
					gchar* _tmp113_;
					gchar* _tmp114_;
#line 671 "../src/Composer.vala"
					_tmp111_ = self->priv->to_val;
#line 671 "../src/Composer.vala"
					_tmp112_ = reply_to;
#line 671 "../src/Composer.vala"
					_tmp113_ = camel_address_format ((CamelAddress*) _tmp112_);
#line 671 "../src/Composer.vala"
					_tmp114_ = _tmp113_;
#line 671 "../src/Composer.vala"
					gtk_entry_set_text (_tmp111_, _tmp114_);
#line 671 "../src/Composer.vala"
					_g_free0 (_tmp114_);
#line 3001 "Composer.c"
				} else {
					GtkEntry* _tmp115_;
					CamelInternetAddress* _tmp116_;
					gchar* _tmp117_;
					gchar* _tmp118_;
#line 673 "../src/Composer.vala"
					_tmp115_ = self->priv->to_val;
#line 673 "../src/Composer.vala"
					_tmp116_ = camel_mime_message_get_from (message);
#line 673 "../src/Composer.vala"
					_tmp117_ = camel_address_format ((CamelAddress*) _tmp116_);
#line 673 "../src/Composer.vala"
					_tmp118_ = _tmp117_;
#line 673 "../src/Composer.vala"
					gtk_entry_set_text (_tmp115_, _tmp118_);
#line 673 "../src/Composer.vala"
					_g_free0 (_tmp118_);
#line 3019 "Composer.c"
				}
#line 676 "../src/Composer.vala"
				if (type == MAIL_COMPOSER_TYPE_REPLY_ALL) {
#line 3023 "Composer.c"
					gchar* to_addresses = NULL;
					const gchar* _tmp119_;
					const gchar* _tmp120_;
					gchar* _tmp121_;
					GtkEntry* _tmp122_;
					GtkEntry* _tmp123_;
					const gchar* _tmp124_;
					const gchar* _tmp125_;
					const gchar* _tmp126_;
					gchar* _tmp127_;
					gchar* _tmp128_;
					gchar* _tmp129_;
					gchar* _tmp130_;
					const gchar* _tmp131_;
					const gchar* _tmp132_;
#line 677 "../src/Composer.vala"
					_tmp119_ = camel_message_info_get_to (info);
#line 677 "../src/Composer.vala"
					_tmp120_ = _tmp119_;
#line 677 "../src/Composer.vala"
					_tmp121_ = mail_utils_get_reply_addresses (_tmp120_, _______lambda100__mail_utils_accept_address, self);
#line 677 "../src/Composer.vala"
					to_addresses = _tmp121_;
#line 678 "../src/Composer.vala"
					_tmp122_ = self->priv->to_val;
#line 678 "../src/Composer.vala"
					_tmp123_ = self->priv->to_val;
#line 678 "../src/Composer.vala"
					_tmp124_ = gtk_entry_get_text (_tmp123_);
#line 678 "../src/Composer.vala"
					_tmp125_ = _tmp124_;
#line 678 "../src/Composer.vala"
					_tmp126_ = to_addresses;
#line 678 "../src/Composer.vala"
					_tmp127_ = g_strdup_printf (", %s", _tmp126_);
#line 678 "../src/Composer.vala"
					_tmp128_ = _tmp127_;
#line 678 "../src/Composer.vala"
					_tmp129_ = g_strconcat (_tmp125_, _tmp128_, NULL);
#line 678 "../src/Composer.vala"
					_tmp130_ = _tmp129_;
#line 678 "../src/Composer.vala"
					gtk_entry_set_text (_tmp123_, _tmp130_);
#line 678 "../src/Composer.vala"
					_g_free0 (_tmp130_);
#line 678 "../src/Composer.vala"
					_g_free0 (_tmp128_);
#line 680 "../src/Composer.vala"
					_tmp131_ = camel_message_info_get_cc (info);
#line 680 "../src/Composer.vala"
					_tmp132_ = _tmp131_;
#line 680 "../src/Composer.vala"
					if (_tmp132_ != NULL) {
#line 3077 "Composer.c"
						GtkEntry* _tmp133_;
						const gchar* _tmp134_;
						const gchar* _tmp135_;
						gchar* _tmp136_;
						gchar* _tmp137_;
						GtkEntry* _tmp138_;
						const gchar* _tmp139_;
						const gchar* _tmp140_;
						gint _tmp141_;
						gint _tmp142_;
#line 681 "../src/Composer.vala"
						_tmp133_ = self->priv->cc_val;
#line 681 "../src/Composer.vala"
						_tmp134_ = camel_message_info_get_cc (info);
#line 681 "../src/Composer.vala"
						_tmp135_ = _tmp134_;
#line 681 "../src/Composer.vala"
						_tmp136_ = mail_utils_get_reply_addresses (_tmp135_, ________lambda101__mail_utils_accept_address, self);
#line 681 "../src/Composer.vala"
						_tmp137_ = _tmp136_;
#line 681 "../src/Composer.vala"
						gtk_entry_set_text (_tmp133_, _tmp137_);
#line 681 "../src/Composer.vala"
						_g_free0 (_tmp137_);
#line 689 "../src/Composer.vala"
						_tmp138_ = self->priv->cc_val;
#line 689 "../src/Composer.vala"
						_tmp139_ = gtk_entry_get_text (_tmp138_);
#line 689 "../src/Composer.vala"
						_tmp140_ = _tmp139_;
#line 689 "../src/Composer.vala"
						_tmp141_ = strlen (_tmp140_);
#line 689 "../src/Composer.vala"
						_tmp142_ = _tmp141_;
#line 689 "../src/Composer.vala"
						if (_tmp142_ > 0) {
#line 3114 "Composer.c"
							GtkRevealer* _tmp143_;
#line 690 "../src/Composer.vala"
							_tmp143_ = self->priv->cc_revealer;
#line 690 "../src/Composer.vala"
							gtk_revealer_set_reveal_child (_tmp143_, TRUE);
#line 3120 "Composer.c"
						}
					}
#line 676 "../src/Composer.vala"
					_g_free0 (to_addresses);
#line 3125 "Composer.c"
				}
#line 695 "../src/Composer.vala"
				_tmp144_ = camel_message_info_get_date_received (info);
#line 695 "../src/Composer.vala"
				_tmp145_ = _tmp144_;
#line 695 "../src/Composer.vala"
				_tmp146_ = g_date_time_new_from_unix_utc (_tmp145_);
#line 695 "../src/Composer.vala"
				_tmp147_ = _tmp146_;
#line 695 "../src/Composer.vala"
				_tmp148_ = date_format;
#line 695 "../src/Composer.vala"
				_tmp149_ = g_date_time_format (_tmp147_, _tmp148_);
#line 695 "../src/Composer.vala"
				_tmp150_ = _tmp149_;
#line 695 "../src/Composer.vala"
				_g_date_time_unref0 (_tmp147_);
#line 695 "../src/Composer.vala"
				when = _tmp150_;
#line 696 "../src/Composer.vala"
				_tmp151_ = camel_mime_message_get_from (message);
#line 696 "../src/Composer.vala"
				_tmp152_ = camel_address_format ((CamelAddress*) _tmp151_);
#line 696 "../src/Composer.vala"
				_tmp153_ = _tmp152_;
#line 696 "../src/Composer.vala"
				_tmp154_ = mail_utils_escape_html_tags (_tmp153_);
#line 696 "../src/Composer.vala"
				_tmp155_ = _tmp154_;
#line 696 "../src/Composer.vala"
				_g_free0 (_tmp153_);
#line 696 "../src/Composer.vala"
				who = _tmp155_;
#line 697 "../src/Composer.vala"
				_tmp156_ = message_content;
#line 697 "../src/Composer.vala"
				_tmp157_ = when;
#line 697 "../src/Composer.vala"
				_tmp158_ = who;
#line 697 "../src/Composer.vala"
				_tmp159_ = g_strdup_printf (_ ("On %1$s, %2$s wrote:"), _tmp157_, _tmp158_);
#line 697 "../src/Composer.vala"
				_tmp160_ = _tmp159_;
#line 697 "../src/Composer.vala"
				_tmp161_ = g_strconcat (_tmp156_, _tmp160_, NULL);
#line 697 "../src/Composer.vala"
				_g_free0 (message_content);
#line 697 "../src/Composer.vala"
				message_content = _tmp161_;
#line 697 "../src/Composer.vala"
				_g_free0 (_tmp160_);
#line 698 "../src/Composer.vala"
				_tmp162_ = message_content;
#line 698 "../src/Composer.vala"
				_tmp163_ = g_strconcat (_tmp162_, "<br/>", NULL);
#line 698 "../src/Composer.vala"
				_g_free0 (message_content);
#line 698 "../src/Composer.vala"
				message_content = _tmp163_;
#line 699 "../src/Composer.vala"
				_tmp164_ = message_content;
#line 699 "../src/Composer.vala"
				_tmp165_ = g_strdup_printf ("<blockquote type=\"cite\">%s</blockquote>", content_to_quote);
#line 699 "../src/Composer.vala"
				_tmp166_ = _tmp165_;
#line 699 "../src/Composer.vala"
				_tmp167_ = g_strconcat (_tmp164_, _tmp166_, NULL);
#line 699 "../src/Composer.vala"
				_g_free0 (message_content);
#line 699 "../src/Composer.vala"
				message_content = _tmp167_;
#line 699 "../src/Composer.vala"
				_g_free0 (_tmp166_);
#line 668 "../src/Composer.vala"
				_g_free0 (who);
#line 668 "../src/Composer.vala"
				_g_free0 (when);
#line 668 "../src/Composer.vala"
				_g_object_unref0 (reply_to);
#line 3205 "Composer.c"
			} else {
#line 700 "../src/Composer.vala"
				if (type == MAIL_COMPOSER_TYPE_FORWARD) {
#line 3209 "Composer.c"
					const gchar* _tmp168_;
					gchar* _tmp169_;
					const gchar* _tmp170_;
					gchar* _tmp171_;
					const gchar* _tmp172_;
					CamelInternetAddress* _tmp173_;
					gchar* _tmp174_;
					gchar* _tmp175_;
					gchar* _tmp176_;
					gchar* _tmp177_;
					gchar* _tmp178_;
					gchar* _tmp179_;
					gchar* _tmp180_;
					const gchar* _tmp181_;
					const gchar* _tmp182_;
					const gchar* _tmp183_;
					gchar* _tmp184_;
					gchar* _tmp185_;
					gchar* _tmp186_;
					gchar* _tmp187_;
					gchar* _tmp188_;
					const gchar* _tmp189_;
					gint64 _tmp190_;
					gint64 _tmp191_;
					GDateTime* _tmp192_;
					GDateTime* _tmp193_;
					const gchar* _tmp194_;
					gchar* _tmp195_;
					gchar* _tmp196_;
					gchar* _tmp197_;
					gchar* _tmp198_;
					gchar* _tmp199_;
					const gchar* _tmp200_;
					const gchar* _tmp201_;
					const gchar* _tmp202_;
					gchar* _tmp203_;
					gchar* _tmp204_;
					gchar* _tmp205_;
					gchar* _tmp206_;
					gchar* _tmp207_;
					gboolean _tmp208_ = FALSE;
					const gchar* _tmp209_;
					const gchar* _tmp210_;
					const gchar* _tmp221_;
					gchar* _tmp222_;
					const gchar* _tmp223_;
					gchar* _tmp224_;
#line 701 "../src/Composer.vala"
					_tmp168_ = message_content;
#line 701 "../src/Composer.vala"
					_tmp169_ = g_strconcat (_tmp168_, _ ("---------- Forwarded message ----------"), NULL);
#line 701 "../src/Composer.vala"
					_g_free0 (message_content);
#line 701 "../src/Composer.vala"
					message_content = _tmp169_;
#line 702 "../src/Composer.vala"
					_tmp170_ = message_content;
#line 702 "../src/Composer.vala"
					_tmp171_ = g_strconcat (_tmp170_, "<br/><br/>", NULL);
#line 702 "../src/Composer.vala"
					_g_free0 (message_content);
#line 702 "../src/Composer.vala"
					message_content = _tmp171_;
#line 703 "../src/Composer.vala"
					_tmp172_ = message_content;
#line 703 "../src/Composer.vala"
					_tmp173_ = camel_mime_message_get_from (message);
#line 703 "../src/Composer.vala"
					_tmp174_ = camel_address_format ((CamelAddress*) _tmp173_);
#line 703 "../src/Composer.vala"
					_tmp175_ = _tmp174_;
#line 703 "../src/Composer.vala"
					_tmp176_ = mail_utils_escape_html_tags (_tmp175_);
#line 703 "../src/Composer.vala"
					_tmp177_ = _tmp176_;
#line 703 "../src/Composer.vala"
					_tmp178_ = g_strdup_printf (_ ("From: %s<br/>"), _tmp177_);
#line 703 "../src/Composer.vala"
					_tmp179_ = _tmp178_;
#line 703 "../src/Composer.vala"
					_tmp180_ = g_strconcat (_tmp172_, _tmp179_, NULL);
#line 703 "../src/Composer.vala"
					_g_free0 (message_content);
#line 703 "../src/Composer.vala"
					message_content = _tmp180_;
#line 703 "../src/Composer.vala"
					_g_free0 (_tmp179_);
#line 703 "../src/Composer.vala"
					_g_free0 (_tmp177_);
#line 703 "../src/Composer.vala"
					_g_free0 (_tmp175_);
#line 704 "../src/Composer.vala"
					_tmp181_ = message_content;
#line 704 "../src/Composer.vala"
					_tmp182_ = camel_message_info_get_subject (info);
#line 704 "../src/Composer.vala"
					_tmp183_ = _tmp182_;
#line 704 "../src/Composer.vala"
					_tmp184_ = mail_utils_escape_html_tags (_tmp183_);
#line 704 "../src/Composer.vala"
					_tmp185_ = _tmp184_;
#line 704 "../src/Composer.vala"
					_tmp186_ = g_strdup_printf (_ ("Subject: %s<br/>"), _tmp185_);
#line 704 "../src/Composer.vala"
					_tmp187_ = _tmp186_;
#line 704 "../src/Composer.vala"
					_tmp188_ = g_strconcat (_tmp181_, _tmp187_, NULL);
#line 704 "../src/Composer.vala"
					_g_free0 (message_content);
#line 704 "../src/Composer.vala"
					message_content = _tmp188_;
#line 704 "../src/Composer.vala"
					_g_free0 (_tmp187_);
#line 704 "../src/Composer.vala"
					_g_free0 (_tmp185_);
#line 705 "../src/Composer.vala"
					_tmp189_ = message_content;
#line 705 "../src/Composer.vala"
					_tmp190_ = camel_message_info_get_date_received (info);
#line 705 "../src/Composer.vala"
					_tmp191_ = _tmp190_;
#line 705 "../src/Composer.vala"
					_tmp192_ = g_date_time_new_from_unix_utc (_tmp191_);
#line 705 "../src/Composer.vala"
					_tmp193_ = _tmp192_;
#line 705 "../src/Composer.vala"
					_tmp194_ = date_format;
#line 705 "../src/Composer.vala"
					_tmp195_ = g_date_time_format (_tmp193_, _tmp194_);
#line 705 "../src/Composer.vala"
					_tmp196_ = _tmp195_;
#line 705 "../src/Composer.vala"
					_tmp197_ = g_strdup_printf (_ ("Date: %s<br/>"), _tmp196_);
#line 705 "../src/Composer.vala"
					_tmp198_ = _tmp197_;
#line 705 "../src/Composer.vala"
					_tmp199_ = g_strconcat (_tmp189_, _tmp198_, NULL);
#line 705 "../src/Composer.vala"
					_g_free0 (message_content);
#line 705 "../src/Composer.vala"
					message_content = _tmp199_;
#line 705 "../src/Composer.vala"
					_g_free0 (_tmp198_);
#line 705 "../src/Composer.vala"
					_g_free0 (_tmp196_);
#line 705 "../src/Composer.vala"
					_g_date_time_unref0 (_tmp193_);
#line 706 "../src/Composer.vala"
					_tmp200_ = message_content;
#line 706 "../src/Composer.vala"
					_tmp201_ = camel_message_info_get_to (info);
#line 706 "../src/Composer.vala"
					_tmp202_ = _tmp201_;
#line 706 "../src/Composer.vala"
					_tmp203_ = mail_utils_escape_html_tags (_tmp202_);
#line 706 "../src/Composer.vala"
					_tmp204_ = _tmp203_;
#line 706 "../src/Composer.vala"
					_tmp205_ = g_strdup_printf (_ ("To: %s<br/>"), _tmp204_);
#line 706 "../src/Composer.vala"
					_tmp206_ = _tmp205_;
#line 706 "../src/Composer.vala"
					_tmp207_ = g_strconcat (_tmp200_, _tmp206_, NULL);
#line 706 "../src/Composer.vala"
					_g_free0 (message_content);
#line 706 "../src/Composer.vala"
					message_content = _tmp207_;
#line 706 "../src/Composer.vala"
					_g_free0 (_tmp206_);
#line 706 "../src/Composer.vala"
					_g_free0 (_tmp204_);
#line 707 "../src/Composer.vala"
					_tmp209_ = camel_message_info_get_cc (info);
#line 707 "../src/Composer.vala"
					_tmp210_ = _tmp209_;
#line 707 "../src/Composer.vala"
					if (_tmp210_ != NULL) {
#line 3387 "Composer.c"
						const gchar* _tmp211_;
						const gchar* _tmp212_;
#line 707 "../src/Composer.vala"
						_tmp211_ = camel_message_info_get_cc (info);
#line 707 "../src/Composer.vala"
						_tmp212_ = _tmp211_;
#line 707 "../src/Composer.vala"
						_tmp208_ = g_strcmp0 (_tmp212_, "") != 0;
#line 3396 "Composer.c"
					} else {
#line 707 "../src/Composer.vala"
						_tmp208_ = FALSE;
#line 3400 "Composer.c"
					}
#line 707 "../src/Composer.vala"
					if (_tmp208_) {
#line 3404 "Composer.c"
						const gchar* _tmp213_;
						const gchar* _tmp214_;
						const gchar* _tmp215_;
						gchar* _tmp216_;
						gchar* _tmp217_;
						gchar* _tmp218_;
						gchar* _tmp219_;
						gchar* _tmp220_;
#line 708 "../src/Composer.vala"
						_tmp213_ = message_content;
#line 708 "../src/Composer.vala"
						_tmp214_ = camel_message_info_get_cc (info);
#line 708 "../src/Composer.vala"
						_tmp215_ = _tmp214_;
#line 708 "../src/Composer.vala"
						_tmp216_ = mail_utils_escape_html_tags (_tmp215_);
#line 708 "../src/Composer.vala"
						_tmp217_ = _tmp216_;
#line 708 "../src/Composer.vala"
						_tmp218_ = g_strdup_printf (_ ("Cc: %s<br/>"), _tmp217_);
#line 708 "../src/Composer.vala"
						_tmp219_ = _tmp218_;
#line 708 "../src/Composer.vala"
						_tmp220_ = g_strconcat (_tmp213_, _tmp219_, NULL);
#line 708 "../src/Composer.vala"
						_g_free0 (message_content);
#line 708 "../src/Composer.vala"
						message_content = _tmp220_;
#line 708 "../src/Composer.vala"
						_g_free0 (_tmp219_);
#line 708 "../src/Composer.vala"
						_g_free0 (_tmp217_);
#line 3437 "Composer.c"
					}
#line 711 "../src/Composer.vala"
					_tmp221_ = message_content;
#line 711 "../src/Composer.vala"
					_tmp222_ = g_strconcat (_tmp221_, "<br/><br/>", NULL);
#line 711 "../src/Composer.vala"
					_g_free0 (message_content);
#line 711 "../src/Composer.vala"
					message_content = _tmp222_;
#line 712 "../src/Composer.vala"
					_tmp223_ = message_content;
#line 712 "../src/Composer.vala"
					_tmp224_ = g_strconcat (_tmp223_, content_to_quote, NULL);
#line 712 "../src/Composer.vala"
					_g_free0 (message_content);
#line 712 "../src/Composer.vala"
					message_content = _tmp224_;
#line 714 "../src/Composer.vala"
					if (camel_mime_message_has_attachment (message)) {
#line 3457 "Composer.c"
						CamelDataWrapper* _tmp225_;
						CamelDataWrapper* _tmp226_;
#line 715 "../src/Composer.vala"
						_tmp225_ = camel_medium_get_content ((CamelMedium*) message);
#line 715 "../src/Composer.vala"
						_tmp226_ = _tmp225_;
#line 715 "../src/Composer.vala"
						mail_composer_get_attachments (self, _tmp226_, NULL, NULL);
#line 3466 "Composer.c"
					}
				}
			}
#line 719 "../src/Composer.vala"
			_tmp227_ = self->priv->web_view;
#line 719 "../src/Composer.vala"
			_tmp228_ = message_content;
#line 719 "../src/Composer.vala"
			mail_web_view_set_content_of_element (_tmp227_, "#elementary-message-quote", _tmp228_);
#line 631 "../src/Composer.vala"
			_g_free0 (date_format);
#line 631 "../src/Composer.vala"
			_g_free0 (message_content);
#line 3480 "Composer.c"
		}
	}
}

static void
mail_composer_get_attachments_data_free (gpointer _data)
{
	MailComposerGetAttachmentsData* _data_;
	_data_ = _data;
#line 8 "../src/Composer.vala"
	_g_object_unref0 (_data_->message_content);
#line 8 "../src/Composer.vala"
	_g_object_unref0 (_data_->self);
#line 8 "../src/Composer.vala"
	g_slice_free (MailComposerGetAttachmentsData, _data_);
#line 3496 "Composer.c"
}

static void
mail_composer_get_attachments (MailComposer* self,
                               CamelDataWrapper* message_content,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	MailComposerGetAttachmentsData* _data_;
	MailComposer* _tmp0_;
	CamelDataWrapper* _tmp1_;
#line 8 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/Composer.vala"
	g_return_if_fail (message_content != NULL);
#line 8 "../src/Composer.vala"
	_data_ = g_slice_new0 (MailComposerGetAttachmentsData);
#line 8 "../src/Composer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 8 "../src/Composer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_composer_get_attachments_data_free);
#line 8 "../src/Composer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 8 "../src/Composer.vala"
	_data_->self = _tmp0_;
#line 8 "../src/Composer.vala"
	_tmp1_ = _g_object_ref0 (message_content);
#line 8 "../src/Composer.vala"
	_g_object_unref0 (_data_->message_content);
#line 8 "../src/Composer.vala"
	_data_->message_content = _tmp1_;
#line 8 "../src/Composer.vala"
	mail_composer_get_attachments_co (_data_);
#line 3530 "Composer.c"
}

static void
mail_composer_get_attachments_finish (MailComposer* self,
                                      GAsyncResult* _res_)
{
	MailComposerGetAttachmentsData* _data_;
#line 8 "../src/Composer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3540 "Composer.c"
}

static void
mail_composer_get_attachments_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	MailComposerGetAttachmentsData* _data_;
#line 739 "../src/Composer.vala"
	_data_ = _user_data_;
#line 739 "../src/Composer.vala"
	_data_->_source_object_ = source_object;
#line 739 "../src/Composer.vala"
	_data_->_res_ = _res_;
#line 739 "../src/Composer.vala"
	mail_composer_get_attachments_co (_data_);
#line 3557 "Composer.c"
}

static gboolean
mail_composer_get_attachments_co (MailComposerGetAttachmentsData* _data_)
{
#line 724 "../src/Composer.vala"
	switch (_data_->_state_) {
#line 724 "../src/Composer.vala"
		case 0:
#line 3567 "Composer.c"
		goto _state_0;
#line 724 "../src/Composer.vala"
		case 1:
#line 3571 "Composer.c"
		goto _state_1;
#line 724 "../src/Composer.vala"
		case 2:
#line 3575 "Composer.c"
		goto _state_2;
#line 724 "../src/Composer.vala"
		case 3:
#line 3579 "Composer.c"
		goto _state_3;
		default:
#line 724 "../src/Composer.vala"
		g_assert_not_reached ();
#line 3584 "Composer.c"
	}
	_state_0:
#line 725 "../src/Composer.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->message_content, camel_multipart_get_type ())) {
#line 726 "../src/Composer.vala"
		_data_->tmp_dir = NULL;
#line 727 "../src/Composer.vala"
		_data_->content = G_TYPE_CHECK_INSTANCE_CAST (_data_->message_content, camel_multipart_get_type (), CamelMultipart);
#line 3593 "Composer.c"
		{
#line 728 "../src/Composer.vala"
			_data_->i = (guint) 0;
#line 3597 "Composer.c"
			{
#line 728 "../src/Composer.vala"
				_data_->_tmp0_ = TRUE;
#line 728 "../src/Composer.vala"
				while (TRUE) {
#line 728 "../src/Composer.vala"
					if (!_data_->_tmp0_) {
#line 728 "../src/Composer.vala"
						_data_->_tmp1_ = _data_->i;
#line 728 "../src/Composer.vala"
						_data_->i = _data_->_tmp1_ + 1;
#line 3609 "Composer.c"
					}
#line 728 "../src/Composer.vala"
					_data_->_tmp0_ = FALSE;
#line 728 "../src/Composer.vala"
					_data_->_tmp2_ = _data_->content;
#line 728 "../src/Composer.vala"
					if (!(_data_->i < camel_multipart_get_number (_data_->_tmp2_))) {
#line 728 "../src/Composer.vala"
						break;
#line 3619 "Composer.c"
					}
#line 729 "../src/Composer.vala"
					_data_->_tmp3_ = _data_->content;
#line 729 "../src/Composer.vala"
					_data_->_tmp4_ = camel_multipart_get_part (_data_->_tmp3_, _data_->i);
#line 729 "../src/Composer.vala"
					_data_->part = _data_->_tmp4_;
#line 730 "../src/Composer.vala"
					_data_->_tmp5_ = _data_->part;
#line 730 "../src/Composer.vala"
					_data_->_tmp6_ = camel_data_wrapper_get_mime_type_field ((CamelDataWrapper*) _data_->_tmp5_);
#line 730 "../src/Composer.vala"
					_data_->field = _data_->_tmp6_;
#line 731 "../src/Composer.vala"
					_data_->_tmp7_ = _data_->part;
#line 731 "../src/Composer.vala"
					_data_->_tmp8_ = camel_mime_part_get_content_disposition (_data_->_tmp7_);
#line 731 "../src/Composer.vala"
					_data_->_tmp9_ = _data_->part;
#line 731 "../src/Composer.vala"
					_data_->_tmp10_ = camel_mime_part_get_content_type (_data_->_tmp9_);
#line 731 "../src/Composer.vala"
					if (camel_content_disposition_is_attachment (_data_->_tmp8_, _data_->_tmp10_)) {
#line 3643 "Composer.c"
						{
#line 733 "../src/Composer.vala"
							_data_->_tmp11_ = _data_->tmp_dir;
#line 733 "../src/Composer.vala"
							if (_data_->_tmp11_ == NULL) {
#line 734 "../src/Composer.vala"
								_data_->_tmp13_ = g_dir_make_tmp (".XXXXXX", &_data_->_inner_error0_);
#line 734 "../src/Composer.vala"
								_data_->_tmp12_ = _data_->_tmp13_;
#line 734 "../src/Composer.vala"
								if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3655 "Composer.c"
									goto __catch0_g_error;
								}
#line 734 "../src/Composer.vala"
								_data_->_tmp14_ = g_file_new_for_path (_data_->_tmp12_);
#line 734 "../src/Composer.vala"
								_g_object_unref0 (_data_->tmp_dir);
#line 734 "../src/Composer.vala"
								_data_->tmp_dir = _data_->_tmp14_;
#line 733 "../src/Composer.vala"
								_g_free0 (_data_->_tmp12_);
#line 3666 "Composer.c"
							}
#line 737 "../src/Composer.vala"
							_data_->_tmp15_ = _data_->tmp_dir;
#line 737 "../src/Composer.vala"
							_data_->_tmp16_ = _data_->part;
#line 737 "../src/Composer.vala"
							_data_->_tmp17_ = camel_mime_part_get_filename (_data_->_tmp16_);
#line 737 "../src/Composer.vala"
							_data_->_tmp18_ = g_file_get_child (_data_->_tmp15_, _data_->_tmp17_);
#line 737 "../src/Composer.vala"
							_data_->file = _data_->_tmp18_;
#line 738 "../src/Composer.vala"
							_data_->_tmp19_ = _data_->file;
#line 738 "../src/Composer.vala"
							if (!g_file_query_exists (_data_->_tmp19_, NULL)) {
#line 739 "../src/Composer.vala"
								_data_->_tmp20_ = _data_->file;
#line 739 "../src/Composer.vala"
								_data_->_state_ = 1;
#line 739 "../src/Composer.vala"
								g_file_create_async (_data_->_tmp20_, G_FILE_CREATE_NONE, G_PRIORITY_DEFAULT, NULL, mail_composer_get_attachments_ready, _data_);
#line 739 "../src/Composer.vala"
								return FALSE;
#line 3690 "Composer.c"
								_state_1:
#line 739 "../src/Composer.vala"
								_data_->_tmp21_ = g_file_create_finish (_data_->_tmp20_, _data_->_res_, &_data_->_inner_error0_);
#line 739 "../src/Composer.vala"
								_data_->output_stream = _data_->_tmp21_;
#line 739 "../src/Composer.vala"
								if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 739 "../src/Composer.vala"
									_g_object_unref0 (_data_->file);
#line 3700 "Composer.c"
									goto __catch0_g_error;
								}
#line 740 "../src/Composer.vala"
								_data_->_tmp22_ = _data_->part;
#line 740 "../src/Composer.vala"
								_data_->_tmp23_ = camel_medium_get_content ((CamelMedium*) _data_->_tmp22_);
#line 740 "../src/Composer.vala"
								_data_->_tmp24_ = _data_->_tmp23_;
#line 740 "../src/Composer.vala"
								_data_->_tmp25_ = _data_->output_stream;
#line 740 "../src/Composer.vala"
								_data_->_state_ = 2;
#line 740 "../src/Composer.vala"
								camel_data_wrapper_decode_to_output_stream (_data_->_tmp24_, (GOutputStream*) _data_->_tmp25_, G_PRIORITY_DEFAULT, NULL, mail_composer_get_attachments_ready, _data_);
#line 740 "../src/Composer.vala"
								return FALSE;
#line 3717 "Composer.c"
								_state_2:
#line 740 "../src/Composer.vala"
								camel_data_wrapper_decode_to_output_stream_finish (_data_->_tmp24_, _data_->_res_, &_data_->_inner_error0_);
#line 740 "../src/Composer.vala"
								if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 740 "../src/Composer.vala"
									_g_object_unref0 (_data_->output_stream);
#line 740 "../src/Composer.vala"
									_g_object_unref0 (_data_->file);
#line 3727 "Composer.c"
									goto __catch0_g_error;
								}
#line 738 "../src/Composer.vala"
								_g_object_unref0 (_data_->output_stream);
#line 3732 "Composer.c"
							}
#line 743 "../src/Composer.vala"
							_data_->_tmp26_ = _data_->self->priv->attachment_box;
#line 743 "../src/Composer.vala"
							_data_->_tmp27_ = _data_->file;
#line 743 "../src/Composer.vala"
							_data_->_tmp28_ = mail_composer_attachment_new (_data_->_tmp27_, MAIL_COMPOSER_ATTACHMENT_DISPOSITION_ATTACHMENT);
#line 743 "../src/Composer.vala"
							g_object_ref_sink (_data_->_tmp28_);
#line 743 "../src/Composer.vala"
							_data_->_tmp29_ = _data_->_tmp28_;
#line 743 "../src/Composer.vala"
							gtk_container_add ((GtkContainer*) _data_->_tmp26_, (GtkWidget*) _data_->_tmp29_);
#line 743 "../src/Composer.vala"
							_g_object_unref0 (_data_->_tmp29_);
#line 744 "../src/Composer.vala"
							_data_->_tmp30_ = _data_->self->priv->attachment_box;
#line 744 "../src/Composer.vala"
							gtk_widget_show_all ((GtkWidget*) _data_->_tmp30_);
#line 732 "../src/Composer.vala"
							_g_object_unref0 (_data_->file);
#line 3754 "Composer.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
#line 732 "../src/Composer.vala"
							_data_->e = _data_->_inner_error0_;
#line 732 "../src/Composer.vala"
							_data_->_inner_error0_ = NULL;
#line 746 "../src/Composer.vala"
							_data_->_tmp31_ = _data_->e;
#line 746 "../src/Composer.vala"
							_data_->_tmp32_ = _data_->_tmp31_->message;
#line 746 "../src/Composer.vala"
							g_critical ("Composer.vala:746: %s", _data_->_tmp32_);
#line 732 "../src/Composer.vala"
							_g_error_free0 (_data_->e);
#line 3771 "Composer.c"
						}
						__finally0:
#line 732 "../src/Composer.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 732 "../src/Composer.vala"
							_g_object_unref0 (_data_->tmp_dir);
#line 732 "../src/Composer.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 732 "../src/Composer.vala"
							g_clear_error (&_data_->_inner_error0_);
#line 732 "../src/Composer.vala"
							g_object_unref (_data_->_async_result);
#line 732 "../src/Composer.vala"
							return FALSE;
#line 3786 "Composer.c"
						}
					} else {
#line 748 "../src/Composer.vala"
						_data_->_tmp33_ = _data_->field;
#line 748 "../src/Composer.vala"
						_data_->_tmp34_ = _data_->_tmp33_->type;
#line 748 "../src/Composer.vala"
						if (g_strcmp0 (_data_->_tmp34_, "multipart") == 0) {
#line 749 "../src/Composer.vala"
							_data_->_tmp35_ = _data_->part;
#line 749 "../src/Composer.vala"
							_data_->_tmp36_ = camel_medium_get_content ((CamelMedium*) _data_->_tmp35_);
#line 749 "../src/Composer.vala"
							_data_->_tmp37_ = _data_->_tmp36_;
#line 749 "../src/Composer.vala"
							_data_->_state_ = 3;
#line 749 "../src/Composer.vala"
							mail_composer_get_attachments (_data_->self, _data_->_tmp37_, mail_composer_get_attachments_ready, _data_);
#line 749 "../src/Composer.vala"
							return FALSE;
#line 3807 "Composer.c"
							_state_3:
#line 749 "../src/Composer.vala"
							mail_composer_get_attachments_finish (_data_->self, _data_->_res_);
#line 3811 "Composer.c"
						}
					}
				}
			}
		}
#line 725 "../src/Composer.vala"
		_g_object_unref0 (_data_->tmp_dir);
#line 3819 "Composer.c"
	}
#line 724 "../src/Composer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 724 "../src/Composer.vala"
	if (_data_->_state_ != 0) {
#line 724 "../src/Composer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 724 "../src/Composer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3829 "Composer.c"
		}
	}
#line 724 "../src/Composer.vala"
	g_object_unref (_data_->_async_result);
#line 724 "../src/Composer.vala"
	return FALSE;
#line 3836 "Composer.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 755 "../src/Composer.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 755 "../src/Composer.vala"
	return _data10_;
#line 3846 "Composer.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 755 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 3856 "Composer.c"
		MailComposer* self;
#line 755 "../src/Composer.vala"
		self = _data10_->self;
#line 755 "../src/Composer.vala"
		_g_object_unref0 (_data10_->discard_dialog);
#line 755 "../src/Composer.vala"
		_g_object_unref0 (self);
#line 755 "../src/Composer.vala"
		g_slice_free (Block10Data, _data10_);
#line 3866 "Composer.c"
	}
}

static void
__lambda91_ (Block10Data* _data10_,
             gint response)
{
	MailComposer* self;
#line 772 "../src/Composer.vala"
	self = _data10_->self;
#line 773 "../src/Composer.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 774 "../src/Composer.vala"
		self->priv->discard_draft = TRUE;
#line 775 "../src/Composer.vala"
		g_signal_emit (self, mail_composer_signals[MAIL_COMPOSER_FINISHED_SIGNAL], 0);
#line 776 "../src/Composer.vala"
		gtk_window_close ((GtkWindow*) self);
#line 3885 "Composer.c"
	}
#line 779 "../src/Composer.vala"
	gtk_widget_destroy ((GtkWidget*) _data10_->discard_dialog);
#line 3889 "Composer.c"
}

static void
___lambda91__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 772 "../src/Composer.vala"
	__lambda91_ (self, response_id);
#line 3899 "Composer.c"
}

static void
mail_composer_on_discard (MailComposer* self)
{
	Block10Data* _data10_;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	GThemedIcon* _tmp2_;
	GtkWindow* _tmp3_;
	GraniteMessageDialog* _tmp4_ = NULL;
	GraniteMessageDialog* _tmp5_;
	GtkWidget* discard_anyway = NULL;
	GtkWidget* _tmp6_;
	GtkWidget* _tmp7_;
	GtkStyleContext* _tmp8_;
#line 755 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 755 "../src/Composer.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 755 "../src/Composer.vala"
	_data10_->_ref_count_ = 1;
#line 755 "../src/Composer.vala"
	_data10_->self = g_object_ref (self);
#line 756 "../src/Composer.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("mail-drafts");
#line 756 "../src/Composer.vala"
	_tmp1_ = _tmp0_;
#line 756 "../src/Composer.vala"
	_tmp2_ = (GThemedIcon*) g_themed_icon_new ("edit-delete");
#line 756 "../src/Composer.vala"
	_tmp3_ = _g_object_ref0 ((GtkWindow*) self);
#line 756 "../src/Composer.vala"
	_tmp4_ = granite_message_dialog_new (_ ("Permanently delete this draft?"), _ ("You cannot undo this action, nor recover your draft once it has been d" \
"eleted."), (GIcon*) _tmp1_, GTK_BUTTONS_NONE);
#line 756 "../src/Composer.vala"
	granite_message_dialog_set_badge_icon (_tmp4_, (GIcon*) _tmp2_);
#line 756 "../src/Composer.vala"
	_g_object_unref0 (_tmp2_);
#line 756 "../src/Composer.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp4_, _tmp3_);
#line 756 "../src/Composer.vala"
	_g_object_unref0 (_tmp3_);
#line 756 "../src/Composer.vala"
	g_object_ref_sink (_tmp4_);
#line 756 "../src/Composer.vala"
	_tmp5_ = _tmp4_;
#line 756 "../src/Composer.vala"
	_g_object_unref0 (_tmp1_);
#line 756 "../src/Composer.vala"
	_data10_->discard_dialog = _tmp5_;
#line 766 "../src/Composer.vala"
	gtk_dialog_add_button ((GtkDialog*) _data10_->discard_dialog, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 768 "../src/Composer.vala"
	_tmp6_ = gtk_dialog_add_button ((GtkDialog*) _data10_->discard_dialog, _ ("Delete Draft"), (gint) GTK_RESPONSE_ACCEPT);
#line 768 "../src/Composer.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 768 "../src/Composer.vala"
	discard_anyway = _tmp7_;
#line 769 "../src/Composer.vala"
	_tmp8_ = gtk_widget_get_style_context (discard_anyway);
#line 769 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp8_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 771 "../src/Composer.vala"
	gtk_window_present ((GtkWindow*) _data10_->discard_dialog);
#line 772 "../src/Composer.vala"
	g_signal_connect_data ((GtkDialog*) _data10_->discard_dialog, "response", (GCallback) ___lambda91__gtk_dialog_response, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 755 "../src/Composer.vala"
	_g_object_unref0 (discard_anyway);
#line 755 "../src/Composer.vala"
	block10_data_unref (_data10_);
#line 755 "../src/Composer.vala"
	_data10_ = NULL;
#line 3972 "Composer.c"
}

static void
mail_composer_on_send (MailComposer* self)
{
#line 783 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 784 "../src/Composer.vala"
	mail_composer_send_message (self, NULL, NULL);
#line 3982 "Composer.c"
}

static void
mail_composer_send_message_data_free (gpointer _data)
{
	MailComposerSendMessageData* _data_;
	_data_ = _data;
#line 8 "../src/Composer.vala"
	_g_object_unref0 (_data_->self);
#line 8 "../src/Composer.vala"
	g_slice_free (MailComposerSendMessageData, _data_);
#line 3994 "Composer.c"
}

static void
mail_composer_send_message (MailComposer* self,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	MailComposerSendMessageData* _data_;
	MailComposer* _tmp0_;
#line 8 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/Composer.vala"
	_data_ = g_slice_new0 (MailComposerSendMessageData);
#line 8 "../src/Composer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 8 "../src/Composer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_composer_send_message_data_free);
#line 8 "../src/Composer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 8 "../src/Composer.vala"
	_data_->self = _tmp0_;
#line 8 "../src/Composer.vala"
	mail_composer_send_message_co (_data_);
#line 4018 "Composer.c"
}

static void
mail_composer_send_message_finish (MailComposer* self,
                                   GAsyncResult* _res_)
{
	MailComposerSendMessageData* _data_;
#line 8 "../src/Composer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4028 "Composer.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 787 "../src/Composer.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 787 "../src/Composer.vala"
	return _data11_;
#line 4038 "Composer.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 787 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 4048 "Composer.c"
		MailComposer* self;
#line 787 "../src/Composer.vala"
		self = _data11_->self;
#line 787 "../src/Composer.vala"
		_g_object_unref0 (self);
#line 787 "../src/Composer.vala"
		g_slice_free (Block11Data, _data11_);
#line 4056 "Composer.c"
	}
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 790 "../src/Composer.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 790 "../src/Composer.vala"
	return _data12_;
#line 4067 "Composer.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 790 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 4077 "Composer.c"
		MailComposer* self;
#line 790 "../src/Composer.vala"
		self = _data12_->_data11_->self;
#line 790 "../src/Composer.vala"
		_g_object_unref0 (_data12_->no_subject_dialog);
#line 790 "../src/Composer.vala"
		block11_data_unref (_data12_->_data11_);
#line 790 "../src/Composer.vala"
		_data12_->_data11_ = NULL;
#line 790 "../src/Composer.vala"
		g_slice_free (Block12Data, _data12_);
#line 4089 "Composer.c"
	}
}

static void
___lambda92_ (Block12Data* _data12_,
              gint response)
{
	Block11Data* _data11_;
	MailComposer* self;
	GraniteMessageDialog* _tmp0_;
#line 806 "../src/Composer.vala"
	_data11_ = _data12_->_data11_;
#line 806 "../src/Composer.vala"
	self = _data11_->self;
#line 807 "../src/Composer.vala"
	_tmp0_ = _data12_->no_subject_dialog;
#line 807 "../src/Composer.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 809 "../src/Composer.vala"
	if (response == ((gint) GTK_RESPONSE_CANCEL)) {
#line 810 "../src/Composer.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
#line 811 "../src/Composer.vala"
		return;
#line 4114 "Composer.c"
	}
#line 814 "../src/Composer.vala"
	mail_composer_send_message_co (_data11_->_async_data_);
#line 4118 "Composer.c"
}

static void
____lambda92__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 806 "../src/Composer.vala"
	___lambda92_ (self, response_id);
#line 4128 "Composer.c"
}

static void
mail_composer_send_message_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	MailComposerSendMessageData* _data_;
#line 821 "../src/Composer.vala"
	_data_ = _user_data_;
#line 821 "../src/Composer.vala"
	_data_->_source_object_ = source_object;
#line 821 "../src/Composer.vala"
	_data_->_res_ = _res_;
#line 821 "../src/Composer.vala"
	mail_composer_send_message_co (_data_);
#line 4145 "Composer.c"
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 831 "../src/Composer.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 831 "../src/Composer.vala"
	return _data13_;
#line 4155 "Composer.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 831 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 4165 "Composer.c"
		MailComposer* self;
#line 831 "../src/Composer.vala"
		self = _data13_->_data11_->self;
#line 831 "../src/Composer.vala"
		_g_object_unref0 (_data13_->warning_dialog);
#line 831 "../src/Composer.vala"
		block11_data_unref (_data13_->_data11_);
#line 831 "../src/Composer.vala"
		_data13_->_data11_ = NULL;
#line 831 "../src/Composer.vala"
		g_slice_free (Block13Data, _data13_);
#line 4177 "Composer.c"
	}
}

static void
____lambda96_ (Block13Data* _data13_)
{
	Block11Data* _data11_;
	MailComposer* self;
	GraniteMessageDialog* _tmp0_;
#line 841 "../src/Composer.vala"
	_data11_ = _data13_->_data11_;
#line 841 "../src/Composer.vala"
	self = _data11_->self;
#line 841 "../src/Composer.vala"
	_tmp0_ = _data13_->warning_dialog;
#line 841 "../src/Composer.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 4195 "Composer.c"
}

static void
_____lambda96__gtk_dialog_response (GtkDialog* _sender,
                                    gint response_id,
                                    gpointer self)
{
#line 841 "../src/Composer.vala"
	____lambda96_ (self);
#line 4205 "Composer.c"
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 828 "../src/Composer.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 828 "../src/Composer.vala"
	return _data14_;
#line 4215 "Composer.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 828 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 4225 "Composer.c"
		MailComposer* self;
#line 828 "../src/Composer.vala"
		self = _data14_->_data11_->self;
#line 828 "../src/Composer.vala"
		_g_object_unref0 (_data14_->error_dialog);
#line 828 "../src/Composer.vala"
		block11_data_unref (_data14_->_data11_);
#line 828 "../src/Composer.vala"
		_data14_->_data11_ = NULL;
#line 828 "../src/Composer.vala"
		g_slice_free (Block14Data, _data14_);
#line 4237 "Composer.c"
	}
}

static void
___lambda97_ (Block14Data* _data14_)
{
	Block11Data* _data11_;
	MailComposer* self;
	GraniteMessageDialog* _tmp0_;
#line 858 "../src/Composer.vala"
	_data11_ = _data14_->_data11_;
#line 858 "../src/Composer.vala"
	self = _data11_->self;
#line 858 "../src/Composer.vala"
	_tmp0_ = _data14_->error_dialog;
#line 858 "../src/Composer.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 4255 "Composer.c"
}

static void
____lambda97__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 858 "../src/Composer.vala"
	___lambda97_ (self);
#line 4265 "Composer.c"
}

static gboolean
mail_composer_send_message_co (MailComposerSendMessageData* _data_)
{
#line 787 "../src/Composer.vala"
	switch (_data_->_state_) {
#line 787 "../src/Composer.vala"
		case 0:
#line 4275 "Composer.c"
		goto _state_0;
#line 787 "../src/Composer.vala"
		case 1:
#line 4279 "Composer.c"
		goto _state_1;
#line 787 "../src/Composer.vala"
		case 2:
#line 4283 "Composer.c"
		goto _state_2;
#line 787 "../src/Composer.vala"
		case 3:
#line 4287 "Composer.c"
		goto _state_3;
		default:
#line 787 "../src/Composer.vala"
		g_assert_not_reached ();
#line 4292 "Composer.c"
	}
	_state_0:
#line 787 "../src/Composer.vala"
	_data_->_data11_ = g_slice_new0 (Block11Data);
#line 787 "../src/Composer.vala"
	_data_->_data11_->_ref_count_ = 1;
#line 787 "../src/Composer.vala"
	_data_->_data11_->self = g_object_ref (_data_->self);
#line 787 "../src/Composer.vala"
	_data_->_data11_->_async_data_ = _data_;
#line 788 "../src/Composer.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _data_->self, FALSE);
#line 790 "../src/Composer.vala"
	_data_->_tmp0_ = _data_->self->priv->subject_val;
#line 790 "../src/Composer.vala"
	_data_->_tmp1_ = gtk_entry_get_text (_data_->_tmp0_);
#line 790 "../src/Composer.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 790 "../src/Composer.vala"
	if (g_strcmp0 (_data_->_tmp2_, "") == 0) {
#line 790 "../src/Composer.vala"
		_data_->_data12_ = g_slice_new0 (Block12Data);
#line 790 "../src/Composer.vala"
		_data_->_data12_->_ref_count_ = 1;
#line 790 "../src/Composer.vala"
		_data_->_data12_->_data11_ = block11_data_ref (_data_->_data11_);
#line 791 "../src/Composer.vala"
		_data_->_tmp3_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Send without subject?"), _ ("This message has an empty subject field. The recipient may be unable t" \
"o infer its scope or importance."), "mail-send", GTK_BUTTONS_NONE);
#line 791 "../src/Composer.vala"
		g_object_ref_sink (_data_->_tmp3_);
#line 791 "../src/Composer.vala"
		_data_->_data12_->no_subject_dialog = _data_->_tmp3_;
#line 797 "../src/Composer.vala"
		_data_->_tmp4_ = _data_->_data12_->no_subject_dialog;
#line 797 "../src/Composer.vala"
		gtk_window_set_modal ((GtkWindow*) _data_->_tmp4_, TRUE);
#line 798 "../src/Composer.vala"
		_data_->_tmp5_ = _data_->_data12_->no_subject_dialog;
#line 798 "../src/Composer.vala"
		gtk_window_set_transient_for ((GtkWindow*) _data_->_tmp5_, (GtkWindow*) _data_->self);
#line 800 "../src/Composer.vala"
		_data_->_tmp6_ = _data_->_data12_->no_subject_dialog;
#line 800 "../src/Composer.vala"
		gtk_dialog_add_button ((GtkDialog*) _data_->_tmp6_, _ ("Don't Send"), (gint) GTK_RESPONSE_CANCEL);
#line 802 "../src/Composer.vala"
		_data_->_tmp7_ = _data_->_data12_->no_subject_dialog;
#line 802 "../src/Composer.vala"
		_data_->_tmp8_ = gtk_dialog_add_button ((GtkDialog*) _data_->_tmp7_, _ ("Send Anyway"), (gint) GTK_RESPONSE_ACCEPT);
#line 802 "../src/Composer.vala"
		_data_->_tmp9_ = _g_object_ref0 (_data_->_tmp8_);
#line 802 "../src/Composer.vala"
		_data_->send_anyway = _data_->_tmp9_;
#line 803 "../src/Composer.vala"
		_data_->_tmp10_ = _data_->send_anyway;
#line 803 "../src/Composer.vala"
		_data_->_tmp11_ = gtk_widget_get_style_context (_data_->_tmp10_);
#line 803 "../src/Composer.vala"
		gtk_style_context_add_class (_data_->_tmp11_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 805 "../src/Composer.vala"
		_data_->_tmp12_ = _data_->_data12_->no_subject_dialog;
#line 805 "../src/Composer.vala"
		gtk_window_present ((GtkWindow*) _data_->_tmp12_);
#line 806 "../src/Composer.vala"
		_data_->_tmp13_ = _data_->_data12_->no_subject_dialog;
#line 806 "../src/Composer.vala"
		g_signal_connect_data ((GtkDialog*) _data_->_tmp13_, "response", (GCallback) ____lambda92__gtk_dialog_response, block12_data_ref (_data_->_data12_), (GClosureNotify) block12_data_unref, 0);
#line 817 "../src/Composer.vala"
		_data_->_state_ = 1;
#line 817 "../src/Composer.vala"
		return FALSE;
#line 4363 "Composer.c"
		_state_1:
		;
#line 790 "../src/Composer.vala"
		_g_object_unref0 (_data_->send_anyway);
#line 790 "../src/Composer.vala"
		block12_data_unref (_data_->_data12_);
#line 790 "../src/Composer.vala"
		_data_->_data12_ = NULL;
#line 4372 "Composer.c"
	}
#line 820 "../src/Composer.vala"
	_data_->_tmp14_ = mail_backend_session_get_default ();
#line 820 "../src/Composer.vala"
	_data_->session = _data_->_tmp14_;
#line 821 "../src/Composer.vala"
	_data_->_tmp15_ = _data_->self->priv->web_view;
#line 821 "../src/Composer.vala"
	_data_->_state_ = 2;
#line 821 "../src/Composer.vala"
	mail_web_view_get_body_html (_data_->_tmp15_, TRUE, mail_composer_send_message_ready, _data_);
#line 821 "../src/Composer.vala"
	return FALSE;
#line 4386 "Composer.c"
	_state_2:
#line 821 "../src/Composer.vala"
	_data_->_tmp16_ = mail_web_view_get_body_html_finish (_data_->_tmp15_, _data_->_res_);
#line 821 "../src/Composer.vala"
	_data_->body_html = _data_->_tmp16_;
#line 822 "../src/Composer.vala"
	_data_->_tmp17_ = mail_composer_build_message (_data_->self, _data_->body_html);
#line 822 "../src/Composer.vala"
	_data_->message = _data_->_tmp17_;
#line 823 "../src/Composer.vala"
	_data_->_tmp18_ = _data_->self->priv->from_combo;
#line 823 "../src/Composer.vala"
	_data_->_tmp19_ = gtk_combo_box_text_get_active_text (_data_->_tmp18_);
#line 823 "../src/Composer.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 823 "../src/Composer.vala"
	_data_->_tmp21_ = mail_composer_build_sender (_data_->self, _data_->message, _data_->_tmp20_);
#line 823 "../src/Composer.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 823 "../src/Composer.vala"
	_g_free0 (_data_->_tmp20_);
#line 823 "../src/Composer.vala"
	_data_->sender = _data_->_tmp22_;
#line 824 "../src/Composer.vala"
	_data_->_tmp23_ = _data_->self->priv->to_val;
#line 824 "../src/Composer.vala"
	_data_->_tmp24_ = gtk_entry_get_text (_data_->_tmp23_);
#line 824 "../src/Composer.vala"
	_data_->_tmp25_ = _data_->_tmp24_;
#line 824 "../src/Composer.vala"
	_data_->_tmp26_ = _data_->self->priv->cc_val;
#line 824 "../src/Composer.vala"
	_data_->_tmp27_ = gtk_entry_get_text (_data_->_tmp26_);
#line 824 "../src/Composer.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 824 "../src/Composer.vala"
	_data_->_tmp29_ = _data_->self->priv->bcc_val;
#line 824 "../src/Composer.vala"
	_data_->_tmp30_ = gtk_entry_get_text (_data_->_tmp29_);
#line 824 "../src/Composer.vala"
	_data_->_tmp31_ = _data_->_tmp30_;
#line 824 "../src/Composer.vala"
	_data_->_tmp32_ = mail_composer_build_recipients (_data_->self, _data_->message, _data_->_tmp25_, _data_->_tmp28_, _data_->_tmp31_);
#line 824 "../src/Composer.vala"
	_data_->recipients = _data_->_tmp32_;
#line 826 "../src/Composer.vala"
	mail_composer_remember_recipients (_data_->self, _data_->recipients, NULL, NULL);
#line 4434 "Composer.c"
	{
#line 829 "../src/Composer.vala"
		_data_->_state_ = 3;
#line 829 "../src/Composer.vala"
		mail_backend_session_send_email (_data_->session, _data_->message, _data_->sender, (CamelAddress*) _data_->recipients, mail_composer_send_message_ready, _data_);
#line 829 "../src/Composer.vala"
		return FALSE;
#line 4442 "Composer.c"
		_state_3:
#line 829 "../src/Composer.vala"
		_data_->sent_message_saved = mail_backend_session_send_email_finish (_data_->session, _data_->_res_, &_data_->_inner_error0_);
#line 829 "../src/Composer.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4448 "Composer.c"
			goto __catch0_g_error;
		}
#line 831 "../src/Composer.vala"
		if (!_data_->sent_message_saved) {
#line 831 "../src/Composer.vala"
			_data_->_data13_ = g_slice_new0 (Block13Data);
#line 831 "../src/Composer.vala"
			_data_->_data13_->_ref_count_ = 1;
#line 831 "../src/Composer.vala"
			_data_->_data13_->_data11_ = block11_data_ref (_data_->_data11_);
#line 832 "../src/Composer.vala"
			_data_->_tmp33_ = (GThemedIcon*) g_themed_icon_new ("mail-send");
#line 832 "../src/Composer.vala"
			_data_->_tmp34_ = _data_->_tmp33_;
#line 832 "../src/Composer.vala"
			_data_->_tmp35_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 832 "../src/Composer.vala"
			_data_->_tmp36_ = NULL;
#line 832 "../src/Composer.vala"
			_data_->_tmp36_ = granite_message_dialog_new (_ ("Sent message was not saved"), _ ("The message was sent, however a copy was not saved to the Sent message" \
" folder."), (GIcon*) _data_->_tmp34_, GTK_BUTTONS_CLOSE);
#line 832 "../src/Composer.vala"
			granite_message_dialog_set_badge_icon (_data_->_tmp36_, (GIcon*) _data_->_tmp35_);
#line 832 "../src/Composer.vala"
			_g_object_unref0 (_data_->_tmp35_);
#line 832 "../src/Composer.vala"
			g_object_ref_sink (_data_->_tmp36_);
#line 832 "../src/Composer.vala"
			_data_->_tmp37_ = _data_->_tmp36_;
#line 832 "../src/Composer.vala"
			_g_object_unref0 (_data_->_tmp34_);
#line 832 "../src/Composer.vala"
			_data_->_data13_->warning_dialog = _data_->_tmp37_;
#line 840 "../src/Composer.vala"
			_data_->_tmp38_ = _data_->_data13_->warning_dialog;
#line 840 "../src/Composer.vala"
			gtk_window_present ((GtkWindow*) _data_->_tmp38_);
#line 841 "../src/Composer.vala"
			_data_->_tmp39_ = _data_->_data13_->warning_dialog;
#line 841 "../src/Composer.vala"
			g_signal_connect_data ((GtkDialog*) _data_->_tmp39_, "response", (GCallback) _____lambda96__gtk_dialog_response, block13_data_ref (_data_->_data13_), (GClosureNotify) block13_data_unref, 0);
#line 831 "../src/Composer.vala"
			block13_data_unref (_data_->_data13_);
#line 831 "../src/Composer.vala"
			_data_->_data13_ = NULL;
#line 4493 "Composer.c"
		}
#line 844 "../src/Composer.vala"
		_data_->self->priv->discard_draft = TRUE;
#line 845 "../src/Composer.vala"
		g_signal_emit (_data_->self, mail_composer_signals[MAIL_COMPOSER_FINISHED_SIGNAL], 0);
#line 846 "../src/Composer.vala"
		gtk_window_close ((GtkWindow*) _data_->self);
#line 4501 "Composer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 828 "../src/Composer.vala"
		_data_->e = _data_->_inner_error0_;
#line 828 "../src/Composer.vala"
		_data_->_inner_error0_ = NULL;
#line 828 "../src/Composer.vala"
		_data_->_data14_ = g_slice_new0 (Block14Data);
#line 828 "../src/Composer.vala"
		_data_->_data14_->_ref_count_ = 1;
#line 828 "../src/Composer.vala"
		_data_->_data14_->_data11_ = block11_data_ref (_data_->_data11_);
#line 848 "../src/Composer.vala"
		_data_->_tmp40_ = (GThemedIcon*) g_themed_icon_new ("mail-send");
#line 848 "../src/Composer.vala"
		_data_->_tmp41_ = _data_->_tmp40_;
#line 848 "../src/Composer.vala"
		_data_->_tmp42_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 848 "../src/Composer.vala"
		_data_->_tmp43_ = NULL;
#line 848 "../src/Composer.vala"
		_data_->_tmp43_ = granite_message_dialog_new (_ ("Unable to send message"), _ ("There was an unexpected error while sending your message."), (GIcon*) _data_->_tmp41_, GTK_BUTTONS_CLOSE);
#line 848 "../src/Composer.vala"
		granite_message_dialog_set_badge_icon (_data_->_tmp43_, (GIcon*) _data_->_tmp42_);
#line 848 "../src/Composer.vala"
		_g_object_unref0 (_data_->_tmp42_);
#line 848 "../src/Composer.vala"
		g_object_ref_sink (_data_->_tmp43_);
#line 848 "../src/Composer.vala"
		_data_->_tmp44_ = _data_->_tmp43_;
#line 848 "../src/Composer.vala"
		_g_object_unref0 (_data_->_tmp41_);
#line 848 "../src/Composer.vala"
		_data_->_data14_->error_dialog = _data_->_tmp44_;
#line 856 "../src/Composer.vala"
		_data_->_tmp45_ = _data_->_data14_->error_dialog;
#line 856 "../src/Composer.vala"
		_data_->_tmp46_ = _data_->e;
#line 856 "../src/Composer.vala"
		_data_->_tmp47_ = _data_->_tmp46_->message;
#line 856 "../src/Composer.vala"
		granite_message_dialog_show_error_details (_data_->_tmp45_, _data_->_tmp47_);
#line 857 "../src/Composer.vala"
		_data_->_tmp48_ = _data_->_data14_->error_dialog;
#line 857 "../src/Composer.vala"
		gtk_window_present ((GtkWindow*) _data_->_tmp48_);
#line 858 "../src/Composer.vala"
		_data_->_tmp49_ = _data_->_data14_->error_dialog;
#line 858 "../src/Composer.vala"
		g_signal_connect_data ((GtkDialog*) _data_->_tmp49_, "response", (GCallback) ____lambda97__gtk_dialog_response, block14_data_ref (_data_->_data14_), (GClosureNotify) block14_data_unref, 0);
#line 828 "../src/Composer.vala"
		_g_error_free0 (_data_->e);
#line 828 "../src/Composer.vala"
		block14_data_unref (_data_->_data14_);
#line 828 "../src/Composer.vala"
		_data_->_data14_ = NULL;
#line 4560 "Composer.c"
	}
	__finally0:
	{
#line 860 "../src/Composer.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _data_->self, TRUE);
#line 4566 "Composer.c"
	}
#line 828 "../src/Composer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 828 "../src/Composer.vala"
		_g_object_unref0 (_data_->recipients);
#line 828 "../src/Composer.vala"
		_g_object_unref0 (_data_->sender);
#line 828 "../src/Composer.vala"
		_g_object_unref0 (_data_->message);
#line 828 "../src/Composer.vala"
		_g_free0 (_data_->body_html);
#line 828 "../src/Composer.vala"
		block11_data_unref (_data_->_data11_);
#line 828 "../src/Composer.vala"
		_data_->_data11_ = NULL;
#line 828 "../src/Composer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 828 "../src/Composer.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 828 "../src/Composer.vala"
		g_object_unref (_data_->_async_result);
#line 828 "../src/Composer.vala"
		return FALSE;
#line 4590 "Composer.c"
	}
#line 787 "../src/Composer.vala"
	_g_object_unref0 (_data_->recipients);
#line 787 "../src/Composer.vala"
	_g_object_unref0 (_data_->sender);
#line 787 "../src/Composer.vala"
	_g_object_unref0 (_data_->message);
#line 787 "../src/Composer.vala"
	_g_free0 (_data_->body_html);
#line 787 "../src/Composer.vala"
	block11_data_unref (_data_->_data11_);
#line 787 "../src/Composer.vala"
	_data_->_data11_ = NULL;
#line 787 "../src/Composer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 787 "../src/Composer.vala"
	if (_data_->_state_ != 0) {
#line 787 "../src/Composer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 787 "../src/Composer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4612 "Composer.c"
		}
	}
#line 787 "../src/Composer.vala"
	g_object_unref (_data_->_async_result);
#line 787 "../src/Composer.vala"
	return FALSE;
#line 4619 "Composer.c"
}

static CamelInternetAddress*
mail_composer_build_sender (MailComposer* self,
                            CamelMimeMessage* message,
                            const gchar* from)
{
	CamelInternetAddress* sender = NULL;
	CamelInternetAddress* _tmp0_;
	CamelInternetAddress* result;
#line 864 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 864 "../src/Composer.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 864 "../src/Composer.vala"
	g_return_val_if_fail (from != NULL, NULL);
#line 865 "../src/Composer.vala"
	_tmp0_ = camel_internet_address_new ();
#line 865 "../src/Composer.vala"
	sender = _tmp0_;
#line 866 "../src/Composer.vala"
	camel_address_unformat ((CamelAddress*) sender, from);
#line 867 "../src/Composer.vala"
	camel_mime_message_set_from (message, sender);
#line 869 "../src/Composer.vala"
	result = sender;
#line 869 "../src/Composer.vala"
	return result;
#line 4648 "Composer.c"
}

static CamelInternetAddress*
mail_composer_build_recipients (MailComposer* self,
                                CamelMimeMessage* message,
                                const gchar* to,
                                const gchar* cc,
                                const gchar* bcc)
{
	CamelInternetAddress* to_addresses = NULL;
	CamelInternetAddress* _tmp0_;
	CamelInternetAddress* cc_addresses = NULL;
	CamelInternetAddress* _tmp1_;
	CamelInternetAddress* bcc_addresses = NULL;
	CamelInternetAddress* _tmp2_;
	CamelInternetAddress* recipients = NULL;
	CamelInternetAddress* _tmp3_;
	CamelInternetAddress* result;
#line 872 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 872 "../src/Composer.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 872 "../src/Composer.vala"
	g_return_val_if_fail (to != NULL, NULL);
#line 872 "../src/Composer.vala"
	g_return_val_if_fail (cc != NULL, NULL);
#line 872 "../src/Composer.vala"
	g_return_val_if_fail (bcc != NULL, NULL);
#line 873 "../src/Composer.vala"
	_tmp0_ = camel_internet_address_new ();
#line 873 "../src/Composer.vala"
	to_addresses = _tmp0_;
#line 874 "../src/Composer.vala"
	camel_address_unformat ((CamelAddress*) to_addresses, to);
#line 875 "../src/Composer.vala"
	camel_mime_message_set_recipients (message, CAMEL_RECIPIENT_TYPE_TO, to_addresses);
#line 877 "../src/Composer.vala"
	_tmp1_ = camel_internet_address_new ();
#line 877 "../src/Composer.vala"
	cc_addresses = _tmp1_;
#line 878 "../src/Composer.vala"
	camel_address_unformat ((CamelAddress*) cc_addresses, cc);
#line 879 "../src/Composer.vala"
	camel_mime_message_set_recipients (message, CAMEL_RECIPIENT_TYPE_CC, cc_addresses);
#line 881 "../src/Composer.vala"
	_tmp2_ = camel_internet_address_new ();
#line 881 "../src/Composer.vala"
	bcc_addresses = _tmp2_;
#line 882 "../src/Composer.vala"
	camel_address_unformat ((CamelAddress*) bcc_addresses, bcc);
#line 883 "../src/Composer.vala"
	camel_mime_message_set_recipients (message, CAMEL_RECIPIENT_TYPE_BCC, bcc_addresses);
#line 885 "../src/Composer.vala"
	_tmp3_ = camel_internet_address_new ();
#line 885 "../src/Composer.vala"
	recipients = _tmp3_;
#line 886 "../src/Composer.vala"
	camel_address_cat ((CamelAddress*) recipients, (CamelAddress*) to_addresses);
#line 887 "../src/Composer.vala"
	camel_address_cat ((CamelAddress*) recipients, (CamelAddress*) cc_addresses);
#line 888 "../src/Composer.vala"
	camel_address_cat ((CamelAddress*) recipients, (CamelAddress*) bcc_addresses);
#line 890 "../src/Composer.vala"
	result = recipients;
#line 890 "../src/Composer.vala"
	_g_object_unref0 (bcc_addresses);
#line 890 "../src/Composer.vala"
	_g_object_unref0 (cc_addresses);
#line 890 "../src/Composer.vala"
	_g_object_unref0 (to_addresses);
#line 890 "../src/Composer.vala"
	return result;
#line 4721 "Composer.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 4758 "Composer.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 4764 "Composer.c"
}

static CamelMimeMessage*
mail_composer_build_message (MailComposer* self,
                             const gchar* body_html)
{
	CamelStreamMem* stream_mem = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
	CamelStreamMem* _tmp3_;
	CamelStreamFilter* stream_filter = NULL;
	CamelStreamMem* _tmp4_;
	CamelStreamFilter* _tmp5_;
	CamelDataWrapper* html = NULL;
	CamelDataWrapper* _tmp6_;
	CamelMimePart* part = NULL;
	CamelMimePart* _tmp12_;
	CamelMimePart* _tmp13_;
	CamelDataWrapper* _tmp14_;
	CamelMimePart* _tmp15_;
	CamelMultipart* body = NULL;
	CamelMultipart* _tmp16_;
	CamelMultipart* _tmp17_;
	CamelMultipart* _tmp18_;
	CamelMultipart* _tmp19_;
	CamelMimePart* _tmp20_;
	GtkFlowBox* _tmp21_;
	GList* _tmp22_;
	GList* _tmp23_;
	gboolean _tmp24_;
	CamelMimeMessage* message = NULL;
	CamelMimeMessage* _tmp33_;
	GtkEntry* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	CamelMultipart* _tmp37_;
	GError* _inner_error0_ = NULL;
	CamelMimeMessage* result;
#line 893 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 893 "../src/Composer.vala"
	g_return_val_if_fail (body_html != NULL, NULL);
#line 894 "../src/Composer.vala"
	_tmp0_ = string_get_data (body_html, &_tmp1_);
#line 894 "../src/Composer.vala"
	_tmp0__length1 = _tmp1_;
#line 894 "../src/Composer.vala"
	_tmp2_ = _tmp0_;
#line 894 "../src/Composer.vala"
	_tmp2__length1 = _tmp0__length1;
#line 894 "../src/Composer.vala"
	_tmp3_ = (CamelStreamMem*) camel_stream_mem_new_with_buffer (_tmp2_, _tmp2__length1);
#line 894 "../src/Composer.vala"
	stream_mem = _tmp3_;
#line 895 "../src/Composer.vala"
	_tmp4_ = stream_mem;
#line 895 "../src/Composer.vala"
	_tmp5_ = (CamelStreamFilter*) camel_stream_filter_new ((CamelStream*) _tmp4_);
#line 895 "../src/Composer.vala"
	stream_filter = _tmp5_;
#line 897 "../src/Composer.vala"
	_tmp6_ = camel_data_wrapper_new ();
#line 897 "../src/Composer.vala"
	html = _tmp6_;
#line 4832 "Composer.c"
	{
		CamelDataWrapper* _tmp7_;
		CamelStreamFilter* _tmp8_;
		CamelDataWrapper* _tmp9_;
#line 899 "../src/Composer.vala"
		_tmp7_ = html;
#line 899 "../src/Composer.vala"
		_tmp8_ = stream_filter;
#line 899 "../src/Composer.vala"
		camel_data_wrapper_construct_from_stream_sync (_tmp7_, (CamelStream*) _tmp8_, NULL, &_inner_error0_);
#line 899 "../src/Composer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4845 "Composer.c"
			goto __catch0_g_error;
		}
#line 900 "../src/Composer.vala"
		_tmp9_ = html;
#line 900 "../src/Composer.vala"
		camel_data_wrapper_set_mime_type (_tmp9_, "text/html; charset=utf-8");
#line 4852 "Composer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 898 "../src/Composer.vala"
		e = _inner_error0_;
#line 898 "../src/Composer.vala"
		_inner_error0_ = NULL;
#line 902 "../src/Composer.vala"
		_tmp10_ = e;
#line 902 "../src/Composer.vala"
		_tmp11_ = _tmp10_->message;
#line 902 "../src/Composer.vala"
		g_warning ("Composer.vala:902: Error constructing html from stream: %s", _tmp11_);
#line 898 "../src/Composer.vala"
		_g_error_free0 (e);
#line 4872 "Composer.c"
	}
	__finally0:
#line 898 "../src/Composer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 898 "../src/Composer.vala"
		_g_object_unref0 (html);
#line 898 "../src/Composer.vala"
		_g_object_unref0 (stream_filter);
#line 898 "../src/Composer.vala"
		_g_object_unref0 (stream_mem);
#line 898 "../src/Composer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 898 "../src/Composer.vala"
		g_clear_error (&_inner_error0_);
#line 898 "../src/Composer.vala"
		return NULL;
#line 4889 "Composer.c"
	}
#line 905 "../src/Composer.vala"
	_tmp12_ = camel_mime_part_new ();
#line 905 "../src/Composer.vala"
	part = _tmp12_;
#line 906 "../src/Composer.vala"
	_tmp13_ = part;
#line 906 "../src/Composer.vala"
	_tmp14_ = html;
#line 906 "../src/Composer.vala"
	camel_medium_set_content ((CamelMedium*) _tmp13_, _tmp14_);
#line 907 "../src/Composer.vala"
	_tmp15_ = part;
#line 907 "../src/Composer.vala"
	camel_mime_part_set_encoding (_tmp15_, CAMEL_TRANSFER_ENCODING_QUOTEDPRINTABLE);
#line 909 "../src/Composer.vala"
	_tmp16_ = camel_multipart_new ();
#line 909 "../src/Composer.vala"
	body = _tmp16_;
#line 910 "../src/Composer.vala"
	_tmp17_ = body;
#line 910 "../src/Composer.vala"
	camel_data_wrapper_set_mime_type ((CamelDataWrapper*) _tmp17_, "multipart/alternative");
#line 911 "../src/Composer.vala"
	_tmp18_ = body;
#line 911 "../src/Composer.vala"
	camel_multipart_set_boundary (_tmp18_, NULL);
#line 912 "../src/Composer.vala"
	_tmp19_ = body;
#line 912 "../src/Composer.vala"
	_tmp20_ = part;
#line 912 "../src/Composer.vala"
	camel_multipart_add_part (_tmp19_, _tmp20_);
#line 914 "../src/Composer.vala"
	_tmp21_ = self->priv->attachment_box;
#line 914 "../src/Composer.vala"
	_tmp22_ = gtk_container_get_children ((GtkContainer*) _tmp21_);
#line 914 "../src/Composer.vala"
	_tmp23_ = _tmp22_;
#line 914 "../src/Composer.vala"
	_tmp24_ = g_list_length (_tmp23_) > ((guint) 0);
#line 914 "../src/Composer.vala"
	(_tmp23_ == NULL) ? NULL : (_tmp23_ = (g_list_free (_tmp23_), NULL));
#line 914 "../src/Composer.vala"
	if (_tmp24_) {
#line 4935 "Composer.c"
		GtkFlowBox* _tmp25_;
		GList* _tmp26_;
#line 915 "../src/Composer.vala"
		_tmp25_ = self->priv->attachment_box;
#line 915 "../src/Composer.vala"
		_tmp26_ = gtk_container_get_children ((GtkContainer*) _tmp25_);
#line 4942 "Composer.c"
		{
			GList* attachment_collection = NULL;
			GList* attachment_it = NULL;
#line 915 "../src/Composer.vala"
			attachment_collection = _tmp26_;
#line 915 "../src/Composer.vala"
			for (attachment_it = attachment_collection; attachment_it != NULL; attachment_it = attachment_it->next) {
#line 4950 "Composer.c"
				GtkWidget* attachment = NULL;
#line 915 "../src/Composer.vala"
				attachment = (GtkWidget*) attachment_it->data;
#line 4954 "Composer.c"
				{
					GtkWidget* _tmp27_;
					MailComposerAttachment* attachment_obj = NULL;
					GtkWidget* _tmp28_;
					CamelMultipart* _tmp29_;
					MailComposerAttachment* _tmp30_;
					CamelMimePart* _tmp31_;
					CamelMimePart* _tmp32_;
#line 916 "../src/Composer.vala"
					_tmp27_ = attachment;
#line 916 "../src/Composer.vala"
					if (!MAIL_COMPOSER_IS_ATTACHMENT (_tmp27_)) {
#line 917 "../src/Composer.vala"
						continue;
#line 4969 "Composer.c"
					}
#line 920 "../src/Composer.vala"
					_tmp28_ = attachment;
#line 920 "../src/Composer.vala"
					attachment_obj = G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, MAIL_COMPOSER_TYPE_ATTACHMENT, MailComposerAttachment);
#line 921 "../src/Composer.vala"
					_tmp29_ = body;
#line 921 "../src/Composer.vala"
					_tmp30_ = attachment_obj;
#line 921 "../src/Composer.vala"
					_tmp31_ = mail_composer_attachment_get_mime_part (_tmp30_);
#line 921 "../src/Composer.vala"
					_tmp32_ = _tmp31_;
#line 921 "../src/Composer.vala"
					camel_multipart_add_part (_tmp29_, _tmp32_);
#line 921 "../src/Composer.vala"
					_g_object_unref0 (_tmp32_);
#line 4987 "Composer.c"
				}
			}
#line 915 "../src/Composer.vala"
			(attachment_collection == NULL) ? NULL : (attachment_collection = (g_list_free (attachment_collection), NULL));
#line 4992 "Composer.c"
		}
	}
#line 925 "../src/Composer.vala"
	_tmp33_ = camel_mime_message_new ();
#line 925 "../src/Composer.vala"
	message = _tmp33_;
#line 926 "../src/Composer.vala"
	_tmp34_ = self->priv->subject_val;
#line 926 "../src/Composer.vala"
	_tmp35_ = gtk_entry_get_text (_tmp34_);
#line 926 "../src/Composer.vala"
	_tmp36_ = _tmp35_;
#line 926 "../src/Composer.vala"
	camel_mime_message_set_subject (message, _tmp36_);
#line 927 "../src/Composer.vala"
	camel_mime_message_set_date (message, (glong) CAMEL_MESSAGE_DATE_CURRENT, 0);
#line 928 "../src/Composer.vala"
	_tmp37_ = body;
#line 928 "../src/Composer.vala"
	camel_medium_set_content ((CamelMedium*) message, (CamelDataWrapper*) _tmp37_);
#line 930 "../src/Composer.vala"
	result = message;
#line 930 "../src/Composer.vala"
	_g_object_unref0 (body);
#line 930 "../src/Composer.vala"
	_g_object_unref0 (part);
#line 930 "../src/Composer.vala"
	_g_object_unref0 (html);
#line 930 "../src/Composer.vala"
	_g_object_unref0 (stream_filter);
#line 930 "../src/Composer.vala"
	_g_object_unref0 (stream_mem);
#line 930 "../src/Composer.vala"
	return result;
#line 5027 "Composer.c"
}

static void
mail_composer_remember_recipients_data_free (gpointer _data)
{
	MailComposerRememberRecipientsData* _data_;
	_data_ = _data;
#line 8 "../src/Composer.vala"
	_g_object_unref0 (_data_->recipients);
#line 8 "../src/Composer.vala"
	_g_object_unref0 (_data_->self);
#line 8 "../src/Composer.vala"
	g_slice_free (MailComposerRememberRecipientsData, _data_);
#line 5041 "Composer.c"
}

static void
mail_composer_remember_recipients (MailComposer* self,
                                   CamelInternetAddress* recipients,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	MailComposerRememberRecipientsData* _data_;
	MailComposer* _tmp0_;
	CamelInternetAddress* _tmp1_;
#line 8 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/Composer.vala"
	g_return_if_fail (recipients != NULL);
#line 8 "../src/Composer.vala"
	_data_ = g_slice_new0 (MailComposerRememberRecipientsData);
#line 8 "../src/Composer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 8 "../src/Composer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_composer_remember_recipients_data_free);
#line 8 "../src/Composer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 8 "../src/Composer.vala"
	_data_->self = _tmp0_;
#line 8 "../src/Composer.vala"
	_tmp1_ = _g_object_ref0 (recipients);
#line 8 "../src/Composer.vala"
	_g_object_unref0 (_data_->recipients);
#line 8 "../src/Composer.vala"
	_data_->recipients = _tmp1_;
#line 8 "../src/Composer.vala"
	mail_composer_remember_recipients_co (_data_);
#line 5075 "Composer.c"
}

static void
mail_composer_remember_recipients_finish (MailComposer* self,
                                          GAsyncResult* _res_)
{
	MailComposerRememberRecipientsData* _data_;
#line 8 "../src/Composer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 5085 "Composer.c"
}

static void
mail_composer_remember_recipients_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	MailComposerRememberRecipientsData* _data_;
#line 939 "../src/Composer.vala"
	_data_ = _user_data_;
#line 939 "../src/Composer.vala"
	_data_->_source_object_ = source_object;
#line 939 "../src/Composer.vala"
	_data_->_res_ = _res_;
#line 939 "../src/Composer.vala"
	mail_composer_remember_recipients_co (_data_);
#line 5102 "Composer.c"
}

static gboolean
mail_composer_remember_recipients_co (MailComposerRememberRecipientsData* _data_)
{
#line 933 "../src/Composer.vala"
	switch (_data_->_state_) {
#line 933 "../src/Composer.vala"
		case 0:
#line 5112 "Composer.c"
		goto _state_0;
#line 933 "../src/Composer.vala"
		case 1:
#line 5116 "Composer.c"
		goto _state_1;
		default:
#line 933 "../src/Composer.vala"
		g_assert_not_reached ();
#line 5121 "Composer.c"
	}
	_state_0:
#line 934 "../src/Composer.vala"
	_data_->_tmp0_ = mail_contact_manager_get_default ();
#line 934 "../src/Composer.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
#line 934 "../src/Composer.vala"
	_data_->contact_manager = _data_->_tmp1_;
#line 5130 "Composer.c"
	{
#line 935 "../src/Composer.vala"
		_data_->i = 0;
#line 5134 "Composer.c"
		{
#line 935 "../src/Composer.vala"
			_data_->_tmp2_ = TRUE;
#line 935 "../src/Composer.vala"
			while (TRUE) {
#line 935 "../src/Composer.vala"
				if (!_data_->_tmp2_) {
#line 935 "../src/Composer.vala"
					_data_->_tmp3_ = _data_->i;
#line 935 "../src/Composer.vala"
					_data_->i = _data_->_tmp3_ + 1;
#line 5146 "Composer.c"
				}
#line 935 "../src/Composer.vala"
				_data_->_tmp2_ = FALSE;
#line 935 "../src/Composer.vala"
				if (!(_data_->i < camel_address_length ((CamelAddress*) _data_->recipients))) {
#line 935 "../src/Composer.vala"
					break;
#line 5154 "Composer.c"
				}
#line 938 "../src/Composer.vala"
				_data_->_tmp4_ = NULL;
#line 938 "../src/Composer.vala"
				_data_->_tmp5_ = NULL;
#line 938 "../src/Composer.vala"
				camel_internet_address_get (_data_->recipients, _data_->i, &_data_->_tmp4_, &_data_->_tmp5_);
#line 938 "../src/Composer.vala"
				_g_free0 (_data_->name);
#line 938 "../src/Composer.vala"
				_data_->_tmp6_ = g_strdup (_data_->_tmp4_);
#line 938 "../src/Composer.vala"
				_data_->name = _data_->_tmp6_;
#line 938 "../src/Composer.vala"
				_g_free0 (_data_->address);
#line 938 "../src/Composer.vala"
				_data_->_tmp7_ = g_strdup (_data_->_tmp5_);
#line 938 "../src/Composer.vala"
				_data_->address = _data_->_tmp7_;
#line 939 "../src/Composer.vala"
				_data_->_tmp8_ = _data_->contact_manager;
#line 939 "../src/Composer.vala"
				_data_->_tmp9_ = _data_->address;
#line 939 "../src/Composer.vala"
				_data_->_tmp10_ = _data_->name;
#line 939 "../src/Composer.vala"
				_data_->_state_ = 1;
#line 939 "../src/Composer.vala"
				mail_contact_manager_remember_mail_address (_data_->_tmp8_, _data_->_tmp9_, _data_->_tmp10_, mail_composer_remember_recipients_ready, _data_);
#line 939 "../src/Composer.vala"
				return FALSE;
#line 5186 "Composer.c"
				_state_1:
#line 939 "../src/Composer.vala"
				mail_contact_manager_remember_mail_address_finish (_data_->_tmp8_, _data_->_res_);
#line 935 "../src/Composer.vala"
				_g_free0 (_data_->address);
#line 935 "../src/Composer.vala"
				_g_free0 (_data_->name);
#line 5194 "Composer.c"
			}
		}
	}
#line 933 "../src/Composer.vala"
	_g_object_unref0 (_data_->contact_manager);
#line 933 "../src/Composer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 933 "../src/Composer.vala"
	if (_data_->_state_ != 0) {
#line 933 "../src/Composer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 933 "../src/Composer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5208 "Composer.c"
		}
	}
#line 933 "../src/Composer.vala"
	g_object_unref (_data_->_async_result);
#line 933 "../src/Composer.vala"
	return FALSE;
#line 5215 "Composer.c"
}

static void
mail_composer_load_from_combobox (MailComposer* self)
{
	MailBackendSession* session = NULL;
	MailBackendSession* _tmp0_;
	GtkComboBoxText* _tmp12_;
#line 943 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 944 "../src/Composer.vala"
	_tmp0_ = mail_backend_session_get_default ();
#line 944 "../src/Composer.vala"
	session = _tmp0_;
#line 5230 "Composer.c"
	{
		GeeArrayList* _address_list = NULL;
		MailBackendSession* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _address_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _address_index = 0;
#line 945 "../src/Composer.vala"
		_tmp1_ = session;
#line 945 "../src/Composer.vala"
		_tmp2_ = mail_backend_session_get_own_addresses (_tmp1_);
#line 945 "../src/Composer.vala"
		_address_list = _tmp2_;
#line 945 "../src/Composer.vala"
		_tmp3_ = _address_list;
#line 945 "../src/Composer.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 945 "../src/Composer.vala"
		_tmp5_ = _tmp4_;
#line 945 "../src/Composer.vala"
		_address_size = _tmp5_;
#line 945 "../src/Composer.vala"
		_address_index = -1;
#line 945 "../src/Composer.vala"
		while (TRUE) {
#line 5258 "Composer.c"
			gint _tmp6_;
			gint _tmp7_;
			gchar* address = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			GtkComboBoxText* _tmp10_;
			const gchar* _tmp11_;
#line 945 "../src/Composer.vala"
			_address_index = _address_index + 1;
#line 945 "../src/Composer.vala"
			_tmp6_ = _address_index;
#line 945 "../src/Composer.vala"
			_tmp7_ = _address_size;
#line 945 "../src/Composer.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 945 "../src/Composer.vala"
				break;
#line 5276 "Composer.c"
			}
#line 945 "../src/Composer.vala"
			_tmp8_ = _address_list;
#line 945 "../src/Composer.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _address_index);
#line 945 "../src/Composer.vala"
			address = (gchar*) _tmp9_;
#line 946 "../src/Composer.vala"
			_tmp10_ = self->priv->from_combo;
#line 946 "../src/Composer.vala"
			_tmp11_ = address;
#line 946 "../src/Composer.vala"
			gtk_combo_box_text_append_text (_tmp10_, _tmp11_);
#line 945 "../src/Composer.vala"
			_g_free0 (address);
#line 5292 "Composer.c"
		}
#line 945 "../src/Composer.vala"
		_g_object_unref0 (_address_list);
#line 5296 "Composer.c"
	}
#line 949 "../src/Composer.vala"
	_tmp12_ = self->priv->from_combo;
#line 949 "../src/Composer.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _tmp12_, 0);
#line 5302 "Composer.c"
}

static GVariant*
_variant_new1 (const gchar* value)
{
#line 958 "../src/Composer.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 5310 "Composer.c"
}

static GVariant*
_variant_new2 (const gchar* value)
{
#line 962 "../src/Composer.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 5318 "Composer.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 961 "../src/Composer.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 5326 "Composer.c"
}

static void
mail_composer_populate_signature_menu (MailComposer* self,
                                       GMenu* menu)
{
	GMenu* manage_section = NULL;
	GMenu* _tmp0_;
	GMenuItem* manage_item = NULL;
	GMenuItem* _tmp1_;
	GMenu* _tmp2_;
	GMenuItem* _tmp3_;
	GMenu* selection_section = NULL;
	GMenu* _tmp4_;
	GMenu* _tmp5_;
	GVariant* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	MailBackendSession* session = NULL;
	MailBackendSession* _tmp9_;
	MailBackendSession* _tmp10_;
	GList* _tmp11_;
	GMenu* _tmp23_;
	GMenu* _tmp24_;
#line 952 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 952 "../src/Composer.vala"
	g_return_if_fail (menu != NULL);
#line 953 "../src/Composer.vala"
	_tmp0_ = g_menu_new ();
#line 953 "../src/Composer.vala"
	manage_section = _tmp0_;
#line 954 "../src/Composer.vala"
	_tmp1_ = g_menu_item_new (_ ("Edit Signatures…"), MAIL_APPLICATION_ACTION_PREFIX MAIL_APPLICATION_ACTION_MANAGE_SIGNATURES);
#line 954 "../src/Composer.vala"
	manage_item = _tmp1_;
#line 955 "../src/Composer.vala"
	_tmp2_ = manage_section;
#line 955 "../src/Composer.vala"
	_tmp3_ = manage_item;
#line 955 "../src/Composer.vala"
	g_menu_append_item (_tmp2_, _tmp3_);
#line 957 "../src/Composer.vala"
	_tmp4_ = g_menu_new ();
#line 957 "../src/Composer.vala"
	selection_section = _tmp4_;
#line 958 "../src/Composer.vala"
	_tmp5_ = selection_section;
#line 958 "../src/Composer.vala"
	_tmp6_ = _variant_new1 ("none");
#line 958 "../src/Composer.vala"
	_tmp7_ = g_action_print_detailed_name (MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_INSERT_SIGNATURE, _tmp6_);
#line 958 "../src/Composer.vala"
	_tmp8_ = _tmp7_;
#line 958 "../src/Composer.vala"
	g_menu_append (_tmp5_, _ ("None"), _tmp8_);
#line 958 "../src/Composer.vala"
	_g_free0 (_tmp8_);
#line 958 "../src/Composer.vala"
	_g_variant_unref0 (_tmp6_);
#line 960 "../src/Composer.vala"
	_tmp9_ = mail_backend_session_get_default ();
#line 960 "../src/Composer.vala"
	session = _tmp9_;
#line 961 "../src/Composer.vala"
	_tmp10_ = session;
#line 961 "../src/Composer.vala"
	_tmp11_ = mail_backend_session_get_all_signature_sources (_tmp10_);
#line 5395 "Composer.c"
	{
		GList* signature_source_collection = NULL;
		GList* signature_source_it = NULL;
#line 961 "../src/Composer.vala"
		signature_source_collection = _tmp11_;
#line 961 "../src/Composer.vala"
		for (signature_source_it = signature_source_collection; signature_source_it != NULL; signature_source_it = signature_source_it->next) {
#line 5403 "Composer.c"
			ESource* _tmp12_;
			ESource* signature_source = NULL;
#line 961 "../src/Composer.vala"
			_tmp12_ = _g_object_ref0 ((ESource*) signature_source_it->data);
#line 961 "../src/Composer.vala"
			signature_source = _tmp12_;
#line 5410 "Composer.c"
			{
				GMenu* _tmp13_;
				ESource* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
				ESource* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				GVariant* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
#line 962 "../src/Composer.vala"
				_tmp13_ = selection_section;
#line 962 "../src/Composer.vala"
				_tmp14_ = signature_source;
#line 962 "../src/Composer.vala"
				_tmp15_ = e_source_get_display_name (_tmp14_);
#line 962 "../src/Composer.vala"
				_tmp16_ = _tmp15_;
#line 962 "../src/Composer.vala"
				_tmp17_ = signature_source;
#line 962 "../src/Composer.vala"
				_tmp18_ = e_source_get_uid (_tmp17_);
#line 962 "../src/Composer.vala"
				_tmp19_ = _tmp18_;
#line 962 "../src/Composer.vala"
				_tmp20_ = _variant_new2 (_tmp19_);
#line 962 "../src/Composer.vala"
				_tmp21_ = g_action_print_detailed_name (MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_INSERT_SIGNATURE, _tmp20_);
#line 962 "../src/Composer.vala"
				_tmp22_ = _tmp21_;
#line 962 "../src/Composer.vala"
				g_menu_append (_tmp13_, _tmp16_, _tmp22_);
#line 962 "../src/Composer.vala"
				_g_free0 (_tmp22_);
#line 962 "../src/Composer.vala"
				_g_variant_unref0 (_tmp20_);
#line 961 "../src/Composer.vala"
				_g_object_unref0 (signature_source);
#line 5450 "Composer.c"
			}
		}
#line 961 "../src/Composer.vala"
		(signature_source_collection == NULL) ? NULL : (signature_source_collection = (_g_list_free__g_object_unref0_ (signature_source_collection), NULL));
#line 5455 "Composer.c"
	}
#line 968 "../src/Composer.vala"
	g_menu_remove_all (menu);
#line 969 "../src/Composer.vala"
	_tmp23_ = manage_section;
#line 969 "../src/Composer.vala"
	g_menu_append_section (menu, NULL, (GMenuModel*) _tmp23_);
#line 970 "../src/Composer.vala"
	_tmp24_ = selection_section;
#line 970 "../src/Composer.vala"
	g_menu_append_section (menu, NULL, (GMenuModel*) _tmp24_);
#line 952 "../src/Composer.vala"
	_g_object_unref0 (selection_section);
#line 952 "../src/Composer.vala"
	_g_object_unref0 (manage_item);
#line 952 "../src/Composer.vala"
	_g_object_unref0 (manage_section);
#line 5473 "Composer.c"
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 973 "../src/Composer.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 973 "../src/Composer.vala"
	return _data15_;
#line 5483 "Composer.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 973 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 5493 "Composer.c"
		MailComposer* self;
#line 973 "../src/Composer.vala"
		self = _data15_->self;
#line 973 "../src/Composer.vala"
		_g_object_unref0 (self);
#line 973 "../src/Composer.vala"
		g_slice_free (Block15Data, _data15_);
#line 5501 "Composer.c"
	}
}

static void
__lambda90_ (Block15Data* _data15_,
             GObject* obj,
             GAsyncResult* res)
{
	MailComposer* self;
	gchar* signature = NULL;
	MailBackendSession* _tmp0_;
	gchar* _tmp1_;
	MailWebView* _tmp2_;
#line 982 "../src/Composer.vala"
	self = _data15_->self;
#line 982 "../src/Composer.vala"
	g_return_if_fail (res != NULL);
#line 983 "../src/Composer.vala"
	_tmp0_ = _data15_->session;
#line 983 "../src/Composer.vala"
	_tmp1_ = mail_backend_session_get_signature_for_uid_finish (_tmp0_, res);
#line 983 "../src/Composer.vala"
	signature = _tmp1_;
#line 984 "../src/Composer.vala"
	_tmp2_ = self->priv->web_view;
#line 984 "../src/Composer.vala"
	mail_web_view_set_content_of_element (_tmp2_, "#elementary-message-signature", signature);
#line 982 "../src/Composer.vala"
	_g_free0 (signature);
#line 5531 "Composer.c"
}

static void
___lambda90__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 982 "../src/Composer.vala"
	__lambda90_ (self, source_object, res);
#line 982 "../src/Composer.vala"
	block15_data_unref (self);
#line 5543 "Composer.c"
}

static void
mail_composer_on_insert_signature (MailComposer* self,
                                   GAction* action,
                                   GVariant* parameter)
{
	Block15Data* _data15_;
	const gchar* signature_uid = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	MailBackendSession* _tmp3_;
	MailBackendSession* _tmp4_;
	const gchar* _tmp5_;
#line 973 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 973 "../src/Composer.vala"
	g_return_if_fail (action != NULL);
#line 973 "../src/Composer.vala"
	_data15_ = g_slice_new0 (Block15Data);
#line 973 "../src/Composer.vala"
	_data15_->_ref_count_ = 1;
#line 973 "../src/Composer.vala"
	_data15_->self = g_object_ref (self);
#line 974 "../src/Composer.vala"
	_tmp0_ = g_variant_get_string (parameter, NULL);
#line 974 "../src/Composer.vala"
	signature_uid = _tmp0_;
#line 976 "../src/Composer.vala"
	_tmp1_ = signature_uid;
#line 976 "../src/Composer.vala"
	if (g_strcmp0 (_tmp1_, "none") == 0) {
#line 5576 "Composer.c"
		MailWebView* _tmp2_;
#line 977 "../src/Composer.vala"
		_tmp2_ = self->priv->web_view;
#line 977 "../src/Composer.vala"
		mail_web_view_set_content_of_element (_tmp2_, "#elementary-message-signature", "");
#line 978 "../src/Composer.vala"
		block15_data_unref (_data15_);
#line 978 "../src/Composer.vala"
		_data15_ = NULL;
#line 978 "../src/Composer.vala"
		return;
#line 5588 "Composer.c"
	}
#line 981 "../src/Composer.vala"
	_tmp3_ = mail_backend_session_get_default ();
#line 981 "../src/Composer.vala"
	_data15_->session = _tmp3_;
#line 982 "../src/Composer.vala"
	_tmp4_ = _data15_->session;
#line 982 "../src/Composer.vala"
	_tmp5_ = signature_uid;
#line 982 "../src/Composer.vala"
	mail_backend_session_get_signature_for_uid (_tmp4_, _tmp5_, ___lambda90__gasync_ready_callback, block15_data_ref (_data15_));
#line 973 "../src/Composer.vala"
	block15_data_unref (_data15_);
#line 973 "../src/Composer.vala"
	_data15_ = NULL;
#line 5604 "Composer.c"
}

static GVariant*
_variant_new3 (gchar* value)
{
#line 991 "../src/Composer.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 5612 "Composer.c"
}

static void
mail_composer_set_default_signature_for_sender (MailComposer* self)
{
	gchar* sender = NULL;
	GtkComboBoxText* _tmp0_;
	gchar* _tmp1_;
	MailBackendSession* session = NULL;
	MailBackendSession* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GVariant* _tmp5_;
#line 988 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 989 "../src/Composer.vala"
	_tmp0_ = self->priv->from_combo;
#line 989 "../src/Composer.vala"
	_tmp1_ = gtk_combo_box_text_get_active_text (_tmp0_);
#line 989 "../src/Composer.vala"
	sender = _tmp1_;
#line 990 "../src/Composer.vala"
	_tmp2_ = mail_backend_session_get_default ();
#line 990 "../src/Composer.vala"
	session = _tmp2_;
#line 991 "../src/Composer.vala"
	_tmp3_ = mail_backend_session_get_signature_uid_for_sender (session, sender);
#line 991 "../src/Composer.vala"
	_tmp4_ = _tmp3_;
#line 991 "../src/Composer.vala"
	_tmp5_ = _variant_new3 (_tmp4_);
#line 991 "../src/Composer.vala"
	g_action_group_activate_action ((GActionGroup*) self, MAIL_COMPOSER_ACTION_INSERT_SIGNATURE, _tmp5_);
#line 991 "../src/Composer.vala"
	_g_variant_unref0 (_tmp5_);
#line 991 "../src/Composer.vala"
	_g_free0 (_tmp4_);
#line 988 "../src/Composer.vala"
	_g_free0 (sender);
#line 5652 "Composer.c"
}

static void
mail_composer_save_draft_data_free (gpointer _data)
{
	MailComposerSaveDraftData* _data_;
	_data_ = _data;
#line 8 "../src/Composer.vala"
	_g_object_unref0 (_data_->self);
#line 8 "../src/Composer.vala"
	g_slice_free (MailComposerSaveDraftData, _data_);
#line 5664 "Composer.c"
}

void
mail_composer_save_draft (MailComposer* self,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	MailComposerSaveDraftData* _data_;
	MailComposer* _tmp0_;
#line 8 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/Composer.vala"
	_data_ = g_slice_new0 (MailComposerSaveDraftData);
#line 8 "../src/Composer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 8 "../src/Composer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_composer_save_draft_data_free);
#line 8 "../src/Composer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 8 "../src/Composer.vala"
	_data_->self = _tmp0_;
#line 8 "../src/Composer.vala"
	mail_composer_save_draft_co (_data_);
#line 5688 "Composer.c"
}

gboolean
mail_composer_save_draft_finish (MailComposer* self,
                                 GAsyncResult* _res_)
{
	gboolean result;
	MailComposerSaveDraftData* _data_;
#line 8 "../src/Composer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8 "../src/Composer.vala"
	result = _data_->result;
#line 8 "../src/Composer.vala"
	return result;
#line 5703 "Composer.c"
}

static void
mail_composer_save_draft_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	MailComposerSaveDraftData* _data_;
#line 1134 "../src/Composer.vala"
	_data_ = _user_data_;
#line 1134 "../src/Composer.vala"
	_data_->_source_object_ = source_object;
#line 1134 "../src/Composer.vala"
	_data_->_res_ = _res_;
#line 1134 "../src/Composer.vala"
	mail_composer_save_draft_co (_data_);
#line 5720 "Composer.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 1143 "../src/Composer.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 1143 "../src/Composer.vala"
	return _data16_;
#line 5730 "Composer.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 1143 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 5740 "Composer.c"
		MailComposer* self;
#line 1143 "../src/Composer.vala"
		self = _data16_->self;
#line 1143 "../src/Composer.vala"
		_g_object_unref0 (_data16_->error_dialog);
#line 1143 "../src/Composer.vala"
		_g_object_unref0 (self);
#line 1143 "../src/Composer.vala"
		g_slice_free (Block16Data, _data16_);
#line 5750 "Composer.c"
	}
}

static void
____lambda102_ (Block16Data* _data16_)
{
	MailComposer* self;
	GraniteMessageDialog* _tmp0_;
#line 1156 "../src/Composer.vala"
	self = _data16_->self;
#line 1156 "../src/Composer.vala"
	_tmp0_ = _data16_->error_dialog;
#line 1156 "../src/Composer.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 5765 "Composer.c"
}

static void
_____lambda102__gtk_dialog_response (GtkDialog* _sender,
                                     gint response_id,
                                     gpointer self)
{
#line 1156 "../src/Composer.vala"
	____lambda102_ (self);
#line 5775 "Composer.c"
}

static gboolean
mail_composer_save_draft_co (MailComposerSaveDraftData* _data_)
{
#line 1129 "../src/Composer.vala"
	switch (_data_->_state_) {
#line 1129 "../src/Composer.vala"
		case 0:
#line 5785 "Composer.c"
		goto _state_0;
#line 1129 "../src/Composer.vala"
		case 1:
#line 5789 "Composer.c"
		goto _state_1;
#line 1129 "../src/Composer.vala"
		case 2:
#line 5793 "Composer.c"
		goto _state_2;
		default:
#line 1129 "../src/Composer.vala"
		g_assert_not_reached ();
#line 5798 "Composer.c"
	}
	_state_0:
#line 1130 "../src/Composer.vala"
	if (_data_->self->priv->discard_draft) {
#line 1130 "../src/Composer.vala"
		_data_->_tmp0_ = TRUE;
#line 5805 "Composer.c"
	} else {
#line 1130 "../src/Composer.vala"
		_data_->_tmp1_ = _data_->self->priv->web_view;
#line 1130 "../src/Composer.vala"
		_data_->_tmp2_ = mail_web_view_get_body_html_changed (_data_->_tmp1_);
#line 1130 "../src/Composer.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 1130 "../src/Composer.vala"
		_data_->_tmp0_ = !_data_->_tmp3_;
#line 5815 "Composer.c"
	}
#line 1130 "../src/Composer.vala"
	if (_data_->_tmp0_) {
#line 1131 "../src/Composer.vala"
		_data_->result = FALSE;
#line 1131 "../src/Composer.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1131 "../src/Composer.vala"
		if (_data_->_state_ != 0) {
#line 1131 "../src/Composer.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 1131 "../src/Composer.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5829 "Composer.c"
			}
		}
#line 1131 "../src/Composer.vala"
		g_object_unref (_data_->_async_result);
#line 1131 "../src/Composer.vala"
		return FALSE;
#line 5836 "Composer.c"
	}
#line 1134 "../src/Composer.vala"
	_data_->_tmp4_ = _data_->self->priv->web_view;
#line 1134 "../src/Composer.vala"
	_data_->_state_ = 1;
#line 1134 "../src/Composer.vala"
	mail_web_view_get_body_html (_data_->_tmp4_, FALSE, mail_composer_save_draft_ready, _data_);
#line 1134 "../src/Composer.vala"
	return FALSE;
#line 5846 "Composer.c"
	_state_1:
#line 1134 "../src/Composer.vala"
	_data_->_tmp5_ = mail_web_view_get_body_html_finish (_data_->_tmp4_, _data_->_res_);
#line 1134 "../src/Composer.vala"
	_data_->body_html = _data_->_tmp5_;
#line 1136 "../src/Composer.vala"
	_data_->_tmp6_ = _data_->body_html;
#line 1136 "../src/Composer.vala"
	if (_data_->_tmp6_ != NULL) {
#line 1137 "../src/Composer.vala"
		_data_->_tmp7_ = mail_backend_session_get_default ();
#line 1137 "../src/Composer.vala"
		_data_->session = _data_->_tmp7_;
#line 1139 "../src/Composer.vala"
		_data_->_tmp8_ = _data_->body_html;
#line 1139 "../src/Composer.vala"
		_data_->_tmp9_ = mail_composer_build_message (_data_->self, _data_->_tmp8_);
#line 1139 "../src/Composer.vala"
		_data_->message = _data_->_tmp9_;
#line 1140 "../src/Composer.vala"
		_data_->_tmp10_ = _data_->message;
#line 1140 "../src/Composer.vala"
		_data_->_tmp11_ = _data_->self->priv->from_combo;
#line 1140 "../src/Composer.vala"
		_data_->_tmp12_ = gtk_combo_box_text_get_active_text (_data_->_tmp11_);
#line 1140 "../src/Composer.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 1140 "../src/Composer.vala"
		_data_->_tmp14_ = mail_composer_build_sender (_data_->self, _data_->_tmp10_, _data_->_tmp13_);
#line 1140 "../src/Composer.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 1140 "../src/Composer.vala"
		_g_free0 (_data_->_tmp13_);
#line 1140 "../src/Composer.vala"
		_data_->sender = _data_->_tmp15_;
#line 1141 "../src/Composer.vala"
		_data_->_tmp16_ = _data_->message;
#line 1141 "../src/Composer.vala"
		_data_->_tmp17_ = _data_->self->priv->to_val;
#line 1141 "../src/Composer.vala"
		_data_->_tmp18_ = gtk_entry_get_text (_data_->_tmp17_);
#line 1141 "../src/Composer.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 1141 "../src/Composer.vala"
		_data_->_tmp20_ = _data_->self->priv->cc_val;
#line 1141 "../src/Composer.vala"
		_data_->_tmp21_ = gtk_entry_get_text (_data_->_tmp20_);
#line 1141 "../src/Composer.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 1141 "../src/Composer.vala"
		_data_->_tmp23_ = _data_->self->priv->bcc_val;
#line 1141 "../src/Composer.vala"
		_data_->_tmp24_ = gtk_entry_get_text (_data_->_tmp23_);
#line 1141 "../src/Composer.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 1141 "../src/Composer.vala"
		_data_->_tmp26_ = mail_composer_build_recipients (_data_->self, _data_->_tmp16_, _data_->_tmp19_, _data_->_tmp22_, _data_->_tmp25_);
#line 1141 "../src/Composer.vala"
		_data_->recipients = _data_->_tmp26_;
#line 5906 "Composer.c"
		{
#line 1144 "../src/Composer.vala"
			_data_->_tmp27_ = _data_->session;
#line 1144 "../src/Composer.vala"
			_data_->_tmp28_ = _data_->message;
#line 1144 "../src/Composer.vala"
			_data_->_tmp29_ = _data_->sender;
#line 1144 "../src/Composer.vala"
			_data_->_tmp30_ = _data_->recipients;
#line 1144 "../src/Composer.vala"
			_data_->_tmp31_ = _data_->self->priv->ancestor_message_info;
#line 1144 "../src/Composer.vala"
			_data_->_state_ = 2;
#line 1144 "../src/Composer.vala"
			mail_backend_session_save_draft (_data_->_tmp27_, _data_->_tmp28_, _data_->_tmp29_, (CamelAddress*) _data_->_tmp30_, _data_->_tmp31_, mail_composer_save_draft_ready, _data_);
#line 1144 "../src/Composer.vala"
			return FALSE;
#line 5924 "Composer.c"
			_state_2:
#line 1144 "../src/Composer.vala"
			mail_backend_session_save_draft_finish (_data_->_tmp27_, _data_->_res_, &_data_->_inner_error0_);
#line 1144 "../src/Composer.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 5930 "Composer.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 1143 "../src/Composer.vala"
			_data_->e = _data_->_inner_error0_;
#line 1143 "../src/Composer.vala"
			_data_->_inner_error0_ = NULL;
#line 1143 "../src/Composer.vala"
			_data_->_data16_ = g_slice_new0 (Block16Data);
#line 1143 "../src/Composer.vala"
			_data_->_data16_->_ref_count_ = 1;
#line 1143 "../src/Composer.vala"
			_data_->_data16_->self = g_object_ref (_data_->self);
#line 1146 "../src/Composer.vala"
			_data_->_tmp32_ = (GThemedIcon*) g_themed_icon_new ("mail-drafts");
#line 1146 "../src/Composer.vala"
			_data_->_tmp33_ = _data_->_tmp32_;
#line 1146 "../src/Composer.vala"
			_data_->_tmp34_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 1146 "../src/Composer.vala"
			_data_->_tmp35_ = NULL;
#line 1146 "../src/Composer.vala"
			_data_->_tmp35_ = granite_message_dialog_new (_ ("Unable to save draft"), _ ("There was an unexpected error while saving your draft."), (GIcon*) _data_->_tmp33_, GTK_BUTTONS_CLOSE);
#line 1146 "../src/Composer.vala"
			granite_message_dialog_set_badge_icon (_data_->_tmp35_, (GIcon*) _data_->_tmp34_);
#line 1146 "../src/Composer.vala"
			_g_object_unref0 (_data_->_tmp34_);
#line 1146 "../src/Composer.vala"
			g_object_ref_sink (_data_->_tmp35_);
#line 1146 "../src/Composer.vala"
			_data_->_tmp36_ = _data_->_tmp35_;
#line 1146 "../src/Composer.vala"
			_g_object_unref0 (_data_->_tmp33_);
#line 1146 "../src/Composer.vala"
			_data_->_data16_->error_dialog = _data_->_tmp36_;
#line 1154 "../src/Composer.vala"
			_data_->_tmp37_ = _data_->_data16_->error_dialog;
#line 1154 "../src/Composer.vala"
			_data_->_tmp38_ = _data_->e;
#line 1154 "../src/Composer.vala"
			_data_->_tmp39_ = _data_->_tmp38_->message;
#line 1154 "../src/Composer.vala"
			granite_message_dialog_show_error_details (_data_->_tmp37_, _data_->_tmp39_);
#line 1155 "../src/Composer.vala"
			_data_->_tmp40_ = _data_->_data16_->error_dialog;
#line 1155 "../src/Composer.vala"
			gtk_window_present ((GtkWindow*) _data_->_tmp40_);
#line 1156 "../src/Composer.vala"
			_data_->_tmp41_ = _data_->_data16_->error_dialog;
#line 1156 "../src/Composer.vala"
			g_signal_connect_data ((GtkDialog*) _data_->_tmp41_, "response", (GCallback) _____lambda102__gtk_dialog_response, block16_data_ref (_data_->_data16_), (GClosureNotify) block16_data_unref, 0);
#line 1157 "../src/Composer.vala"
			_data_->result = TRUE;
#line 1157 "../src/Composer.vala"
			_g_error_free0 (_data_->e);
#line 1157 "../src/Composer.vala"
			block16_data_unref (_data_->_data16_);
#line 1157 "../src/Composer.vala"
			_data_->_data16_ = NULL;
#line 1157 "../src/Composer.vala"
			_g_object_unref0 (_data_->recipients);
#line 1157 "../src/Composer.vala"
			_g_object_unref0 (_data_->sender);
#line 1157 "../src/Composer.vala"
			_g_object_unref0 (_data_->message);
#line 1157 "../src/Composer.vala"
			_g_free0 (_data_->body_html);
#line 1157 "../src/Composer.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1157 "../src/Composer.vala"
			if (_data_->_state_ != 0) {
#line 1157 "../src/Composer.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 1157 "../src/Composer.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6009 "Composer.c"
				}
			}
#line 1157 "../src/Composer.vala"
			g_object_unref (_data_->_async_result);
#line 1157 "../src/Composer.vala"
			return FALSE;
#line 6016 "Composer.c"
		}
		__finally0:
#line 1143 "../src/Composer.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1143 "../src/Composer.vala"
			_g_object_unref0 (_data_->recipients);
#line 1143 "../src/Composer.vala"
			_g_object_unref0 (_data_->sender);
#line 1143 "../src/Composer.vala"
			_g_object_unref0 (_data_->message);
#line 1143 "../src/Composer.vala"
			_g_free0 (_data_->body_html);
#line 1143 "../src/Composer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1143 "../src/Composer.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 1143 "../src/Composer.vala"
			g_object_unref (_data_->_async_result);
#line 1143 "../src/Composer.vala"
			return FALSE;
#line 6037 "Composer.c"
		}
#line 1136 "../src/Composer.vala"
		_g_object_unref0 (_data_->recipients);
#line 1136 "../src/Composer.vala"
		_g_object_unref0 (_data_->sender);
#line 1136 "../src/Composer.vala"
		_g_object_unref0 (_data_->message);
#line 6045 "Composer.c"
	}
#line 1161 "../src/Composer.vala"
	_data_->result = FALSE;
#line 1161 "../src/Composer.vala"
	_g_free0 (_data_->body_html);
#line 1161 "../src/Composer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1161 "../src/Composer.vala"
	if (_data_->_state_ != 0) {
#line 1161 "../src/Composer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1161 "../src/Composer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6059 "Composer.c"
		}
	}
#line 1161 "../src/Composer.vala"
	g_object_unref (_data_->_async_result);
#line 1161 "../src/Composer.vala"
	return FALSE;
#line 6066 "Composer.c"
}

gboolean
mail_composer_get_has_recipients (MailComposer* self)
{
	gboolean result;
#line 20 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20 "../src/Composer.vala"
	result = self->priv->_has_recipients;
#line 20 "../src/Composer.vala"
	return result;
#line 6079 "Composer.c"
}

void
mail_composer_set_has_recipients (MailComposer* self,
                                  gboolean value)
{
	gboolean old_value;
#line 20 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Composer.vala"
	old_value = mail_composer_get_has_recipients (self);
#line 20 "../src/Composer.vala"
	if (old_value != value) {
#line 20 "../src/Composer.vala"
		self->priv->_has_recipients = value;
#line 20 "../src/Composer.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_composer_properties[MAIL_COMPOSER_HAS_RECIPIENTS_PROPERTY]);
#line 6097 "Composer.c"
	}
}

const gchar*
mail_composer_get_to (MailComposer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 21 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Composer.vala"
	_tmp0_ = self->priv->_to;
#line 21 "../src/Composer.vala"
	result = _tmp0_;
#line 21 "../src/Composer.vala"
	return result;
#line 6114 "Composer.c"
}

static void
mail_composer_set_to (MailComposer* self,
                      const gchar* value)
{
	gchar* old_value;
#line 21 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Composer.vala"
	old_value = mail_composer_get_to (self);
#line 21 "../src/Composer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6128 "Composer.c"
		gchar* _tmp0_;
#line 21 "../src/Composer.vala"
		_tmp0_ = g_strdup (value);
#line 21 "../src/Composer.vala"
		_g_free0 (self->priv->_to);
#line 21 "../src/Composer.vala"
		self->priv->_to = _tmp0_;
#line 21 "../src/Composer.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_composer_properties[MAIL_COMPOSER_TO_PROPERTY]);
#line 6138 "Composer.c"
	}
}

const gchar*
mail_composer_get_mailto_query (MailComposer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/Composer.vala"
	_tmp0_ = self->priv->_mailto_query;
#line 22 "../src/Composer.vala"
	result = _tmp0_;
#line 22 "../src/Composer.vala"
	return result;
#line 6155 "Composer.c"
}

static void
mail_composer_set_mailto_query (MailComposer* self,
                                const gchar* value)
{
	gchar* old_value;
#line 22 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Composer.vala"
	old_value = mail_composer_get_mailto_query (self);
#line 22 "../src/Composer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6169 "Composer.c"
		gchar* _tmp0_;
#line 22 "../src/Composer.vala"
		_tmp0_ = g_strdup (value);
#line 22 "../src/Composer.vala"
		_g_free0 (self->priv->_mailto_query);
#line 22 "../src/Composer.vala"
		self->priv->_mailto_query = _tmp0_;
#line 22 "../src/Composer.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_composer_properties[MAIL_COMPOSER_MAILTO_QUERY_PROPERTY]);
#line 6179 "Composer.c"
	}
}

static inline gpointer
mail_composer_attachment_get_instance_private (MailComposerAttachment* self)
{
	return G_STRUCT_MEMBER_P (self, MailComposerAttachment_private_offset);
}

static MailComposerAttachment*
mail_composer_attachment_construct (GType object_type,
                                    GFile* file,
                                    const gchar* disposition)
{
	MailComposerAttachment * self = NULL;
#line 1005 "../src/Composer.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1005 "../src/Composer.vala"
	g_return_val_if_fail (disposition != NULL, NULL);
#line 1006 "../src/Composer.vala"
	self = (MailComposerAttachment*) g_object_new (object_type, "file", file, "disposition", disposition, NULL);
#line 1005 "../src/Composer.vala"
	return self;
#line 6203 "Composer.c"
}

static MailComposerAttachment*
mail_composer_attachment_new (GFile* file,
                              const gchar* disposition)
{
#line 1005 "../src/Composer.vala"
	return mail_composer_attachment_construct (MAIL_COMPOSER_TYPE_ATTACHMENT, file, disposition);
#line 6212 "Composer.c"
}

static CamelMimePart*
mail_composer_attachment_get_mime_part (MailComposerAttachment* self)
{
	GFileInfo* _tmp0_;
	const gchar* content_type = NULL;
	GFileInfo* _tmp1_;
	const gchar* _tmp2_;
	gchar* mime_type = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	CamelDataWrapper* wrapper = NULL;
	CamelDataWrapper* _tmp5_;
	CamelDataWrapper* _tmp12_;
	const gchar* _tmp13_;
	CamelMimePart* mimepart = NULL;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	CamelDataWrapper* _tmp18_;
	CamelDataWrapper* _tmp19_;
	CamelMimePart* _tmp20_ = NULL;
	CamelMimePart* _tmp21_;
	GFileInfo* _tmp22_;
	const gchar* _tmp23_;
	CamelMimePart* _tmp24_;
	CamelContentType* _tmp25_;
	GError* _inner_error0_ = NULL;
	CamelMimePart* result;
#line 1073 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1074 "../src/Composer.vala"
	_tmp0_ = self->priv->info;
#line 1074 "../src/Composer.vala"
	if (_tmp0_ == NULL) {
#line 1075 "../src/Composer.vala"
		result = NULL;
#line 1075 "../src/Composer.vala"
		return result;
#line 6254 "Composer.c"
	}
#line 1078 "../src/Composer.vala"
	_tmp1_ = self->priv->info;
#line 1078 "../src/Composer.vala"
	_tmp2_ = g_file_info_get_content_type (_tmp1_);
#line 1078 "../src/Composer.vala"
	content_type = _tmp2_;
#line 1079 "../src/Composer.vala"
	_tmp3_ = content_type;
#line 1079 "../src/Composer.vala"
	_tmp4_ = g_content_type_get_mime_type (_tmp3_);
#line 1079 "../src/Composer.vala"
	mime_type = _tmp4_;
#line 1081 "../src/Composer.vala"
	_tmp5_ = camel_data_wrapper_new ();
#line 1081 "../src/Composer.vala"
	wrapper = _tmp5_;
#line 6272 "Composer.c"
	{
		GFileInputStream* _tmp6_ = NULL;
		GFile* _tmp7_;
		GFileInputStream* _tmp8_;
		CamelDataWrapper* _tmp9_;
#line 1083 "../src/Composer.vala"
		_tmp7_ = self->priv->_file;
#line 1083 "../src/Composer.vala"
		_tmp8_ = g_file_read (_tmp7_, NULL, &_inner_error0_);
#line 1083 "../src/Composer.vala"
		_tmp6_ = _tmp8_;
#line 1083 "../src/Composer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6286 "Composer.c"
			goto __catch0_g_error;
		}
#line 1083 "../src/Composer.vala"
		_tmp9_ = wrapper;
#line 1083 "../src/Composer.vala"
		camel_data_wrapper_construct_from_input_stream_sync (_tmp9_, (GInputStream*) _tmp6_, NULL, &_inner_error0_);
#line 1083 "../src/Composer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1083 "../src/Composer.vala"
			_g_object_unref0 (_tmp6_);
#line 6297 "Composer.c"
			goto __catch0_g_error;
		}
#line 1082 "../src/Composer.vala"
		_g_object_unref0 (_tmp6_);
#line 6302 "Composer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 1082 "../src/Composer.vala"
		e = _inner_error0_;
#line 1082 "../src/Composer.vala"
		_inner_error0_ = NULL;
#line 1085 "../src/Composer.vala"
		_tmp10_ = e;
#line 1085 "../src/Composer.vala"
		_tmp11_ = _tmp10_->message;
#line 1085 "../src/Composer.vala"
		g_warning ("Composer.vala:1085: Error constructing wrapper for attachment: %s", _tmp11_);
#line 1086 "../src/Composer.vala"
		result = NULL;
#line 1086 "../src/Composer.vala"
		_g_error_free0 (e);
#line 1086 "../src/Composer.vala"
		_g_object_unref0 (wrapper);
#line 1086 "../src/Composer.vala"
		_g_free0 (mime_type);
#line 1086 "../src/Composer.vala"
		return result;
#line 6330 "Composer.c"
	}
	__finally0:
#line 1082 "../src/Composer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1082 "../src/Composer.vala"
		_g_object_unref0 (wrapper);
#line 1082 "../src/Composer.vala"
		_g_free0 (mime_type);
#line 1082 "../src/Composer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1082 "../src/Composer.vala"
		g_clear_error (&_inner_error0_);
#line 1082 "../src/Composer.vala"
		return NULL;
#line 6345 "Composer.c"
	}
#line 1089 "../src/Composer.vala"
	_tmp12_ = wrapper;
#line 1089 "../src/Composer.vala"
	_tmp13_ = mime_type;
#line 1089 "../src/Composer.vala"
	camel_data_wrapper_set_mime_type (_tmp12_, _tmp13_);
#line 1091 "../src/Composer.vala"
	_tmp14_ = self->priv->_cid;
#line 1091 "../src/Composer.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 1091 "../src/Composer.vala"
	_tmp16_ = self->priv->_disposition;
#line 1091 "../src/Composer.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 1091 "../src/Composer.vala"
	_tmp18_ = wrapper;
#line 1091 "../src/Composer.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1091 "../src/Composer.vala"
	_tmp20_ = camel_mime_part_new ();
#line 1091 "../src/Composer.vala"
	camel_mime_part_set_content_id (_tmp20_, _tmp15_);
#line 1091 "../src/Composer.vala"
	_g_free0 (_tmp15_);
#line 1091 "../src/Composer.vala"
	camel_mime_part_set_disposition (_tmp20_, _tmp17_);
#line 1091 "../src/Composer.vala"
	_g_free0 (_tmp17_);
#line 1091 "../src/Composer.vala"
	camel_medium_set_content ((CamelMedium*) _tmp20_, _tmp19_);
#line 1091 "../src/Composer.vala"
	_g_object_unref0 (_tmp19_);
#line 1091 "../src/Composer.vala"
	mimepart = _tmp20_;
#line 1097 "../src/Composer.vala"
	_tmp21_ = mimepart;
#line 1097 "../src/Composer.vala"
	_tmp22_ = self->priv->info;
#line 1097 "../src/Composer.vala"
	_tmp23_ = g_file_info_get_display_name (_tmp22_);
#line 1097 "../src/Composer.vala"
	camel_mime_part_set_filename (_tmp21_, _tmp23_);
#line 1099 "../src/Composer.vala"
	_tmp24_ = mimepart;
#line 1099 "../src/Composer.vala"
	_tmp25_ = camel_mime_part_get_content_type (_tmp24_);
#line 1099 "../src/Composer.vala"
	if (camel_content_type_is (_tmp25_, "text", "*")) {
#line 6395 "Composer.c"
		CamelStreamNull* stream = NULL;
		CamelStreamNull* _tmp26_;
		CamelStreamFilter* filtered_stream = NULL;
		CamelStreamNull* _tmp27_;
		CamelStreamFilter* _tmp28_;
		CamelMimeFilterBestenc* filter = NULL;
		CamelMimeFilterBestenc* _tmp29_;
		CamelStreamFilter* _tmp30_;
		CamelMimeFilterBestenc* _tmp31_;
#line 1101 "../src/Composer.vala"
		_tmp26_ = (CamelStreamNull*) camel_stream_null_new ();
#line 1101 "../src/Composer.vala"
		stream = _tmp26_;
#line 1102 "../src/Composer.vala"
		_tmp27_ = stream;
#line 1102 "../src/Composer.vala"
		_tmp28_ = (CamelStreamFilter*) camel_stream_filter_new ((CamelStream*) _tmp27_);
#line 1102 "../src/Composer.vala"
		filtered_stream = _tmp28_;
#line 1103 "../src/Composer.vala"
		_tmp29_ = (CamelMimeFilterBestenc*) camel_mime_filter_bestenc_new ((guint) CAMEL_BESTENC_GET_ENCODING);
#line 1103 "../src/Composer.vala"
		filter = _tmp29_;
#line 1104 "../src/Composer.vala"
		_tmp30_ = filtered_stream;
#line 1104 "../src/Composer.vala"
		_tmp31_ = filter;
#line 1104 "../src/Composer.vala"
		camel_stream_filter_add (_tmp30_, (CamelMimeFilter*) _tmp31_);
#line 6425 "Composer.c"
		{
			CamelDataWrapper* _tmp32_;
			CamelStreamFilter* _tmp33_;
			CamelTransferEncoding encoding = 0;
			CamelMimeFilterBestenc* _tmp34_;
			CamelMimePart* _tmp35_;
#line 1107 "../src/Composer.vala"
			_tmp32_ = wrapper;
#line 1107 "../src/Composer.vala"
			_tmp33_ = filtered_stream;
#line 1107 "../src/Composer.vala"
			camel_data_wrapper_decode_to_stream_sync (_tmp32_, (CamelStream*) _tmp33_, NULL, &_inner_error0_);
#line 1107 "../src/Composer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6440 "Composer.c"
				goto __catch1_g_error;
			}
#line 1109 "../src/Composer.vala"
			_tmp34_ = filter;
#line 1109 "../src/Composer.vala"
			encoding = camel_mime_filter_bestenc_get_best_encoding (_tmp34_, CAMEL_BESTENC_8BIT);
#line 1110 "../src/Composer.vala"
			_tmp35_ = mimepart;
#line 1110 "../src/Composer.vala"
			camel_mime_part_set_encoding (_tmp35_, encoding);
#line 6451 "Composer.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 1106 "../src/Composer.vala"
			e = _inner_error0_;
#line 1106 "../src/Composer.vala"
			_inner_error0_ = NULL;
#line 1112 "../src/Composer.vala"
			_tmp36_ = e;
#line 1112 "../src/Composer.vala"
			_tmp37_ = _tmp36_->message;
#line 1112 "../src/Composer.vala"
			g_warning ("Composer.vala:1112: Unable to determine best encoding for attachment: " \
"%s", _tmp37_);
#line 1106 "../src/Composer.vala"
			_g_error_free0 (e);
#line 6471 "Composer.c"
		}
		__finally1:
#line 1106 "../src/Composer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1106 "../src/Composer.vala"
			_g_object_unref0 (filter);
#line 1106 "../src/Composer.vala"
			_g_object_unref0 (filtered_stream);
#line 1106 "../src/Composer.vala"
			_g_object_unref0 (stream);
#line 1106 "../src/Composer.vala"
			_g_object_unref0 (mimepart);
#line 1106 "../src/Composer.vala"
			_g_object_unref0 (wrapper);
#line 1106 "../src/Composer.vala"
			_g_free0 (mime_type);
#line 1106 "../src/Composer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1106 "../src/Composer.vala"
			g_clear_error (&_inner_error0_);
#line 1106 "../src/Composer.vala"
			return NULL;
#line 6494 "Composer.c"
		}
#line 1099 "../src/Composer.vala"
		_g_object_unref0 (filter);
#line 1099 "../src/Composer.vala"
		_g_object_unref0 (filtered_stream);
#line 1099 "../src/Composer.vala"
		_g_object_unref0 (stream);
#line 6502 "Composer.c"
	} else {
		CamelMimePart* _tmp38_;
#line 1116 "../src/Composer.vala"
		_tmp38_ = mimepart;
#line 1116 "../src/Composer.vala"
		camel_mime_part_set_encoding (_tmp38_, CAMEL_TRANSFER_ENCODING_BASE64);
#line 6509 "Composer.c"
	}
#line 1119 "../src/Composer.vala"
	result = mimepart;
#line 1119 "../src/Composer.vala"
	_g_object_unref0 (wrapper);
#line 1119 "../src/Composer.vala"
	_g_free0 (mime_type);
#line 1119 "../src/Composer.vala"
	return result;
#line 6519 "Composer.c"
}

static GFile*
mail_composer_attachment_get_file (MailComposerAttachment* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 998 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 998 "../src/Composer.vala"
	_tmp0_ = self->priv->_file;
#line 998 "../src/Composer.vala"
	result = _tmp0_;
#line 998 "../src/Composer.vala"
	return result;
#line 6535 "Composer.c"
}

static void
mail_composer_attachment_set_file (MailComposerAttachment* self,
                                   GFile* value)
{
	GFile* old_value;
#line 998 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 998 "../src/Composer.vala"
	old_value = mail_composer_attachment_get_file (self);
#line 998 "../src/Composer.vala"
	if (old_value != value) {
#line 6549 "Composer.c"
		GFile* _tmp0_;
#line 998 "../src/Composer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 998 "../src/Composer.vala"
		_g_object_unref0 (self->priv->_file);
#line 998 "../src/Composer.vala"
		self->priv->_file = _tmp0_;
#line 998 "../src/Composer.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_composer_attachment_properties[MAIL_COMPOSER_ATTACHMENT_FILE_PROPERTY]);
#line 6559 "Composer.c"
	}
}

static const gchar*
mail_composer_attachment_get_disposition (MailComposerAttachment* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 999 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 999 "../src/Composer.vala"
	_tmp0_ = self->priv->_disposition;
#line 999 "../src/Composer.vala"
	result = _tmp0_;
#line 999 "../src/Composer.vala"
	return result;
#line 6576 "Composer.c"
}

static void
mail_composer_attachment_set_disposition (MailComposerAttachment* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 999 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 999 "../src/Composer.vala"
	old_value = mail_composer_attachment_get_disposition (self);
#line 999 "../src/Composer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6590 "Composer.c"
		gchar* _tmp0_;
#line 999 "../src/Composer.vala"
		_tmp0_ = g_strdup (value);
#line 999 "../src/Composer.vala"
		_g_free0 (self->priv->_disposition);
#line 999 "../src/Composer.vala"
		self->priv->_disposition = _tmp0_;
#line 999 "../src/Composer.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_composer_attachment_properties[MAIL_COMPOSER_ATTACHMENT_DISPOSITION_PROPERTY]);
#line 6600 "Composer.c"
	}
}

static const gchar*
mail_composer_attachment_get_cid (MailComposerAttachment* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1000 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1000 "../src/Composer.vala"
	_tmp0_ = self->priv->_cid;
#line 1000 "../src/Composer.vala"
	result = _tmp0_;
#line 1000 "../src/Composer.vala"
	return result;
#line 6617 "Composer.c"
}

static void
mail_composer_attachment_set_cid (MailComposerAttachment* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 1000 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 1000 "../src/Composer.vala"
	old_value = mail_composer_attachment_get_cid (self);
#line 1000 "../src/Composer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6631 "Composer.c"
		gchar* _tmp0_;
#line 1000 "../src/Composer.vala"
		_tmp0_ = g_strdup (value);
#line 1000 "../src/Composer.vala"
		_g_free0 (self->priv->_cid);
#line 1000 "../src/Composer.vala"
		self->priv->_cid = _tmp0_;
#line 1000 "../src/Composer.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_composer_attachment_properties[MAIL_COMPOSER_ATTACHMENT_CID_PROPERTY]);
#line 6641 "Composer.c"
	}
}

static const gchar*
mail_composer_attachment_get_uri (MailComposerAttachment* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1001 "../src/Composer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1001 "../src/Composer.vala"
	_tmp0_ = self->priv->_uri;
#line 1001 "../src/Composer.vala"
	result = _tmp0_;
#line 1001 "../src/Composer.vala"
	return result;
#line 6658 "Composer.c"
}

static void
mail_composer_attachment_set_uri (MailComposerAttachment* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 1001 "../src/Composer.vala"
	g_return_if_fail (self != NULL);
#line 1001 "../src/Composer.vala"
	old_value = mail_composer_attachment_get_uri (self);
#line 1001 "../src/Composer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6672 "Composer.c"
		gchar* _tmp0_;
#line 1001 "../src/Composer.vala"
		_tmp0_ = g_strdup (value);
#line 1001 "../src/Composer.vala"
		_g_free0 (self->priv->_uri);
#line 1001 "../src/Composer.vala"
		self->priv->_uri = _tmp0_;
#line 1001 "../src/Composer.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_composer_attachment_properties[MAIL_COMPOSER_ATTACHMENT_URI_PROPERTY]);
#line 6682 "Composer.c"
	}
}

static void
_mail_composer_attachment___lambda86_ (MailComposerAttachment* self)
{
#line 1069 "../src/Composer.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 6691 "Composer.c"
}

static void
__mail_composer_attachment___lambda86__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 1068 "../src/Composer.vala"
	_mail_composer_attachment___lambda86_ ((MailComposerAttachment*) self);
#line 6700 "Composer.c"
}

static GObject *
mail_composer_attachment_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MailComposerAttachment * self;
#line 1013 "../src/Composer.vala"
	static const char QUERY_STRING[] = G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME "," G_FILE_ATTRIBUTE_STANDARD_ICON "," G_FILE_ATTRIBUTE_STANDARD_SIZE;
#line 6713 "Composer.c"
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkImage* image = NULL;
	GFileInfo* _tmp11_;
	GIcon* _tmp12_;
	GIcon* _tmp13_;
	GtkImage* _tmp14_ = NULL;
	GtkLabel* name_label = NULL;
	GFileInfo* _tmp15_;
	const gchar* _tmp16_;
	GtkLabel* _tmp17_ = NULL;
	GtkLabel* size_label = NULL;
	GFileInfo* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkButton* remove_button = NULL;
	GtkButton* _tmp27_;
	GtkStyleContext* remove_button_context = NULL;
	GtkButton* _tmp28_;
	GtkStyleContext* _tmp29_;
	GtkStyleContext* _tmp30_;
	GtkStyleContext* _tmp31_;
	GtkBox* box = NULL;
	GtkBox* _tmp32_ = NULL;
	GtkBox* _tmp33_;
	GtkImage* _tmp34_;
	GtkBox* _tmp35_;
	GtkLabel* _tmp36_;
	GtkBox* _tmp37_;
	GtkLabel* _tmp38_;
	GtkBox* _tmp39_;
	GtkButton* _tmp40_;
	const gchar* _tmp41_;
	GtkBox* _tmp42_;
	GtkButton* _tmp43_;
	GError* _inner_error0_ = NULL;
#line 1012 "../src/Composer.vala"
	parent_class = G_OBJECT_CLASS (mail_composer_attachment_parent_class);
#line 1012 "../src/Composer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 1012 "../src/Composer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_COMPOSER_TYPE_ATTACHMENT, MailComposerAttachment);
#line 1019 "../src/Composer.vala"
	_tmp0_ = g_uuid_string_random ();
#line 1019 "../src/Composer.vala"
	_tmp1_ = _tmp0_;
#line 1019 "../src/Composer.vala"
	mail_composer_attachment_set_cid (self, _tmp1_);
#line 1019 "../src/Composer.vala"
	_g_free0 (_tmp1_);
#line 1020 "../src/Composer.vala"
	_tmp2_ = self->priv->_cid;
#line 1020 "../src/Composer.vala"
	_tmp3_ = g_strdup_printf ("cid:%s", _tmp2_);
#line 1020 "../src/Composer.vala"
	_tmp4_ = _tmp3_;
#line 1020 "../src/Composer.vala"
	mail_composer_attachment_set_uri (self, _tmp4_);
#line 1020 "../src/Composer.vala"
	_g_free0 (_tmp4_);
#line 6783 "Composer.c"
	{
		GFileInfo* _tmp5_ = NULL;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
		GFileInfo* _tmp8_;
#line 1023 "../src/Composer.vala"
		_tmp6_ = self->priv->_file;
#line 1023 "../src/Composer.vala"
		_tmp7_ = g_file_query_info (_tmp6_, QUERY_STRING, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 1023 "../src/Composer.vala"
		_tmp5_ = _tmp7_;
#line 1023 "../src/Composer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6797 "Composer.c"
			goto __catch0_g_error;
		}
#line 1023 "../src/Composer.vala"
		_tmp8_ = _tmp5_;
#line 1023 "../src/Composer.vala"
		_tmp5_ = NULL;
#line 1023 "../src/Composer.vala"
		_g_object_unref0 (self->priv->info);
#line 1023 "../src/Composer.vala"
		self->priv->info = _tmp8_;
#line 1022 "../src/Composer.vala"
		_g_object_unref0 (_tmp5_);
#line 6810 "Composer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 1022 "../src/Composer.vala"
		e = _inner_error0_;
#line 1022 "../src/Composer.vala"
		_inner_error0_ = NULL;
#line 1025 "../src/Composer.vala"
		_tmp9_ = e;
#line 1025 "../src/Composer.vala"
		_tmp10_ = _tmp9_->message;
#line 1025 "../src/Composer.vala"
		g_warning ("Composer.vala:1025: Error querying attachment file attributes: %s", _tmp10_);
#line 1022 "../src/Composer.vala"
		_g_error_free0 (e);
#line 6830 "Composer.c"
	}
	__finally0:
#line 1022 "../src/Composer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1022 "../src/Composer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1022 "../src/Composer.vala"
		g_clear_error (&_inner_error0_);
#line 6839 "Composer.c"
	}
#line 1028 "../src/Composer.vala"
	_tmp11_ = self->priv->info;
#line 1028 "../src/Composer.vala"
	_tmp12_ = g_file_info_get_icon (_tmp11_);
#line 1028 "../src/Composer.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 1028 "../src/Composer.vala"
	_tmp14_ = (GtkImage*) gtk_image_new ();
#line 1028 "../src/Composer.vala"
	g_object_set (_tmp14_, "gicon", _tmp13_, NULL);
#line 1028 "../src/Composer.vala"
	_g_object_unref0 (_tmp13_);
#line 1028 "../src/Composer.vala"
	gtk_image_set_pixel_size (_tmp14_, 24);
#line 1028 "../src/Composer.vala"
	g_object_ref_sink (_tmp14_);
#line 1028 "../src/Composer.vala"
	image = _tmp14_;
#line 1033 "../src/Composer.vala"
	_tmp15_ = self->priv->info;
#line 1033 "../src/Composer.vala"
	_tmp16_ = g_file_info_get_display_name (_tmp15_);
#line 1033 "../src/Composer.vala"
	_tmp17_ = (GtkLabel*) gtk_label_new (_tmp16_);
#line 1033 "../src/Composer.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp17_, TRUE);
#line 1033 "../src/Composer.vala"
	gtk_label_set_xalign (_tmp17_, (gfloat) 0);
#line 1033 "../src/Composer.vala"
	g_object_ref_sink (_tmp17_);
#line 1033 "../src/Composer.vala"
	name_label = _tmp17_;
#line 1038 "../src/Composer.vala"
	_tmp18_ = self->priv->info;
#line 1038 "../src/Composer.vala"
	_tmp19_ = g_format_size_full ((guint64) g_file_info_get_size (_tmp18_), G_FORMAT_SIZE_DEFAULT);
#line 1038 "../src/Composer.vala"
	_tmp20_ = _tmp19_;
#line 1038 "../src/Composer.vala"
	_tmp21_ = g_strdup_printf ("(%s)", _tmp20_);
#line 1038 "../src/Composer.vala"
	_tmp22_ = _tmp21_;
#line 1038 "../src/Composer.vala"
	_tmp23_ = (GtkLabel*) gtk_label_new (_tmp22_);
#line 1038 "../src/Composer.vala"
	g_object_ref_sink (_tmp23_);
#line 1038 "../src/Composer.vala"
	_tmp24_ = _tmp23_;
#line 1038 "../src/Composer.vala"
	_g_free0 (_tmp22_);
#line 1038 "../src/Composer.vala"
	_g_free0 (_tmp20_);
#line 1038 "../src/Composer.vala"
	size_label = _tmp24_;
#line 1039 "../src/Composer.vala"
	_tmp25_ = size_label;
#line 1039 "../src/Composer.vala"
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
#line 1039 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp26_, GTK_STYLE_CLASS_DIM_LABEL);
#line 1041 "../src/Composer.vala"
	_tmp27_ = (GtkButton*) gtk_button_new_from_icon_name ("process-stop-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 1041 "../src/Composer.vala"
	g_object_ref_sink (_tmp27_);
#line 1041 "../src/Composer.vala"
	remove_button = _tmp27_;
#line 1043 "../src/Composer.vala"
	_tmp28_ = remove_button;
#line 1043 "../src/Composer.vala"
	_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) _tmp28_);
#line 1043 "../src/Composer.vala"
	remove_button_context = _tmp29_;
#line 1044 "../src/Composer.vala"
	_tmp30_ = remove_button_context;
#line 1044 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp30_, GTK_STYLE_CLASS_FLAT);
#line 1045 "../src/Composer.vala"
	_tmp31_ = remove_button_context;
#line 1045 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp31_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 1047 "../src/Composer.vala"
	_tmp32_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 1047 "../src/Composer.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp32_, 3);
#line 1047 "../src/Composer.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp32_, 3);
#line 1047 "../src/Composer.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp32_, 3);
#line 1047 "../src/Composer.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp32_, 3);
#line 1047 "../src/Composer.vala"
	g_object_ref_sink (_tmp32_);
#line 1047 "../src/Composer.vala"
	box = _tmp32_;
#line 1053 "../src/Composer.vala"
	_tmp33_ = box;
#line 1053 "../src/Composer.vala"
	_tmp34_ = image;
#line 1053 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
#line 1054 "../src/Composer.vala"
	_tmp35_ = box;
#line 1054 "../src/Composer.vala"
	_tmp36_ = name_label;
#line 1054 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp36_);
#line 1055 "../src/Composer.vala"
	_tmp37_ = box;
#line 1055 "../src/Composer.vala"
	_tmp38_ = size_label;
#line 1055 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
#line 1056 "../src/Composer.vala"
	_tmp39_ = box;
#line 1056 "../src/Composer.vala"
	_tmp40_ = remove_button;
#line 1056 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
#line 1058 "../src/Composer.vala"
	_tmp41_ = self->priv->_disposition;
#line 1058 "../src/Composer.vala"
	if (g_strcmp0 (_tmp41_, MAIL_COMPOSER_ATTACHMENT_DISPOSITION_INLINE) == 0) {
#line 1059 "../src/Composer.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) self, TRUE);
#line 6965 "Composer.c"
	}
#line 1062 "../src/Composer.vala"
	gtk_widget_set_margin_top ((GtkWidget*) self, 3);
#line 1063 "../src/Composer.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 3);
#line 1064 "../src/Composer.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 3);
#line 1065 "../src/Composer.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 3);
#line 1066 "../src/Composer.vala"
	_tmp42_ = box;
#line 1066 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp42_);
#line 1068 "../src/Composer.vala"
	_tmp43_ = remove_button;
#line 1068 "../src/Composer.vala"
	g_signal_connect_object (_tmp43_, "clicked", (GCallback) __mail_composer_attachment___lambda86__gtk_button_clicked, self, 0);
#line 1012 "../src/Composer.vala"
	_g_object_unref0 (box);
#line 1012 "../src/Composer.vala"
	_g_object_unref0 (remove_button);
#line 1012 "../src/Composer.vala"
	_g_object_unref0 (size_label);
#line 1012 "../src/Composer.vala"
	_g_object_unref0 (name_label);
#line 1012 "../src/Composer.vala"
	_g_object_unref0 (image);
#line 1012 "../src/Composer.vala"
	return obj;
#line 6995 "Composer.c"
}

static void
mail_composer_attachment_class_init (MailComposerAttachmentClass * klass,
                                     gpointer klass_data)
{
#line 994 "../src/Composer.vala"
	mail_composer_attachment_parent_class = g_type_class_peek_parent (klass);
#line 994 "../src/Composer.vala"
	g_type_class_adjust_private_offset (klass, &MailComposerAttachment_private_offset);
#line 994 "../src/Composer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_mail_composer_attachment_get_property;
#line 994 "../src/Composer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_mail_composer_attachment_set_property;
#line 994 "../src/Composer.vala"
	G_OBJECT_CLASS (klass)->constructor = mail_composer_attachment_constructor;
#line 994 "../src/Composer.vala"
	G_OBJECT_CLASS (klass)->finalize = mail_composer_attachment_finalize;
#line 994 "../src/Composer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_COMPOSER_ATTACHMENT_FILE_PROPERTY, mail_composer_attachment_properties[MAIL_COMPOSER_ATTACHMENT_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 994 "../src/Composer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_COMPOSER_ATTACHMENT_DISPOSITION_PROPERTY, mail_composer_attachment_properties[MAIL_COMPOSER_ATTACHMENT_DISPOSITION_PROPERTY] = g_param_spec_string ("disposition", "disposition", "disposition", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 994 "../src/Composer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_COMPOSER_ATTACHMENT_CID_PROPERTY, mail_composer_attachment_properties[MAIL_COMPOSER_ATTACHMENT_CID_PROPERTY] = g_param_spec_string ("cid", "cid", "cid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 994 "../src/Composer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_COMPOSER_ATTACHMENT_URI_PROPERTY, mail_composer_attachment_properties[MAIL_COMPOSER_ATTACHMENT_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7022 "Composer.c"
}

static void
mail_composer_attachment_instance_init (MailComposerAttachment * self,
                                        gpointer klass)
{
#line 994 "../src/Composer.vala"
	self->priv = mail_composer_attachment_get_instance_private (self);
#line 7031 "Composer.c"
}

static void
mail_composer_attachment_finalize (GObject * obj)
{
	MailComposerAttachment * self;
#line 994 "../src/Composer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_COMPOSER_TYPE_ATTACHMENT, MailComposerAttachment);
#line 998 "../src/Composer.vala"
	_g_object_unref0 (self->priv->_file);
#line 999 "../src/Composer.vala"
	_g_free0 (self->priv->_disposition);
#line 1000 "../src/Composer.vala"
	_g_free0 (self->priv->_cid);
#line 1001 "../src/Composer.vala"
	_g_free0 (self->priv->_uri);
#line 1003 "../src/Composer.vala"
	_g_object_unref0 (self->priv->info);
#line 994 "../src/Composer.vala"
	G_OBJECT_CLASS (mail_composer_attachment_parent_class)->finalize (obj);
#line 7052 "Composer.c"
}

static GType
mail_composer_attachment_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailComposerAttachmentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_composer_attachment_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailComposerAttachment), 0, (GInstanceInitFunc) mail_composer_attachment_instance_init, NULL };
	GType mail_composer_attachment_type_id;
	mail_composer_attachment_type_id = g_type_register_static (gtk_flow_box_child_get_type (), "MailComposerAttachment", &g_define_type_info, 0);
	MailComposerAttachment_private_offset = g_type_add_instance_private (mail_composer_attachment_type_id, sizeof (MailComposerAttachmentPrivate));
	return mail_composer_attachment_type_id;
}

static GType
mail_composer_attachment_get_type (void)
{
	static volatile gsize mail_composer_attachment_type_id__once = 0;
	if (g_once_init_enter (&mail_composer_attachment_type_id__once)) {
		GType mail_composer_attachment_type_id;
		mail_composer_attachment_type_id = mail_composer_attachment_get_type_once ();
		g_once_init_leave (&mail_composer_attachment_type_id__once, mail_composer_attachment_type_id);
	}
	return mail_composer_attachment_type_id__once;
}

static void
_vala_mail_composer_attachment_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	MailComposerAttachment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_COMPOSER_TYPE_ATTACHMENT, MailComposerAttachment);
#line 994 "../src/Composer.vala"
	switch (property_id) {
#line 994 "../src/Composer.vala"
		case MAIL_COMPOSER_ATTACHMENT_FILE_PROPERTY:
#line 994 "../src/Composer.vala"
		g_value_set_object (value, mail_composer_attachment_get_file (self));
#line 994 "../src/Composer.vala"
		break;
#line 994 "../src/Composer.vala"
		case MAIL_COMPOSER_ATTACHMENT_DISPOSITION_PROPERTY:
#line 994 "../src/Composer.vala"
		g_value_set_string (value, mail_composer_attachment_get_disposition (self));
#line 994 "../src/Composer.vala"
		break;
#line 994 "../src/Composer.vala"
		case MAIL_COMPOSER_ATTACHMENT_CID_PROPERTY:
#line 994 "../src/Composer.vala"
		g_value_set_string (value, mail_composer_attachment_get_cid (self));
#line 994 "../src/Composer.vala"
		break;
#line 994 "../src/Composer.vala"
		case MAIL_COMPOSER_ATTACHMENT_URI_PROPERTY:
#line 994 "../src/Composer.vala"
		g_value_set_string (value, mail_composer_attachment_get_uri (self));
#line 994 "../src/Composer.vala"
		break;
#line 7111 "Composer.c"
		default:
#line 994 "../src/Composer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 994 "../src/Composer.vala"
		break;
#line 7117 "Composer.c"
	}
}

static void
_vala_mail_composer_attachment_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	MailComposerAttachment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_COMPOSER_TYPE_ATTACHMENT, MailComposerAttachment);
#line 994 "../src/Composer.vala"
	switch (property_id) {
#line 994 "../src/Composer.vala"
		case MAIL_COMPOSER_ATTACHMENT_FILE_PROPERTY:
#line 994 "../src/Composer.vala"
		mail_composer_attachment_set_file (self, g_value_get_object (value));
#line 994 "../src/Composer.vala"
		break;
#line 994 "../src/Composer.vala"
		case MAIL_COMPOSER_ATTACHMENT_DISPOSITION_PROPERTY:
#line 994 "../src/Composer.vala"
		mail_composer_attachment_set_disposition (self, g_value_get_string (value));
#line 994 "../src/Composer.vala"
		break;
#line 994 "../src/Composer.vala"
		case MAIL_COMPOSER_ATTACHMENT_CID_PROPERTY:
#line 994 "../src/Composer.vala"
		mail_composer_attachment_set_cid (self, g_value_get_string (value));
#line 994 "../src/Composer.vala"
		break;
#line 994 "../src/Composer.vala"
		case MAIL_COMPOSER_ATTACHMENT_URI_PROPERTY:
#line 994 "../src/Composer.vala"
		mail_composer_attachment_set_uri (self, g_value_get_string (value));
#line 994 "../src/Composer.vala"
		break;
#line 7155 "Composer.c"
		default:
#line 994 "../src/Composer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 994 "../src/Composer.vala"
		break;
#line 7161 "Composer.c"
	}
}

static MailComposerEntryGrid*
mail_composer_entry_grid_construct (GType object_type)
{
	MailComposerEntryGrid * self = NULL;
#line 1123 "../src/Composer.vala"
	self = (MailComposerEntryGrid*) g_object_new (object_type, NULL);
#line 1123 "../src/Composer.vala"
	return self;
#line 7173 "Composer.c"
}

static MailComposerEntryGrid*
mail_composer_entry_grid_new (void)
{
#line 1123 "../src/Composer.vala"
	return mail_composer_entry_grid_construct (MAIL_COMPOSER_TYPE_ENTRY_GRID);
#line 7181 "Composer.c"
}

static void
mail_composer_entry_grid_class_init (MailComposerEntryGridClass * klass,
                                     gpointer klass_data)
{
#line 1123 "../src/Composer.vala"
	mail_composer_entry_grid_parent_class = g_type_class_peek_parent (klass);
#line 1125 "../src/Composer.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), GTK_STYLE_CLASS_ENTRY);
#line 7192 "Composer.c"
}

static void
mail_composer_entry_grid_instance_init (MailComposerEntryGrid * self,
                                        gpointer klass)
{
}

static GType
mail_composer_entry_grid_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailComposerEntryGridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_composer_entry_grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailComposerEntryGrid), 0, (GInstanceInitFunc) mail_composer_entry_grid_instance_init, NULL };
	GType mail_composer_entry_grid_type_id;
	mail_composer_entry_grid_type_id = g_type_register_static (gtk_grid_get_type (), "MailComposerEntryGrid", &g_define_type_info, 0);
	return mail_composer_entry_grid_type_id;
}

static GType
mail_composer_entry_grid_get_type (void)
{
	static volatile gsize mail_composer_entry_grid_type_id__once = 0;
	if (g_once_init_enter (&mail_composer_entry_grid_type_id__once)) {
		GType mail_composer_entry_grid_type_id;
		mail_composer_entry_grid_type_id = mail_composer_entry_grid_get_type_once ();
		g_once_init_leave (&mail_composer_entry_grid_type_id__once, mail_composer_entry_grid_type_id);
	}
	return mail_composer_entry_grid_type_id__once;
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 66 "../src/Composer.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 66 "../src/Composer.vala"
	return _data17_;
#line 7229 "Composer.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 66 "../src/Composer.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 7239 "Composer.c"
		MailComposer* self;
#line 66 "../src/Composer.vala"
		self = _data17_->self;
#line 66 "../src/Composer.vala"
		_g_object_unref0 (_data17_->signature_menu);
#line 66 "../src/Composer.vala"
		_g_object_unref0 (_data17_->to_grid);
#line 66 "../src/Composer.vala"
		_g_object_unref0 (_data17_->bcc_button);
#line 66 "../src/Composer.vala"
		_g_object_unref0 (self);
#line 66 "../src/Composer.vala"
		g_slice_free (Block17Data, _data17_);
#line 7253 "Composer.c"
	}
}

static void
_mail_composer___lambda103_ (MailComposer* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 171 "../src/Composer.vala"
	_tmp0_ = self->priv->subject_val;
#line 171 "../src/Composer.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 171 "../src/Composer.vala"
	_tmp2_ = _tmp1_;
#line 171 "../src/Composer.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp2_);
#line 7271 "Composer.c"
}

static void
__mail_composer___lambda103__gtk_editable_changed (GtkEditable* _sender,
                                                   gpointer self)
{
#line 170 "../src/Composer.vala"
	_mail_composer___lambda103_ ((MailComposer*) self);
#line 7280 "Composer.c"
}

static void
_mail_composer_on_mouse_target_changed_webkit_web_view_mouse_target_changed (WebKitWebView* _sender,
                                                                             WebKitHitTestResult* hit_test_result,
                                                                             guint modifiers,
                                                                             gpointer self)
{
#line 209 "../src/Composer.vala"
	mail_composer_on_mouse_target_changed ((MailComposer*) self, _sender, hit_test_result, modifiers);
#line 7291 "Composer.c"
}

static void
__lambda113_ (MailComposer* self,
              GObject* obj,
              GAsyncResult* res)
{
#line 292 "../src/Composer.vala"
	g_return_if_fail (res != NULL);
#line 293 "../src/Composer.vala"
	if (!mail_composer_save_draft_finish (self, res)) {
#line 294 "../src/Composer.vala"
		g_signal_emit (self, mail_composer_signals[MAIL_COMPOSER_FINISHED_SIGNAL], 0);
#line 295 "../src/Composer.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 7307 "Composer.c"
	}
}

static void
___lambda113__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 292 "../src/Composer.vala"
	__lambda113_ ((MailComposer*) self, source_object, res);
#line 292 "../src/Composer.vala"
	g_object_unref (self);
#line 7320 "Composer.c"
}

static gboolean
_mail_composer___lambda112_ (MailComposer* self)
{
	gboolean result;
#line 292 "../src/Composer.vala"
	mail_composer_save_draft (self, ___lambda113__gasync_ready_callback, g_object_ref (self));
#line 298 "../src/Composer.vala"
	result = TRUE;
#line 298 "../src/Composer.vala"
	return result;
#line 7333 "Composer.c"
}

static gboolean
__mail_composer___lambda112__gtk_widget_delete_event (GtkWidget* _sender,
                                                      GdkEventAny* event,
                                                      gpointer self)
{
	gboolean result;
	result = _mail_composer___lambda112_ ((MailComposer*) self);
#line 291 "../src/Composer.vala"
	return result;
#line 7345 "Composer.c"
}

static void
_mail_composer___lambda114_ (MailComposer* self)
{
#line 307 "../src/Composer.vala"
	mail_composer_set_default_signature_for_sender (self);
#line 7353 "Composer.c"
}

static void
__mail_composer___lambda114__gtk_combo_box_changed (GtkComboBox* _sender,
                                                    gpointer self)
{
#line 306 "../src/Composer.vala"
	_mail_composer___lambda114_ ((MailComposer*) self);
#line 7362 "Composer.c"
}

static void
_mail_composer___lambda115_ (MailComposer* self)
{
	GtkRevealer* _tmp0_;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 317 "../src/Composer.vala"
	_tmp0_ = self->priv->cc_revealer;
#line 317 "../src/Composer.vala"
	_tmp1_ = self->priv->cc_button;
#line 317 "../src/Composer.vala"
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
#line 317 "../src/Composer.vala"
	_tmp3_ = _tmp2_;
#line 317 "../src/Composer.vala"
	gtk_revealer_set_reveal_child (_tmp0_, _tmp3_);
#line 7382 "Composer.c"
}

static void
__mail_composer___lambda115__gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 316 "../src/Composer.vala"
	_mail_composer___lambda115_ ((MailComposer*) self);
#line 7391 "Composer.c"
}

static void
_mail_composer___lambda116_ (MailComposer* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 321 "../src/Composer.vala"
	_tmp0_ = self->priv->cc_val;
#line 321 "../src/Composer.vala"
	mail_composer_on_sanitize_recipient_entry (self, _tmp0_);
#line 322 "../src/Composer.vala"
	_tmp1_ = self->priv->cc_val;
#line 322 "../src/Composer.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 322 "../src/Composer.vala"
	_tmp3_ = _tmp2_;
#line 322 "../src/Composer.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 7413 "Composer.c"
		GtkToggleButton* _tmp4_;
#line 323 "../src/Composer.vala"
		_tmp4_ = self->priv->cc_button;
#line 323 "../src/Composer.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 7419 "Composer.c"
	} else {
		GtkToggleButton* _tmp5_;
#line 325 "../src/Composer.vala"
		_tmp5_ = self->priv->cc_button;
#line 325 "../src/Composer.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
#line 7426 "Composer.c"
	}
}

static void
__mail_composer___lambda116__gtk_editable_changed (GtkEditable* _sender,
                                                   gpointer self)
{
#line 320 "../src/Composer.vala"
	_mail_composer___lambda116_ ((MailComposer*) self);
#line 7436 "Composer.c"
}

static void
_mail_composer___lambda117_ (Block17Data* _data17_)
{
	MailComposer* self;
	GtkRevealer* _tmp0_;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 329 "../src/Composer.vala"
	self = _data17_->self;
#line 330 "../src/Composer.vala"
	_tmp0_ = self->priv->bcc_revealer;
#line 330 "../src/Composer.vala"
	_tmp1_ = _data17_->bcc_button;
#line 330 "../src/Composer.vala"
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
#line 330 "../src/Composer.vala"
	_tmp3_ = _tmp2_;
#line 330 "../src/Composer.vala"
	gtk_revealer_set_reveal_child (_tmp0_, _tmp3_);
#line 7459 "Composer.c"
}

static void
__mail_composer___lambda117__gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 329 "../src/Composer.vala"
	_mail_composer___lambda117_ (self);
#line 7468 "Composer.c"
}

static void
_mail_composer___lambda118_ (Block17Data* _data17_)
{
	MailComposer* self;
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 333 "../src/Composer.vala"
	self = _data17_->self;
#line 334 "../src/Composer.vala"
	_tmp0_ = self->priv->bcc_val;
#line 334 "../src/Composer.vala"
	mail_composer_on_sanitize_recipient_entry (self, _tmp0_);
#line 335 "../src/Composer.vala"
	_tmp1_ = self->priv->bcc_val;
#line 335 "../src/Composer.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 335 "../src/Composer.vala"
	_tmp3_ = _tmp2_;
#line 335 "../src/Composer.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 7493 "Composer.c"
		GtkToggleButton* _tmp4_;
#line 336 "../src/Composer.vala"
		_tmp4_ = _data17_->bcc_button;
#line 336 "../src/Composer.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 7499 "Composer.c"
	} else {
		GtkToggleButton* _tmp5_;
#line 338 "../src/Composer.vala"
		_tmp5_ = _data17_->bcc_button;
#line 338 "../src/Composer.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
#line 7506 "Composer.c"
	}
}

static void
__mail_composer___lambda118__gtk_editable_changed (GtkEditable* _sender,
                                                   gpointer self)
{
#line 333 "../src/Composer.vala"
	_mail_composer___lambda118_ (self);
#line 7516 "Composer.c"
}

static void
_mail_composer___lambda119_ (MailComposer* self)
{
}

static void
__mail_composer___lambda119__gtk_combo_box_changed (GtkComboBox* _sender,
                                                    gpointer self)
{
#line 342 "../src/Composer.vala"
	_mail_composer___lambda119_ ((MailComposer*) self);
#line 7530 "Composer.c"
}

static void
_mail_composer___lambda120_ (MailComposer* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 347 "../src/Composer.vala"
	_tmp0_ = self->priv->to_val;
#line 347 "../src/Composer.vala"
	mail_composer_on_sanitize_recipient_entry (self, _tmp0_);
#line 348 "../src/Composer.vala"
	_tmp1_ = self->priv->to_val;
#line 348 "../src/Composer.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 348 "../src/Composer.vala"
	_tmp3_ = _tmp2_;
#line 348 "../src/Composer.vala"
	mail_composer_set_has_recipients (self, g_strcmp0 (_tmp3_, "") != 0);
#line 7552 "Composer.c"
}

static void
__mail_composer___lambda120__gtk_editable_changed (GtkEditable* _sender,
                                                   gpointer self)
{
#line 346 "../src/Composer.vala"
	_mail_composer___lambda120_ ((MailComposer*) self);
#line 7561 "Composer.c"
}

static void
_mail_composer___lambda121_ (Block17Data* _data17_)
{
	MailComposer* self;
	GtkStyleContext* to_grid_style_context = NULL;
	MailComposerEntryGrid* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags state = 0U;
	GtkStyleContext* _tmp2_;
	GtkEntry* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkStyleContext* _tmp6_;
#line 351 "../src/Composer.vala"
	self = _data17_->self;
#line 352 "../src/Composer.vala"
	_tmp0_ = _data17_->to_grid;
#line 352 "../src/Composer.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
#line 352 "../src/Composer.vala"
	to_grid_style_context = _tmp1_;
#line 353 "../src/Composer.vala"
	_tmp2_ = to_grid_style_context;
#line 353 "../src/Composer.vala"
	state = gtk_style_context_get_state (_tmp2_);
#line 354 "../src/Composer.vala"
	_tmp3_ = self->priv->to_val;
#line 354 "../src/Composer.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 354 "../src/Composer.vala"
	_tmp5_ = _tmp4_;
#line 354 "../src/Composer.vala"
	if (_tmp5_) {
#line 355 "../src/Composer.vala"
		state |= GTK_STATE_FLAG_FOCUSED;
#line 7599 "Composer.c"
	} else {
#line 357 "../src/Composer.vala"
		state ^= GTK_STATE_FLAG_FOCUSED;
#line 7603 "Composer.c"
	}
#line 360 "../src/Composer.vala"
	_tmp6_ = to_grid_style_context;
#line 360 "../src/Composer.vala"
	gtk_style_context_set_state (_tmp6_, state);
#line 7609 "Composer.c"
}

static void
__mail_composer___lambda121__gtk_style_context_changed (GtkStyleContext* _sender,
                                                        gpointer self)
{
#line 351 "../src/Composer.vala"
	_mail_composer___lambda121_ (self);
#line 7618 "Composer.c"
}

static void
_mail_composer___lambda122_ (Block17Data* _data17_)
{
	MailComposer* self;
	GMenu* _tmp0_;
#line 368 "../src/Composer.vala"
	self = _data17_->self;
#line 368 "../src/Composer.vala"
	_tmp0_ = _data17_->signature_menu;
#line 368 "../src/Composer.vala"
	mail_composer_populate_signature_menu (self, _tmp0_);
#line 7632 "Composer.c"
}

static void
__mail_composer___lambda122__mail_backend_session_signature_changed (MailBackendSession* _sender,
                                                                     gpointer self)
{
#line 368 "../src/Composer.vala"
	_mail_composer___lambda122_ (self);
#line 7641 "Composer.c"
}

static GObject *
mail_composer_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MailComposer * self;
	Block17Data* _data17_;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkApplication* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GtkApplication* _tmp7_;
	GtkApplication* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	GtkApplication* _tmp12_;
	GtkApplication* _tmp13_;
	GList* _tmp14_;
	HdyHeaderBar* headerbar = NULL;
	HdyHeaderBar* _tmp17_ = NULL;
	HdyHeaderBar* _tmp18_;
	GtkStyleContext* _tmp19_;
	HdyHeaderBar* _tmp20_;
	GtkStyleContext* _tmp21_;
	GtkLabel* from_label = NULL;
	GtkLabel* _tmp22_ = NULL;
	GtkLabel* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkComboBoxText* _tmp25_ = NULL;
	GtkBox* from_box = NULL;
	GtkBox* _tmp26_ = NULL;
	GtkBox* _tmp27_;
	GtkLabel* _tmp28_;
	GtkBox* _tmp29_;
	GtkComboBoxText* _tmp30_;
	GtkRevealer* from_revealer = NULL;
	GtkBox* _tmp31_;
	GtkWidget* _tmp32_;
	GtkRevealer* _tmp33_ = NULL;
	GtkLabel* to_label = NULL;
	GtkLabel* _tmp34_ = NULL;
	GtkLabel* _tmp35_;
	GtkStyleContext* _tmp36_;
	GtkLabel* subject_label = NULL;
	GtkLabel* _tmp37_ = NULL;
	GtkLabel* _tmp38_;
	GtkStyleContext* _tmp39_;
	GtkEntry* _tmp40_ = NULL;
	GtkToggleButton* _tmp41_;
	GtkToggleButton* _tmp42_;
	MailComposerEntryGrid* _tmp43_;
	MailComposerEntryGrid* _tmp44_;
	GtkEntry* _tmp45_;
	MailComposerEntryGrid* _tmp46_;
	GtkToggleButton* _tmp47_;
	MailComposerEntryGrid* _tmp48_;
	GtkToggleButton* _tmp49_;
	GtkLabel* cc_label = NULL;
	GtkLabel* _tmp50_ = NULL;
	GtkLabel* _tmp51_;
	GtkStyleContext* _tmp52_;
	GtkEntry* _tmp53_ = NULL;
	GtkBox* cc_box = NULL;
	GtkBox* _tmp54_ = NULL;
	GtkBox* _tmp55_;
	GtkLabel* _tmp56_;
	GtkBox* _tmp57_;
	GtkEntry* _tmp58_;
	GtkRevealer* _tmp59_;
	GtkRevealer* _tmp60_;
	GtkBox* _tmp61_;
	GtkLabel* bcc_label = NULL;
	GtkLabel* _tmp62_ = NULL;
	GtkLabel* _tmp63_;
	GtkStyleContext* _tmp64_;
	GtkEntry* _tmp65_ = NULL;
	GtkBox* bcc_box = NULL;
	GtkBox* _tmp66_ = NULL;
	GtkBox* _tmp67_;
	GtkLabel* _tmp68_;
	GtkBox* _tmp69_;
	GtkEntry* _tmp70_;
	GtkRevealer* _tmp71_;
	GtkRevealer* _tmp72_;
	GtkBox* _tmp73_;
	GtkEntry* _tmp74_ = NULL;
	GtkEntry* _tmp75_;
	GtkSizeGroup* size_group = NULL;
	GtkSizeGroup* _tmp76_;
	GtkSizeGroup* _tmp77_;
	GtkLabel* _tmp78_;
	GtkSizeGroup* _tmp79_;
	GtkLabel* _tmp80_;
	GtkSizeGroup* _tmp81_;
	GtkLabel* _tmp82_;
	GtkSizeGroup* _tmp83_;
	GtkLabel* _tmp84_;
	GtkSizeGroup* _tmp85_;
	GtkLabel* _tmp86_;
	GtkGrid* recipient_grid = NULL;
	GtkGrid* _tmp87_ = NULL;
	GtkGrid* _tmp88_;
	GtkRevealer* _tmp89_;
	GtkGrid* _tmp90_;
	GtkLabel* _tmp91_;
	GtkGrid* _tmp92_;
	MailComposerEntryGrid* _tmp93_;
	GtkGrid* _tmp94_;
	GtkRevealer* _tmp95_;
	GtkGrid* _tmp96_;
	GtkRevealer* _tmp97_;
	GtkGrid* _tmp98_;
	GtkLabel* _tmp99_;
	GtkGrid* _tmp100_;
	GtkEntry* _tmp101_;
	GtkButton* image = NULL;
	gchar* _tmp102_;
	gchar* _tmp103_;
	GtkButton* _tmp104_ = NULL;
	MailWebView* _tmp105_;
	MailWebView* _tmp113_;
	EditorToolbar* editor_toolbar = NULL;
	MailWebView* _tmp114_;
	EditorToolbar* _tmp115_;
	EditorToolbar* _tmp116_;
	GtkButton* _tmp117_;
	GtkFlowBox* _tmp118_ = NULL;
	GtkFlowBox* _tmp119_;
	GtkStyleContext* _tmp120_;
	GtkButton* discard = NULL;
	gchar* _tmp121_;
	GtkApplication* _tmp122_;
	GtkApplication* _tmp123_;
	gchar** _tmp124_;
	gchar** _tmp125_;
	gchar** _tmp126_;
	gint _tmp126__length1;
	gchar* _tmp127_;
	GtkButton* _tmp128_ = NULL;
	GtkButton* _tmp129_;
	GtkButton* attach = NULL;
	gchar* _tmp130_;
	GtkApplication* _tmp131_;
	GtkApplication* _tmp132_;
	gchar** _tmp133_;
	gchar** _tmp134_;
	gchar** _tmp135_;
	gint _tmp135__length1;
	gchar* _tmp136_;
	GtkButton* _tmp137_ = NULL;
	GtkButton* _tmp138_;
	GMenu* _tmp139_;
	GtkMenuButton* signature_button = NULL;
	GtkImage* _tmp140_;
	GMenu* _tmp141_;
	GMenuModel* _tmp142_;
	gchar* _tmp143_;
	GtkMenuButton* _tmp144_ = NULL;
	GtkButton* send = NULL;
	gchar* _tmp145_;
	gchar* _tmp146_;
	GtkApplication* _tmp147_;
	GtkApplication* _tmp148_;
	gchar** _tmp149_;
	gchar** _tmp150_;
	gchar** _tmp151_;
	gint _tmp151__length1;
	gchar* _tmp152_;
	GtkButton* _tmp153_ = NULL;
	GtkButton* _tmp154_;
	GtkButton* _tmp155_;
	GtkStyleContext* _tmp156_;
	GtkActionBar* action_bar = NULL;
	GtkActionBar* _tmp157_ = NULL;
	GtkActionBar* _tmp158_;
	GtkStyleContext* _tmp159_;
	GtkActionBar* _tmp160_;
	GtkButton* _tmp161_;
	GtkActionBar* _tmp162_;
	GtkButton* _tmp163_;
	GtkActionBar* _tmp164_;
	GtkMenuButton* _tmp165_;
	GtkActionBar* _tmp166_;
	GtkButton* _tmp167_;
	GtkOverlay* view_overlay = NULL;
	GtkOverlay* _tmp168_;
	GtkOverlay* _tmp169_;
	MailWebView* _tmp170_;
	GtkOverlay* _tmp171_;
	GraniteWidgetsOverlayBar* _tmp172_;
	GraniteWidgetsOverlayBar* _tmp173_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp174_;
	GtkBox* _tmp175_;
	HdyHeaderBar* _tmp176_;
	GtkBox* _tmp177_;
	GtkGrid* _tmp178_;
	GtkBox* _tmp179_;
	EditorToolbar* _tmp180_;
	GtkBox* _tmp181_;
	GtkSeparator* _tmp182_;
	GtkSeparator* _tmp183_;
	GtkBox* _tmp184_;
	GtkOverlay* _tmp185_;
	GtkBox* _tmp186_;
	GtkFlowBox* _tmp187_;
	GtkBox* _tmp188_;
	GtkActionBar* _tmp189_;
	GtkBox* _tmp190_;
	MailContactManager* contact_manager = NULL;
	MailContactManager* _tmp191_;
	MailContactManager* _tmp192_;
	MailContactManager* _tmp193_;
	GtkEntry* _tmp194_;
	MailContactManager* _tmp195_;
	GtkEntry* _tmp196_;
	MailContactManager* _tmp197_;
	GtkEntry* _tmp198_;
	GtkComboBoxText* _tmp199_;
	GtkRevealer* _tmp200_;
	GtkComboBoxText* _tmp201_;
	GtkTreeModel* _tmp202_;
	GtkTreeModel* _tmp203_;
	GtkButton* _tmp204_;
	HdyHeaderBar* _tmp205_;
	GtkToggleButton* _tmp206_;
	GtkEntry* _tmp207_;
	GtkToggleButton* _tmp208_;
	GtkEntry* _tmp209_;
	GtkComboBoxText* _tmp210_;
	GtkEntry* _tmp211_;
	GtkEntry* _tmp212_;
	GtkStyleContext* _tmp213_;
	const gchar* _tmp214_;
	MailBackendSession* session = NULL;
	MailBackendSession* _tmp217_;
	MailBackendSession* _tmp218_;
	GMenu* _tmp219_;
	const gchar* _tmp220_;
	GError* _inner_error0_ = NULL;
#line 66 "../src/Composer.vala"
	parent_class = G_OBJECT_CLASS (mail_composer_parent_class);
#line 66 "../src/Composer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 66 "../src/Composer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_COMPOSER, MailComposer);
#line 66 "../src/Composer.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 66 "../src/Composer.vala"
	_data17_->_ref_count_ = 1;
#line 66 "../src/Composer.vala"
	_data17_->self = g_object_ref (self);
#line 67 "../src/Composer.vala"
	g_action_map_add_action_entries ((GActionMap*) self, MAIL_COMPOSER_ACTION_ENTRIES, (gint) G_N_ELEMENTS (MAIL_COMPOSER_ACTION_ENTRIES), self);
#line 69 "../src/Composer.vala"
	_tmp0_ = g_application_get_default ();
#line 69 "../src/Composer.vala"
	gtk_window_set_application ((GtkWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 71 "../src/Composer.vala"
	_tmp1_ = gtk_window_get_application ((GtkWindow*) self);
#line 71 "../src/Composer.vala"
	_tmp2_ = _tmp1_;
#line 71 "../src/Composer.vala"
	_tmp3_ = g_strdup ("<Alt>I");
#line 71 "../src/Composer.vala"
	_tmp4_ = g_strdup ("<Shift><Control>A");
#line 71 "../src/Composer.vala"
	_tmp5_ = g_new0 (gchar*, 2 + 1);
#line 71 "../src/Composer.vala"
	_tmp5_[0] = _tmp3_;
#line 71 "../src/Composer.vala"
	_tmp5_[1] = _tmp4_;
#line 71 "../src/Composer.vala"
	_tmp6_ = _tmp5_;
#line 71 "../src/Composer.vala"
	_tmp6__length1 = 2;
#line 71 "../src/Composer.vala"
	gtk_application_set_accels_for_action (_tmp2_, MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_ADD_ATTACHMENT, _tmp6_);
#line 71 "../src/Composer.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 72 "../src/Composer.vala"
	_tmp7_ = gtk_window_get_application ((GtkWindow*) self);
#line 72 "../src/Composer.vala"
	_tmp8_ = _tmp7_;
#line 72 "../src/Composer.vala"
	_tmp9_ = g_strdup ("<Control>Return");
#line 72 "../src/Composer.vala"
	_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 72 "../src/Composer.vala"
	_tmp10_[0] = _tmp9_;
#line 72 "../src/Composer.vala"
	_tmp11_ = _tmp10_;
#line 72 "../src/Composer.vala"
	_tmp11__length1 = 1;
#line 72 "../src/Composer.vala"
	gtk_application_set_accels_for_action (_tmp8_, MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_SEND, _tmp11_);
#line 72 "../src/Composer.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 74 "../src/Composer.vala"
	_tmp12_ = gtk_window_get_application ((GtkWindow*) self);
#line 74 "../src/Composer.vala"
	_tmp13_ = _tmp12_;
#line 74 "../src/Composer.vala"
	_tmp14_ = gtk_application_get_windows (_tmp13_);
#line 7956 "Composer.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 74 "../src/Composer.vala"
		window_collection = _tmp14_;
#line 74 "../src/Composer.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 7964 "Composer.c"
			GtkWindow* window = NULL;
#line 74 "../src/Composer.vala"
			window = (GtkWindow*) window_it->data;
#line 7968 "Composer.c"
			{
				GtkWindow* _tmp15_;
#line 75 "../src/Composer.vala"
				_tmp15_ = window;
#line 75 "../src/Composer.vala"
				if (MAIL_IS_MAIN_WINDOW (_tmp15_)) {
#line 7975 "Composer.c"
					GtkWindow* _tmp16_;
#line 76 "../src/Composer.vala"
					_tmp16_ = window;
#line 76 "../src/Composer.vala"
					gtk_window_set_transient_for ((GtkWindow*) self, _tmp16_);
#line 77 "../src/Composer.vala"
					break;
#line 7983 "Composer.c"
				}
			}
		}
	}
#line 81 "../src/Composer.vala"
	_tmp17_ = (HdyHeaderBar*) hdy_header_bar_new ();
#line 81 "../src/Composer.vala"
	hdy_header_bar_set_has_subtitle (_tmp17_, FALSE);
#line 81 "../src/Composer.vala"
	hdy_header_bar_set_show_close_button (_tmp17_, TRUE);
#line 81 "../src/Composer.vala"
	g_object_ref_sink (_tmp17_);
#line 81 "../src/Composer.vala"
	headerbar = _tmp17_;
#line 85 "../src/Composer.vala"
	_tmp18_ = headerbar;
#line 85 "../src/Composer.vala"
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
#line 85 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp19_, GTK_STYLE_CLASS_FLAT);
#line 86 "../src/Composer.vala"
	_tmp20_ = headerbar;
#line 86 "../src/Composer.vala"
	_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
#line 86 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp21_, "default-decoration");
#line 88 "../src/Composer.vala"
	_tmp22_ = (GtkLabel*) gtk_label_new (_ ("From:"));
#line 88 "../src/Composer.vala"
	gtk_label_set_xalign (_tmp22_, (gfloat) 1);
#line 88 "../src/Composer.vala"
	g_object_ref_sink (_tmp22_);
#line 88 "../src/Composer.vala"
	from_label = _tmp22_;
#line 91 "../src/Composer.vala"
	_tmp23_ = from_label;
#line 91 "../src/Composer.vala"
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) _tmp23_);
#line 91 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp24_, GTK_STYLE_CLASS_DIM_LABEL);
#line 93 "../src/Composer.vala"
	_tmp25_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 93 "../src/Composer.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp25_, TRUE);
#line 93 "../src/Composer.vala"
	g_object_ref_sink (_tmp25_);
#line 93 "../src/Composer.vala"
	_g_object_unref0 (self->priv->from_combo);
#line 93 "../src/Composer.vala"
	self->priv->from_combo = _tmp25_;
#line 97 "../src/Composer.vala"
	_tmp26_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 97 "../src/Composer.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp26_, 6);
#line 97 "../src/Composer.vala"
	g_object_ref_sink (_tmp26_);
#line 97 "../src/Composer.vala"
	from_box = _tmp26_;
#line 100 "../src/Composer.vala"
	_tmp27_ = from_box;
#line 100 "../src/Composer.vala"
	_tmp28_ = from_label;
#line 100 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 101 "../src/Composer.vala"
	_tmp29_ = from_box;
#line 101 "../src/Composer.vala"
	_tmp30_ = self->priv->from_combo;
#line 101 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
#line 103 "../src/Composer.vala"
	_tmp31_ = from_box;
#line 103 "../src/Composer.vala"
	_tmp32_ = _g_object_ref0 ((GtkWidget*) _tmp31_);
#line 103 "../src/Composer.vala"
	_tmp33_ = (GtkRevealer*) gtk_revealer_new ();
#line 103 "../src/Composer.vala"
	g_object_set ((GtkContainer*) _tmp33_, "child", _tmp32_, NULL);
#line 103 "../src/Composer.vala"
	_g_object_unref0 (_tmp32_);
#line 103 "../src/Composer.vala"
	g_object_ref_sink (_tmp33_);
#line 103 "../src/Composer.vala"
	from_revealer = _tmp33_;
#line 107 "../src/Composer.vala"
	_tmp34_ = (GtkLabel*) gtk_label_new (_ ("To:"));
#line 107 "../src/Composer.vala"
	gtk_label_set_xalign (_tmp34_, (gfloat) 1);
#line 107 "../src/Composer.vala"
	g_object_ref_sink (_tmp34_);
#line 107 "../src/Composer.vala"
	to_label = _tmp34_;
#line 110 "../src/Composer.vala"
	_tmp35_ = to_label;
#line 110 "../src/Composer.vala"
	_tmp36_ = gtk_widget_get_style_context ((GtkWidget*) _tmp35_);
#line 110 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp36_, GTK_STYLE_CLASS_DIM_LABEL);
#line 112 "../src/Composer.vala"
	_tmp37_ = (GtkLabel*) gtk_label_new (_ ("Subject:"));
#line 112 "../src/Composer.vala"
	gtk_label_set_xalign (_tmp37_, (gfloat) 1);
#line 112 "../src/Composer.vala"
	g_object_ref_sink (_tmp37_);
#line 112 "../src/Composer.vala"
	subject_label = _tmp37_;
#line 115 "../src/Composer.vala"
	_tmp38_ = subject_label;
#line 115 "../src/Composer.vala"
	_tmp39_ = gtk_widget_get_style_context ((GtkWidget*) _tmp38_);
#line 115 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp39_, GTK_STYLE_CLASS_DIM_LABEL);
#line 117 "../src/Composer.vala"
	_tmp40_ = (GtkEntry*) gtk_entry_new ();
#line 117 "../src/Composer.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp40_, TRUE);
#line 117 "../src/Composer.vala"
	g_object_ref_sink (_tmp40_);
#line 117 "../src/Composer.vala"
	_g_object_unref0 (self->priv->to_val);
#line 117 "../src/Composer.vala"
	self->priv->to_val = _tmp40_;
#line 121 "../src/Composer.vala"
	_tmp41_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("Cc"));
#line 121 "../src/Composer.vala"
	g_object_ref_sink (_tmp41_);
#line 121 "../src/Composer.vala"
	_g_object_unref0 (self->priv->cc_button);
#line 121 "../src/Composer.vala"
	self->priv->cc_button = _tmp41_;
#line 123 "../src/Composer.vala"
	_tmp42_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("Bcc"));
#line 123 "../src/Composer.vala"
	g_object_ref_sink (_tmp42_);
#line 123 "../src/Composer.vala"
	_data17_->bcc_button = _tmp42_;
#line 125 "../src/Composer.vala"
	_tmp43_ = mail_composer_entry_grid_new ();
#line 125 "../src/Composer.vala"
	g_object_ref_sink (_tmp43_);
#line 125 "../src/Composer.vala"
	_data17_->to_grid = _tmp43_;
#line 126 "../src/Composer.vala"
	_tmp44_ = _data17_->to_grid;
#line 126 "../src/Composer.vala"
	_tmp45_ = self->priv->to_val;
#line 126 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
#line 127 "../src/Composer.vala"
	_tmp46_ = _data17_->to_grid;
#line 127 "../src/Composer.vala"
	_tmp47_ = self->priv->cc_button;
#line 127 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
#line 128 "../src/Composer.vala"
	_tmp48_ = _data17_->to_grid;
#line 128 "../src/Composer.vala"
	_tmp49_ = _data17_->bcc_button;
#line 128 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
#line 130 "../src/Composer.vala"
	_tmp50_ = (GtkLabel*) gtk_label_new (_ ("Cc:"));
#line 130 "../src/Composer.vala"
	gtk_label_set_xalign (_tmp50_, (gfloat) 1);
#line 130 "../src/Composer.vala"
	g_object_ref_sink (_tmp50_);
#line 130 "../src/Composer.vala"
	cc_label = _tmp50_;
#line 133 "../src/Composer.vala"
	_tmp51_ = cc_label;
#line 133 "../src/Composer.vala"
	_tmp52_ = gtk_widget_get_style_context ((GtkWidget*) _tmp51_);
#line 133 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp52_, GTK_STYLE_CLASS_DIM_LABEL);
#line 135 "../src/Composer.vala"
	_tmp53_ = (GtkEntry*) gtk_entry_new ();
#line 135 "../src/Composer.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp53_, TRUE);
#line 135 "../src/Composer.vala"
	g_object_ref_sink (_tmp53_);
#line 135 "../src/Composer.vala"
	_g_object_unref0 (self->priv->cc_val);
#line 135 "../src/Composer.vala"
	self->priv->cc_val = _tmp53_;
#line 139 "../src/Composer.vala"
	_tmp54_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 139 "../src/Composer.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp54_, 6);
#line 139 "../src/Composer.vala"
	g_object_ref_sink (_tmp54_);
#line 139 "../src/Composer.vala"
	cc_box = _tmp54_;
#line 142 "../src/Composer.vala"
	_tmp55_ = cc_box;
#line 142 "../src/Composer.vala"
	_tmp56_ = cc_label;
#line 142 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
#line 143 "../src/Composer.vala"
	_tmp57_ = cc_box;
#line 143 "../src/Composer.vala"
	_tmp58_ = self->priv->cc_val;
#line 143 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
#line 145 "../src/Composer.vala"
	_tmp59_ = (GtkRevealer*) gtk_revealer_new ();
#line 145 "../src/Composer.vala"
	g_object_ref_sink (_tmp59_);
#line 145 "../src/Composer.vala"
	_g_object_unref0 (self->priv->cc_revealer);
#line 145 "../src/Composer.vala"
	self->priv->cc_revealer = _tmp59_;
#line 146 "../src/Composer.vala"
	_tmp60_ = self->priv->cc_revealer;
#line 146 "../src/Composer.vala"
	_tmp61_ = cc_box;
#line 146 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp60_, (GtkWidget*) _tmp61_);
#line 148 "../src/Composer.vala"
	_tmp62_ = (GtkLabel*) gtk_label_new (_ ("Bcc:"));
#line 148 "../src/Composer.vala"
	gtk_label_set_xalign (_tmp62_, (gfloat) 1);
#line 148 "../src/Composer.vala"
	g_object_ref_sink (_tmp62_);
#line 148 "../src/Composer.vala"
	bcc_label = _tmp62_;
#line 151 "../src/Composer.vala"
	_tmp63_ = bcc_label;
#line 151 "../src/Composer.vala"
	_tmp64_ = gtk_widget_get_style_context ((GtkWidget*) _tmp63_);
#line 151 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp64_, GTK_STYLE_CLASS_DIM_LABEL);
#line 153 "../src/Composer.vala"
	_tmp65_ = (GtkEntry*) gtk_entry_new ();
#line 153 "../src/Composer.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp65_, TRUE);
#line 153 "../src/Composer.vala"
	g_object_ref_sink (_tmp65_);
#line 153 "../src/Composer.vala"
	_g_object_unref0 (self->priv->bcc_val);
#line 153 "../src/Composer.vala"
	self->priv->bcc_val = _tmp65_;
#line 157 "../src/Composer.vala"
	_tmp66_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 157 "../src/Composer.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp66_, 6);
#line 157 "../src/Composer.vala"
	g_object_ref_sink (_tmp66_);
#line 157 "../src/Composer.vala"
	bcc_box = _tmp66_;
#line 160 "../src/Composer.vala"
	_tmp67_ = bcc_box;
#line 160 "../src/Composer.vala"
	_tmp68_ = bcc_label;
#line 160 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
#line 161 "../src/Composer.vala"
	_tmp69_ = bcc_box;
#line 161 "../src/Composer.vala"
	_tmp70_ = self->priv->bcc_val;
#line 161 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp69_, (GtkWidget*) _tmp70_);
#line 163 "../src/Composer.vala"
	_tmp71_ = (GtkRevealer*) gtk_revealer_new ();
#line 163 "../src/Composer.vala"
	g_object_ref_sink (_tmp71_);
#line 163 "../src/Composer.vala"
	_g_object_unref0 (self->priv->bcc_revealer);
#line 163 "../src/Composer.vala"
	self->priv->bcc_revealer = _tmp71_;
#line 164 "../src/Composer.vala"
	_tmp72_ = self->priv->bcc_revealer;
#line 164 "../src/Composer.vala"
	_tmp73_ = bcc_box;
#line 164 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp72_, (GtkWidget*) _tmp73_);
#line 166 "../src/Composer.vala"
	_tmp74_ = (GtkEntry*) gtk_entry_new ();
#line 166 "../src/Composer.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp74_, 6);
#line 166 "../src/Composer.vala"
	g_object_ref_sink (_tmp74_);
#line 166 "../src/Composer.vala"
	_g_object_unref0 (self->priv->subject_val);
#line 166 "../src/Composer.vala"
	self->priv->subject_val = _tmp74_;
#line 170 "../src/Composer.vala"
	_tmp75_ = self->priv->subject_val;
#line 170 "../src/Composer.vala"
	g_signal_connect_object ((GtkEditable*) _tmp75_, "changed", (GCallback) __mail_composer___lambda103__gtk_editable_changed, self, 0);
#line 174 "../src/Composer.vala"
	_tmp76_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 174 "../src/Composer.vala"
	size_group = _tmp76_;
#line 175 "../src/Composer.vala"
	_tmp77_ = size_group;
#line 175 "../src/Composer.vala"
	_tmp78_ = from_label;
#line 175 "../src/Composer.vala"
	gtk_size_group_add_widget (_tmp77_, (GtkWidget*) _tmp78_);
#line 176 "../src/Composer.vala"
	_tmp79_ = size_group;
#line 176 "../src/Composer.vala"
	_tmp80_ = to_label;
#line 176 "../src/Composer.vala"
	gtk_size_group_add_widget (_tmp79_, (GtkWidget*) _tmp80_);
#line 177 "../src/Composer.vala"
	_tmp81_ = size_group;
#line 177 "../src/Composer.vala"
	_tmp82_ = cc_label;
#line 177 "../src/Composer.vala"
	gtk_size_group_add_widget (_tmp81_, (GtkWidget*) _tmp82_);
#line 178 "../src/Composer.vala"
	_tmp83_ = size_group;
#line 178 "../src/Composer.vala"
	_tmp84_ = bcc_label;
#line 178 "../src/Composer.vala"
	gtk_size_group_add_widget (_tmp83_, (GtkWidget*) _tmp84_);
#line 179 "../src/Composer.vala"
	_tmp85_ = size_group;
#line 179 "../src/Composer.vala"
	_tmp86_ = subject_label;
#line 179 "../src/Composer.vala"
	gtk_size_group_add_widget (_tmp85_, (GtkWidget*) _tmp86_);
#line 181 "../src/Composer.vala"
	_tmp87_ = (GtkGrid*) gtk_grid_new ();
#line 181 "../src/Composer.vala"
	gtk_grid_set_column_spacing (_tmp87_, 6);
#line 181 "../src/Composer.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp87_, 6);
#line 181 "../src/Composer.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp87_, 6);
#line 181 "../src/Composer.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp87_, 6);
#line 181 "../src/Composer.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp87_, 6);
#line 181 "../src/Composer.vala"
	g_object_ref_sink (_tmp87_);
#line 181 "../src/Composer.vala"
	recipient_grid = _tmp87_;
#line 188 "../src/Composer.vala"
	_tmp88_ = recipient_grid;
#line 188 "../src/Composer.vala"
	_tmp89_ = from_revealer;
#line 188 "../src/Composer.vala"
	gtk_grid_attach (_tmp88_, (GtkWidget*) _tmp89_, 0, 0, 2, 1);
#line 189 "../src/Composer.vala"
	_tmp90_ = recipient_grid;
#line 189 "../src/Composer.vala"
	_tmp91_ = to_label;
#line 189 "../src/Composer.vala"
	gtk_grid_attach (_tmp90_, (GtkWidget*) _tmp91_, 0, 1, 1, 1);
#line 190 "../src/Composer.vala"
	_tmp92_ = recipient_grid;
#line 190 "../src/Composer.vala"
	_tmp93_ = _data17_->to_grid;
#line 190 "../src/Composer.vala"
	gtk_grid_attach (_tmp92_, (GtkWidget*) _tmp93_, 1, 1, 1, 1);
#line 191 "../src/Composer.vala"
	_tmp94_ = recipient_grid;
#line 191 "../src/Composer.vala"
	_tmp95_ = self->priv->cc_revealer;
#line 191 "../src/Composer.vala"
	gtk_grid_attach (_tmp94_, (GtkWidget*) _tmp95_, 0, 2, 2, 1);
#line 192 "../src/Composer.vala"
	_tmp96_ = recipient_grid;
#line 192 "../src/Composer.vala"
	_tmp97_ = self->priv->bcc_revealer;
#line 192 "../src/Composer.vala"
	gtk_grid_attach (_tmp96_, (GtkWidget*) _tmp97_, 0, 3, 2, 1);
#line 193 "../src/Composer.vala"
	_tmp98_ = recipient_grid;
#line 193 "../src/Composer.vala"
	_tmp99_ = subject_label;
#line 193 "../src/Composer.vala"
	gtk_grid_attach (_tmp98_, (GtkWidget*) _tmp99_, 0, 4, 1, 1);
#line 194 "../src/Composer.vala"
	_tmp100_ = recipient_grid;
#line 194 "../src/Composer.vala"
	_tmp101_ = self->priv->subject_val;
#line 194 "../src/Composer.vala"
	gtk_grid_attach (_tmp100_, (GtkWidget*) _tmp101_, 1, 4, 1, 1);
#line 196 "../src/Composer.vala"
	_tmp102_ = g_strdup (MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_INSERT_IMAGE);
#line 196 "../src/Composer.vala"
	_tmp103_ = g_strdup (_ ("Insert Image"));
#line 196 "../src/Composer.vala"
	_tmp104_ = (GtkButton*) gtk_button_new_from_icon_name ("insert-image-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 196 "../src/Composer.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp104_, _tmp102_);
#line 196 "../src/Composer.vala"
	_g_free0 (_tmp102_);
#line 196 "../src/Composer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp104_, _tmp103_);
#line 196 "../src/Composer.vala"
	_g_free0 (_tmp103_);
#line 196 "../src/Composer.vala"
	g_object_ref_sink (_tmp104_);
#line 196 "../src/Composer.vala"
	image = _tmp104_;
#line 201 "../src/Composer.vala"
	_tmp105_ = mail_web_view_new ();
#line 201 "../src/Composer.vala"
	g_object_ref_sink (_tmp105_);
#line 201 "../src/Composer.vala"
	_g_object_unref0 (self->priv->web_view);
#line 201 "../src/Composer.vala"
	self->priv->web_view = _tmp105_;
#line 8392 "Composer.c"
	{
		GBytes* template = NULL;
		GBytes* _tmp106_;
		MailWebView* _tmp107_;
		GBytes* _tmp108_;
		gsize _tmp109_ = 0;
		guint8* _tmp110_;
#line 203 "../src/Composer.vala"
		_tmp106_ = g_resources_lookup_data ("/io/elementary/mail/blank-message-template.html", G_RESOURCE_LOOKUP_FLAGS_NONE, &_inner_error0_);
#line 203 "../src/Composer.vala"
		template = _tmp106_;
#line 203 "../src/Composer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8406 "Composer.c"
			goto __catch0_g_error;
		}
#line 204 "../src/Composer.vala"
		_tmp107_ = self->priv->web_view;
#line 204 "../src/Composer.vala"
		_tmp108_ = template;
#line 204 "../src/Composer.vala"
		_tmp110_ = g_bytes_get_data (_tmp108_, &_tmp109_);
#line 204 "../src/Composer.vala"
		mail_web_view_load_html (_tmp107_, (const gchar*) _tmp110_);
#line 202 "../src/Composer.vala"
		_g_bytes_unref0 (template);
#line 8419 "Composer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp111_;
		const gchar* _tmp112_;
#line 202 "../src/Composer.vala"
		e = _inner_error0_;
#line 202 "../src/Composer.vala"
		_inner_error0_ = NULL;
#line 206 "../src/Composer.vala"
		_tmp111_ = e;
#line 206 "../src/Composer.vala"
		_tmp112_ = _tmp111_->message;
#line 206 "../src/Composer.vala"
		g_warning ("Composer.vala:206: Failed to load blank message template: %s", _tmp112_);
#line 202 "../src/Composer.vala"
		_g_error_free0 (e);
#line 8439 "Composer.c"
	}
	__finally0:
#line 202 "../src/Composer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../src/Composer.vala"
		_g_object_unref0 (image);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (recipient_grid);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (size_group);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (bcc_box);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (bcc_label);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (cc_box);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (cc_label);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (subject_label);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (to_label);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (from_revealer);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (from_box);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (from_label);
#line 202 "../src/Composer.vala"
		_g_object_unref0 (headerbar);
#line 202 "../src/Composer.vala"
		block17_data_unref (_data17_);
#line 202 "../src/Composer.vala"
		_data17_ = NULL;
#line 202 "../src/Composer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../src/Composer.vala"
		g_clear_error (&_inner_error0_);
#line 8478 "Composer.c"
	}
#line 209 "../src/Composer.vala"
	_tmp113_ = self->priv->web_view;
#line 209 "../src/Composer.vala"
	g_signal_connect_object ((WebKitWebView*) _tmp113_, "mouse-target-changed", (GCallback) _mail_composer_on_mouse_target_changed_webkit_web_view_mouse_target_changed, self, 0);
#line 211 "../src/Composer.vala"
	_tmp114_ = self->priv->web_view;
#line 211 "../src/Composer.vala"
	_tmp115_ = editor_toolbar_new (_tmp114_);
#line 211 "../src/Composer.vala"
	g_object_ref_sink (_tmp115_);
#line 211 "../src/Composer.vala"
	editor_toolbar = _tmp115_;
#line 212 "../src/Composer.vala"
	_tmp116_ = editor_toolbar;
#line 212 "../src/Composer.vala"
	_tmp117_ = image;
#line 212 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp116_, (GtkWidget*) _tmp117_);
#line 214 "../src/Composer.vala"
	_tmp118_ = (GtkFlowBox*) gtk_flow_box_new ();
#line 214 "../src/Composer.vala"
	gtk_flow_box_set_homogeneous (_tmp118_, TRUE);
#line 214 "../src/Composer.vala"
	gtk_flow_box_set_selection_mode (_tmp118_, GTK_SELECTION_NONE);
#line 214 "../src/Composer.vala"
	g_object_ref_sink (_tmp118_);
#line 214 "../src/Composer.vala"
	_g_object_unref0 (self->priv->attachment_box);
#line 214 "../src/Composer.vala"
	self->priv->attachment_box = _tmp118_;
#line 218 "../src/Composer.vala"
	_tmp119_ = self->priv->attachment_box;
#line 218 "../src/Composer.vala"
	_tmp120_ = gtk_widget_get_style_context ((GtkWidget*) _tmp119_);
#line 218 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp120_, GTK_STYLE_CLASS_VIEW);
#line 220 "../src/Composer.vala"
	_tmp121_ = g_strdup (MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_DISCARD);
#line 220 "../src/Composer.vala"
	_tmp122_ = gtk_window_get_application ((GtkWindow*) self);
#line 220 "../src/Composer.vala"
	_tmp123_ = _tmp122_;
#line 220 "../src/Composer.vala"
	_tmp125_ = _tmp124_ = gtk_application_get_accels_for_action (_tmp123_, MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_DISCARD);
#line 220 "../src/Composer.vala"
	_tmp126_ = _tmp125_;
#line 220 "../src/Composer.vala"
	_tmp126__length1 = _vala_array_length (_tmp124_);
#line 220 "../src/Composer.vala"
	_tmp127_ = granite_markup_accel_tooltip (_tmp126_, (gint) _vala_array_length (_tmp124_), _ ("Delete draft"));
#line 220 "../src/Composer.vala"
	_tmp128_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-delete-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 220 "../src/Composer.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp128_, _tmp121_);
#line 220 "../src/Composer.vala"
	_g_free0 (_tmp121_);
#line 220 "../src/Composer.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp128_, _tmp127_);
#line 220 "../src/Composer.vala"
	_g_free0 (_tmp127_);
#line 220 "../src/Composer.vala"
	g_object_ref_sink (_tmp128_);
#line 220 "../src/Composer.vala"
	_tmp129_ = _tmp128_;
#line 220 "../src/Composer.vala"
	_tmp126_ = (_vala_array_free (_tmp126_, _tmp126__length1, (GDestroyNotify) g_free), NULL);
#line 220 "../src/Composer.vala"
	discard = _tmp129_;
#line 228 "../src/Composer.vala"
	_tmp130_ = g_strdup (MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_ADD_ATTACHMENT);
#line 228 "../src/Composer.vala"
	_tmp131_ = gtk_window_get_application ((GtkWindow*) self);
#line 228 "../src/Composer.vala"
	_tmp132_ = _tmp131_;
#line 228 "../src/Composer.vala"
	_tmp134_ = _tmp133_ = gtk_application_get_accels_for_action (_tmp132_, MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_ADD_ATTACHMENT);
#line 228 "../src/Composer.vala"
	_tmp135_ = _tmp134_;
#line 228 "../src/Composer.vala"
	_tmp135__length1 = _vala_array_length (_tmp133_);
#line 228 "../src/Composer.vala"
	_tmp136_ = granite_markup_accel_tooltip (_tmp135_, (gint) _vala_array_length (_tmp133_), _ ("Attach file"));
#line 228 "../src/Composer.vala"
	_tmp137_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-attachment-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 228 "../src/Composer.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp137_, _tmp130_);
#line 228 "../src/Composer.vala"
	_g_free0 (_tmp130_);
#line 228 "../src/Composer.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp137_, _tmp136_);
#line 228 "../src/Composer.vala"
	_g_free0 (_tmp136_);
#line 228 "../src/Composer.vala"
	g_object_ref_sink (_tmp137_);
#line 228 "../src/Composer.vala"
	_tmp138_ = _tmp137_;
#line 228 "../src/Composer.vala"
	_tmp135_ = (_vala_array_free (_tmp135_, _tmp135__length1, (GDestroyNotify) g_free), NULL);
#line 228 "../src/Composer.vala"
	attach = _tmp138_;
#line 236 "../src/Composer.vala"
	_tmp139_ = g_menu_new ();
#line 236 "../src/Composer.vala"
	_data17_->signature_menu = _tmp139_;
#line 238 "../src/Composer.vala"
	_tmp140_ = (GtkImage*) gtk_image_new_from_icon_name ("document-edit-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 238 "../src/Composer.vala"
	g_object_ref_sink (_tmp140_);
#line 238 "../src/Composer.vala"
	_tmp141_ = _data17_->signature_menu;
#line 238 "../src/Composer.vala"
	_tmp142_ = _g_object_ref0 ((GMenuModel*) _tmp141_);
#line 238 "../src/Composer.vala"
	_tmp143_ = g_strdup (_ ("Insert Signature…"));
#line 238 "../src/Composer.vala"
	_tmp144_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 238 "../src/Composer.vala"
	gtk_button_set_image ((GtkButton*) _tmp144_, (GtkWidget*) _tmp140_);
#line 238 "../src/Composer.vala"
	_g_object_unref0 (_tmp140_);
#line 238 "../src/Composer.vala"
	gtk_menu_button_set_menu_model (_tmp144_, _tmp142_);
#line 238 "../src/Composer.vala"
	_g_object_unref0 (_tmp142_);
#line 238 "../src/Composer.vala"
	gtk_menu_button_set_use_popover (_tmp144_, FALSE);
#line 238 "../src/Composer.vala"
	gtk_menu_button_set_direction (_tmp144_, GTK_ARROW_UP);
#line 238 "../src/Composer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp144_, _tmp143_);
#line 238 "../src/Composer.vala"
	_g_free0 (_tmp143_);
#line 238 "../src/Composer.vala"
	g_object_ref_sink (_tmp144_);
#line 238 "../src/Composer.vala"
	signature_button = _tmp144_;
#line 246 "../src/Composer.vala"
	_tmp145_ = g_strdup (MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_SEND);
#line 246 "../src/Composer.vala"
	_tmp146_ = g_strdup (_ ("Send"));
#line 246 "../src/Composer.vala"
	_tmp147_ = gtk_window_get_application ((GtkWindow*) self);
#line 246 "../src/Composer.vala"
	_tmp148_ = _tmp147_;
#line 246 "../src/Composer.vala"
	_tmp150_ = _tmp149_ = gtk_application_get_accels_for_action (_tmp148_, MAIL_COMPOSER_ACTION_PREFIX MAIL_COMPOSER_ACTION_SEND);
#line 246 "../src/Composer.vala"
	_tmp151_ = _tmp150_;
#line 246 "../src/Composer.vala"
	_tmp151__length1 = _vala_array_length (_tmp149_);
#line 246 "../src/Composer.vala"
	_tmp152_ = granite_markup_accel_tooltip (_tmp151_, (gint) _vala_array_length (_tmp149_), NULL);
#line 246 "../src/Composer.vala"
	_tmp153_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-send-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 246 "../src/Composer.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp153_, _tmp145_);
#line 246 "../src/Composer.vala"
	_g_free0 (_tmp145_);
#line 246 "../src/Composer.vala"
	gtk_button_set_always_show_image (_tmp153_, TRUE);
#line 246 "../src/Composer.vala"
	gtk_button_set_label (_tmp153_, _tmp146_);
#line 246 "../src/Composer.vala"
	_g_free0 (_tmp146_);
#line 246 "../src/Composer.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp153_, 6);
#line 246 "../src/Composer.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp153_, 0);
#line 246 "../src/Composer.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp153_, 6);
#line 246 "../src/Composer.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp153_, 6);
#line 246 "../src/Composer.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp153_, FALSE);
#line 246 "../src/Composer.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp153_, _tmp152_);
#line 246 "../src/Composer.vala"
	_g_free0 (_tmp152_);
#line 246 "../src/Composer.vala"
	g_object_ref_sink (_tmp153_);
#line 246 "../src/Composer.vala"
	_tmp154_ = _tmp153_;
#line 246 "../src/Composer.vala"
	_tmp151_ = (_vala_array_free (_tmp151_, _tmp151__length1, (GDestroyNotify) g_free), NULL);
#line 246 "../src/Composer.vala"
	send = _tmp154_;
#line 259 "../src/Composer.vala"
	_tmp155_ = send;
#line 259 "../src/Composer.vala"
	_tmp156_ = gtk_widget_get_style_context ((GtkWidget*) _tmp155_);
#line 259 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp156_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 261 "../src/Composer.vala"
	_tmp157_ = (GtkActionBar*) gtk_action_bar_new ();
#line 261 "../src/Composer.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp157_, 1);
#line 261 "../src/Composer.vala"
	g_object_ref_sink (_tmp157_);
#line 261 "../src/Composer.vala"
	action_bar = _tmp157_;
#line 265 "../src/Composer.vala"
	_tmp158_ = action_bar;
#line 265 "../src/Composer.vala"
	_tmp159_ = gtk_widget_get_style_context ((GtkWidget*) _tmp158_);
#line 265 "../src/Composer.vala"
	gtk_style_context_add_class (_tmp159_, GTK_STYLE_CLASS_FLAT);
#line 266 "../src/Composer.vala"
	_tmp160_ = action_bar;
#line 266 "../src/Composer.vala"
	_tmp161_ = discard;
#line 266 "../src/Composer.vala"
	gtk_action_bar_pack_start (_tmp160_, (GtkWidget*) _tmp161_);
#line 267 "../src/Composer.vala"
	_tmp162_ = action_bar;
#line 267 "../src/Composer.vala"
	_tmp163_ = attach;
#line 267 "../src/Composer.vala"
	gtk_action_bar_pack_start (_tmp162_, (GtkWidget*) _tmp163_);
#line 268 "../src/Composer.vala"
	_tmp164_ = action_bar;
#line 268 "../src/Composer.vala"
	_tmp165_ = signature_button;
#line 268 "../src/Composer.vala"
	gtk_action_bar_pack_start (_tmp164_, (GtkWidget*) _tmp165_);
#line 269 "../src/Composer.vala"
	_tmp166_ = action_bar;
#line 269 "../src/Composer.vala"
	_tmp167_ = send;
#line 269 "../src/Composer.vala"
	gtk_action_bar_pack_end (_tmp166_, (GtkWidget*) _tmp167_);
#line 271 "../src/Composer.vala"
	_tmp168_ = (GtkOverlay*) gtk_overlay_new ();
#line 271 "../src/Composer.vala"
	g_object_ref_sink (_tmp168_);
#line 271 "../src/Composer.vala"
	view_overlay = _tmp168_;
#line 272 "../src/Composer.vala"
	_tmp169_ = view_overlay;
#line 272 "../src/Composer.vala"
	_tmp170_ = self->priv->web_view;
#line 272 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp169_, (GtkWidget*) _tmp170_);
#line 273 "../src/Composer.vala"
	_tmp171_ = view_overlay;
#line 273 "../src/Composer.vala"
	_tmp172_ = granite_widgets_overlay_bar_new (_tmp171_);
#line 273 "../src/Composer.vala"
	g_object_ref_sink (_tmp172_);
#line 273 "../src/Composer.vala"
	_g_object_unref0 (self->priv->message_url_overlay);
#line 273 "../src/Composer.vala"
	self->priv->message_url_overlay = _tmp172_;
#line 274 "../src/Composer.vala"
	_tmp173_ = self->priv->message_url_overlay;
#line 274 "../src/Composer.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp173_, TRUE);
#line 276 "../src/Composer.vala"
	_tmp174_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 276 "../src/Composer.vala"
	g_object_ref_sink (_tmp174_);
#line 276 "../src/Composer.vala"
	main_box = _tmp174_;
#line 277 "../src/Composer.vala"
	_tmp175_ = main_box;
#line 277 "../src/Composer.vala"
	_tmp176_ = headerbar;
#line 277 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp175_, (GtkWidget*) _tmp176_);
#line 278 "../src/Composer.vala"
	_tmp177_ = main_box;
#line 278 "../src/Composer.vala"
	_tmp178_ = recipient_grid;
#line 278 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp177_, (GtkWidget*) _tmp178_);
#line 279 "../src/Composer.vala"
	_tmp179_ = main_box;
#line 279 "../src/Composer.vala"
	_tmp180_ = editor_toolbar;
#line 279 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp179_, (GtkWidget*) _tmp180_);
#line 280 "../src/Composer.vala"
	_tmp181_ = main_box;
#line 280 "../src/Composer.vala"
	_tmp182_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 280 "../src/Composer.vala"
	g_object_ref_sink (_tmp182_);
#line 280 "../src/Composer.vala"
	_tmp183_ = _tmp182_;
#line 280 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp181_, (GtkWidget*) _tmp183_);
#line 280 "../src/Composer.vala"
	_g_object_unref0 (_tmp183_);
#line 281 "../src/Composer.vala"
	_tmp184_ = main_box;
#line 281 "../src/Composer.vala"
	_tmp185_ = view_overlay;
#line 281 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp184_, (GtkWidget*) _tmp185_);
#line 282 "../src/Composer.vala"
	_tmp186_ = main_box;
#line 282 "../src/Composer.vala"
	_tmp187_ = self->priv->attachment_box;
#line 282 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp186_, (GtkWidget*) _tmp187_);
#line 283 "../src/Composer.vala"
	_tmp188_ = main_box;
#line 283 "../src/Composer.vala"
	_tmp189_ = action_bar;
#line 283 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) _tmp188_, (GtkWidget*) _tmp189_);
#line 285 "../src/Composer.vala"
	g_object_set ((GtkWindow*) self, "default-height", 500, NULL);
#line 286 "../src/Composer.vala"
	g_object_set ((GtkWindow*) self, "default-width", 680, NULL);
#line 287 "../src/Composer.vala"
	gtk_window_set_title ((GtkWindow*) self, _ ("New Message"));
#line 288 "../src/Composer.vala"
	_tmp190_ = main_box;
#line 288 "../src/Composer.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp190_);
#line 289 "../src/Composer.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 291 "../src/Composer.vala"
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) __mail_composer___lambda112__gtk_widget_delete_event, self, 0);
#line 301 "../src/Composer.vala"
	_tmp191_ = mail_contact_manager_get_default ();
#line 301 "../src/Composer.vala"
	_tmp192_ = _g_object_ref0 (_tmp191_);
#line 301 "../src/Composer.vala"
	contact_manager = _tmp192_;
#line 302 "../src/Composer.vala"
	_tmp193_ = contact_manager;
#line 302 "../src/Composer.vala"
	_tmp194_ = self->priv->to_val;
#line 302 "../src/Composer.vala"
	mail_contact_manager_setup_entry (_tmp193_, _tmp194_);
#line 303 "../src/Composer.vala"
	_tmp195_ = contact_manager;
#line 303 "../src/Composer.vala"
	_tmp196_ = self->priv->cc_val;
#line 303 "../src/Composer.vala"
	mail_contact_manager_setup_entry (_tmp195_, _tmp196_);
#line 304 "../src/Composer.vala"
	_tmp197_ = contact_manager;
#line 304 "../src/Composer.vala"
	_tmp198_ = self->priv->bcc_val;
#line 304 "../src/Composer.vala"
	mail_contact_manager_setup_entry (_tmp197_, _tmp198_);
#line 306 "../src/Composer.vala"
	_tmp199_ = self->priv->from_combo;
#line 306 "../src/Composer.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp199_, "changed", (GCallback) __mail_composer___lambda114__gtk_combo_box_changed, self, 0);
#line 310 "../src/Composer.vala"
	mail_composer_load_from_combobox (self);
#line 311 "../src/Composer.vala"
	_tmp200_ = from_revealer;
#line 311 "../src/Composer.vala"
	_tmp201_ = self->priv->from_combo;
#line 311 "../src/Composer.vala"
	_tmp202_ = gtk_combo_box_get_model ((GtkComboBox*) _tmp201_);
#line 311 "../src/Composer.vala"
	_tmp203_ = _tmp202_;
#line 311 "../src/Composer.vala"
	gtk_revealer_set_reveal_child (_tmp200_, gtk_tree_model_iter_n_children (_tmp203_, NULL) > 1);
#line 313 "../src/Composer.vala"
	_tmp204_ = send;
#line 313 "../src/Composer.vala"
	g_object_bind_property_with_closures ((GObject*) self, "has-recipients", (GObject*) _tmp204_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 314 "../src/Composer.vala"
	_tmp205_ = headerbar;
#line 314 "../src/Composer.vala"
	g_object_bind_property_with_closures ((GObject*) self, "title", (GObject*) _tmp205_, "title", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 316 "../src/Composer.vala"
	_tmp206_ = self->priv->cc_button;
#line 316 "../src/Composer.vala"
	g_signal_connect_object ((GtkButton*) _tmp206_, "clicked", (GCallback) __mail_composer___lambda115__gtk_button_clicked, self, 0);
#line 320 "../src/Composer.vala"
	_tmp207_ = self->priv->cc_val;
#line 320 "../src/Composer.vala"
	g_signal_connect_object ((GtkEditable*) _tmp207_, "changed", (GCallback) __mail_composer___lambda116__gtk_editable_changed, self, 0);
#line 329 "../src/Composer.vala"
	_tmp208_ = _data17_->bcc_button;
#line 329 "../src/Composer.vala"
	g_signal_connect_data ((GtkButton*) _tmp208_, "clicked", (GCallback) __mail_composer___lambda117__gtk_button_clicked, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 333 "../src/Composer.vala"
	_tmp209_ = self->priv->bcc_val;
#line 333 "../src/Composer.vala"
	g_signal_connect_data ((GtkEditable*) _tmp209_, "changed", (GCallback) __mail_composer___lambda118__gtk_editable_changed, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 342 "../src/Composer.vala"
	_tmp210_ = self->priv->from_combo;
#line 342 "../src/Composer.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp210_, "changed", (GCallback) __mail_composer___lambda119__gtk_combo_box_changed, self, 0);
#line 346 "../src/Composer.vala"
	_tmp211_ = self->priv->to_val;
#line 346 "../src/Composer.vala"
	g_signal_connect_object ((GtkEditable*) _tmp211_, "changed", (GCallback) __mail_composer___lambda120__gtk_editable_changed, self, 0);
#line 351 "../src/Composer.vala"
	_tmp212_ = self->priv->to_val;
#line 351 "../src/Composer.vala"
	_tmp213_ = gtk_widget_get_style_context ((GtkWidget*) _tmp212_);
#line 351 "../src/Composer.vala"
	g_signal_connect_data (_tmp213_, "changed", (GCallback) __mail_composer___lambda121__gtk_style_context_changed, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 363 "../src/Composer.vala"
	_tmp214_ = self->priv->_to;
#line 363 "../src/Composer.vala"
	if (_tmp214_ != NULL) {
#line 8886 "Composer.c"
		GtkEntry* _tmp215_;
		const gchar* _tmp216_;
#line 364 "../src/Composer.vala"
		_tmp215_ = self->priv->to_val;
#line 364 "../src/Composer.vala"
		_tmp216_ = self->priv->_to;
#line 364 "../src/Composer.vala"
		gtk_entry_set_text (_tmp215_, _tmp216_);
#line 8895 "Composer.c"
	}
#line 367 "../src/Composer.vala"
	_tmp217_ = mail_backend_session_get_default ();
#line 367 "../src/Composer.vala"
	session = _tmp217_;
#line 368 "../src/Composer.vala"
	_tmp218_ = session;
#line 368 "../src/Composer.vala"
	g_signal_connect_data (_tmp218_, "signature-changed", (GCallback) __mail_composer___lambda122__mail_backend_session_signature_changed, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 369 "../src/Composer.vala"
	_tmp219_ = _data17_->signature_menu;
#line 369 "../src/Composer.vala"
	mail_composer_populate_signature_menu (self, _tmp219_);
#line 371 "../src/Composer.vala"
	_tmp220_ = self->priv->_mailto_query;
#line 371 "../src/Composer.vala"
	if (_tmp220_ != NULL) {
#line 8913 "Composer.c"
		GeeHashMultiMap* _result_ = NULL;
		GeeHashMultiMap* _tmp221_;
		gchar** params = NULL;
		const gchar* _tmp222_;
		gchar** _tmp223_;
		gchar** _tmp224_;
		gint params_length1;
		gint _params_size_;
		gchar** _tmp225_;
		gint _tmp225__length1;
		GeeHashMultiMap* _tmp239_;
		GeeHashMultiMap* _tmp249_;
		GeeHashMultiMap* _tmp259_;
		GeeHashMultiMap* _tmp268_;
		GeeHashMultiMap* _tmp279_;
#line 372 "../src/Composer.vala"
		_tmp221_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 372 "../src/Composer.vala"
		_result_ = _tmp221_;
#line 373 "../src/Composer.vala"
		_tmp222_ = self->priv->_mailto_query;
#line 373 "../src/Composer.vala"
		_tmp224_ = _tmp223_ = g_strsplit (_tmp222_, "&", 0);
#line 373 "../src/Composer.vala"
		params = _tmp224_;
#line 373 "../src/Composer.vala"
		params_length1 = _vala_array_length (_tmp223_);
#line 373 "../src/Composer.vala"
		_params_size_ = params_length1;
#line 375 "../src/Composer.vala"
		_tmp225_ = params;
#line 375 "../src/Composer.vala"
		_tmp225__length1 = params_length1;
#line 8947 "Composer.c"
		{
			gchar** param_collection = NULL;
			gint param_collection_length1 = 0;
			gint _param_collection_size_ = 0;
			gint param_it = 0;
#line 375 "../src/Composer.vala"
			param_collection = _tmp225_;
#line 375 "../src/Composer.vala"
			param_collection_length1 = _tmp225__length1;
#line 375 "../src/Composer.vala"
			for (param_it = 0; param_it < param_collection_length1; param_it = param_it + 1) {
#line 8959 "Composer.c"
				const gchar* param = NULL;
#line 375 "../src/Composer.vala"
				param = param_collection[param_it];
#line 8963 "Composer.c"
				{
					gchar** terms = NULL;
					const gchar* _tmp226_;
					gchar** _tmp227_;
					gchar** _tmp228_;
					gint terms_length1;
					gint _terms_size_;
					gchar** _tmp229_;
					gint _tmp229__length1;
#line 376 "../src/Composer.vala"
					_tmp226_ = param;
#line 376 "../src/Composer.vala"
					_tmp228_ = _tmp227_ = g_strsplit (_tmp226_, "=", 0);
#line 376 "../src/Composer.vala"
					terms = _tmp228_;
#line 376 "../src/Composer.vala"
					terms_length1 = _vala_array_length (_tmp227_);
#line 376 "../src/Composer.vala"
					_terms_size_ = terms_length1;
#line 377 "../src/Composer.vala"
					_tmp229_ = terms;
#line 377 "../src/Composer.vala"
					_tmp229__length1 = terms_length1;
#line 377 "../src/Composer.vala"
					if (_tmp229__length1 == 2) {
#line 8989 "Composer.c"
						GeeHashMultiMap* _tmp230_;
						gchar** _tmp231_;
						gint _tmp231__length1;
						const gchar* _tmp232_;
						gchar* _tmp233_;
						gchar* _tmp234_;
						gchar** _tmp235_;
						gint _tmp235__length1;
						const gchar* _tmp236_;
						gchar* _tmp237_;
						gchar* _tmp238_;
#line 379 "../src/Composer.vala"
						_tmp230_ = _result_;
#line 379 "../src/Composer.vala"
						_tmp231_ = terms;
#line 379 "../src/Composer.vala"
						_tmp231__length1 = terms_length1;
#line 379 "../src/Composer.vala"
						_tmp232_ = _tmp231_[0];
#line 379 "../src/Composer.vala"
						_tmp233_ = g_utf8_strdown (_tmp232_, (gssize) -1);
#line 379 "../src/Composer.vala"
						_tmp234_ = _tmp233_;
#line 379 "../src/Composer.vala"
						_tmp235_ = terms;
#line 379 "../src/Composer.vala"
						_tmp235__length1 = terms_length1;
#line 379 "../src/Composer.vala"
						_tmp236_ = _tmp235_[1];
#line 379 "../src/Composer.vala"
						_tmp237_ = g_uri_unescape_string (_tmp236_, NULL);
#line 379 "../src/Composer.vala"
						_tmp238_ = _tmp237_;
#line 379 "../src/Composer.vala"
						gee_multi_map_set ((GeeMultiMap*) _tmp230_, _tmp234_, _tmp238_);
#line 379 "../src/Composer.vala"
						_g_free0 (_tmp238_);
#line 379 "../src/Composer.vala"
						_g_free0 (_tmp234_);
#line 9029 "Composer.c"
					} else {
#line 384 "../src/Composer.vala"
						g_critical ("Composer.vala:384: Invalid mailto URL");
#line 9033 "Composer.c"
					}
#line 375 "../src/Composer.vala"
					terms = (_vala_array_free (terms, terms_length1, (GDestroyNotify) g_free), NULL);
#line 9037 "Composer.c"
				}
			}
		}
#line 388 "../src/Composer.vala"
		_tmp239_ = _result_;
#line 388 "../src/Composer.vala"
		if (gee_multi_map_contains ((GeeMultiMap*) _tmp239_, "bcc")) {
#line 9045 "Composer.c"
			GtkToggleButton* _tmp240_;
			GtkEntry* _tmp241_;
			GeeHashMultiMap* _tmp242_;
			GeeCollection* _tmp243_;
			GeeCollection* _tmp244_;
			gint _tmp245_ = 0;
			gpointer* _tmp246_;
			gchar** _tmp247_;
			gint _tmp247__length1;
			const gchar* _tmp248_;
#line 389 "../src/Composer.vala"
			_tmp240_ = _data17_->bcc_button;
#line 389 "../src/Composer.vala"
			gtk_button_clicked ((GtkButton*) _tmp240_);
#line 390 "../src/Composer.vala"
			_tmp241_ = self->priv->bcc_val;
#line 390 "../src/Composer.vala"
			_tmp242_ = _result_;
#line 390 "../src/Composer.vala"
			_tmp243_ = gee_multi_map_get ((GeeMultiMap*) _tmp242_, "bcc");
#line 390 "../src/Composer.vala"
			_tmp244_ = _tmp243_;
#line 390 "../src/Composer.vala"
			_tmp246_ = gee_collection_to_array (_tmp244_, &_tmp245_);
#line 390 "../src/Composer.vala"
			_tmp247_ = _tmp246_;
#line 390 "../src/Composer.vala"
			_tmp247__length1 = _tmp245_;
#line 390 "../src/Composer.vala"
			_tmp248_ = _tmp247_[0];
#line 390 "../src/Composer.vala"
			gtk_entry_set_text (_tmp241_, _tmp248_);
#line 390 "../src/Composer.vala"
			_tmp247_ = (_vala_array_free (_tmp247_, _tmp247__length1, (GDestroyNotify) g_free), NULL);
#line 390 "../src/Composer.vala"
			_g_object_unref0 (_tmp244_);
#line 9082 "Composer.c"
		}
#line 393 "../src/Composer.vala"
		_tmp249_ = _result_;
#line 393 "../src/Composer.vala"
		if (gee_multi_map_contains ((GeeMultiMap*) _tmp249_, "cc")) {
#line 9088 "Composer.c"
			GtkToggleButton* _tmp250_;
			GtkEntry* _tmp251_;
			GeeHashMultiMap* _tmp252_;
			GeeCollection* _tmp253_;
			GeeCollection* _tmp254_;
			gint _tmp255_ = 0;
			gpointer* _tmp256_;
			gchar** _tmp257_;
			gint _tmp257__length1;
			const gchar* _tmp258_;
#line 394 "../src/Composer.vala"
			_tmp250_ = self->priv->cc_button;
#line 394 "../src/Composer.vala"
			gtk_button_clicked ((GtkButton*) _tmp250_);
#line 395 "../src/Composer.vala"
			_tmp251_ = self->priv->cc_val;
#line 395 "../src/Composer.vala"
			_tmp252_ = _result_;
#line 395 "../src/Composer.vala"
			_tmp253_ = gee_multi_map_get ((GeeMultiMap*) _tmp252_, "cc");
#line 395 "../src/Composer.vala"
			_tmp254_ = _tmp253_;
#line 395 "../src/Composer.vala"
			_tmp256_ = gee_collection_to_array (_tmp254_, &_tmp255_);
#line 395 "../src/Composer.vala"
			_tmp257_ = _tmp256_;
#line 395 "../src/Composer.vala"
			_tmp257__length1 = _tmp255_;
#line 395 "../src/Composer.vala"
			_tmp258_ = _tmp257_[0];
#line 395 "../src/Composer.vala"
			gtk_entry_set_text (_tmp251_, _tmp258_);
#line 395 "../src/Composer.vala"
			_tmp257_ = (_vala_array_free (_tmp257_, _tmp257__length1, (GDestroyNotify) g_free), NULL);
#line 395 "../src/Composer.vala"
			_g_object_unref0 (_tmp254_);
#line 9125 "Composer.c"
		}
#line 398 "../src/Composer.vala"
		_tmp259_ = _result_;
#line 398 "../src/Composer.vala"
		if (gee_multi_map_contains ((GeeMultiMap*) _tmp259_, "subject")) {
#line 9131 "Composer.c"
			GtkEntry* _tmp260_;
			GeeHashMultiMap* _tmp261_;
			GeeCollection* _tmp262_;
			GeeCollection* _tmp263_;
			gint _tmp264_ = 0;
			gpointer* _tmp265_;
			gchar** _tmp266_;
			gint _tmp266__length1;
			const gchar* _tmp267_;
#line 399 "../src/Composer.vala"
			_tmp260_ = self->priv->subject_val;
#line 399 "../src/Composer.vala"
			_tmp261_ = _result_;
#line 399 "../src/Composer.vala"
			_tmp262_ = gee_multi_map_get ((GeeMultiMap*) _tmp261_, "subject");
#line 399 "../src/Composer.vala"
			_tmp263_ = _tmp262_;
#line 399 "../src/Composer.vala"
			_tmp265_ = gee_collection_to_array (_tmp263_, &_tmp264_);
#line 399 "../src/Composer.vala"
			_tmp266_ = _tmp265_;
#line 399 "../src/Composer.vala"
			_tmp266__length1 = _tmp264_;
#line 399 "../src/Composer.vala"
			_tmp267_ = _tmp266_[0];
#line 399 "../src/Composer.vala"
			gtk_entry_set_text (_tmp260_, _tmp267_);
#line 399 "../src/Composer.vala"
			_tmp266_ = (_vala_array_free (_tmp266_, _tmp266__length1, (GDestroyNotify) g_free), NULL);
#line 399 "../src/Composer.vala"
			_g_object_unref0 (_tmp263_);
#line 9163 "Composer.c"
		}
#line 402 "../src/Composer.vala"
		_tmp268_ = _result_;
#line 402 "../src/Composer.vala"
		if (gee_multi_map_contains ((GeeMultiMap*) _tmp268_, "body")) {
#line 9169 "Composer.c"
			CamelMimeFilterToHTMLFlags flags = 0U;
			MailWebView* _tmp269_;
			GeeHashMultiMap* _tmp270_;
			GeeCollection* _tmp271_;
			GeeCollection* _tmp272_;
			gint _tmp273_ = 0;
			gpointer* _tmp274_;
			gchar** _tmp275_;
			gint _tmp275__length1;
			const gchar* _tmp276_;
			gchar* _tmp277_;
			gchar* _tmp278_;
#line 403 "../src/Composer.vala"
			flags = ((CAMEL_MIME_FILTER_TOHTML_CONVERT_ADDRESSES | CAMEL_MIME_FILTER_TOHTML_CONVERT_NL) | CAMEL_MIME_FILTER_TOHTML_CONVERT_SPACES) | CAMEL_MIME_FILTER_TOHTML_CONVERT_URLS;
#line 409 "../src/Composer.vala"
			_tmp269_ = self->priv->web_view;
#line 409 "../src/Composer.vala"
			_tmp270_ = _result_;
#line 409 "../src/Composer.vala"
			_tmp271_ = gee_multi_map_get ((GeeMultiMap*) _tmp270_, "body");
#line 409 "../src/Composer.vala"
			_tmp272_ = _tmp271_;
#line 409 "../src/Composer.vala"
			_tmp274_ = gee_collection_to_array (_tmp272_, &_tmp273_);
#line 409 "../src/Composer.vala"
			_tmp275_ = _tmp274_;
#line 409 "../src/Composer.vala"
			_tmp275__length1 = _tmp273_;
#line 409 "../src/Composer.vala"
			_tmp276_ = _tmp275_[0];
#line 409 "../src/Composer.vala"
			_tmp277_ = camel_text_to_html (_tmp276_, flags, (guint32) 0);
#line 409 "../src/Composer.vala"
			_tmp278_ = _tmp277_;
#line 409 "../src/Composer.vala"
			mail_web_view_set_content_of_element (_tmp269_, "#elementary-message-body", _tmp278_);
#line 409 "../src/Composer.vala"
			_g_free0 (_tmp278_);
#line 409 "../src/Composer.vala"
			_tmp275_ = (_vala_array_free (_tmp275_, _tmp275__length1, (GDestroyNotify) g_free), NULL);
#line 409 "../src/Composer.vala"
			_g_object_unref0 (_tmp272_);
#line 9212 "Composer.c"
		}
#line 415 "../src/Composer.vala"
		_tmp279_ = _result_;
#line 415 "../src/Composer.vala"
		if (gee_multi_map_contains ((GeeMultiMap*) _tmp279_, "attachment")) {
#line 9218 "Composer.c"
			GtkFlowBox* _tmp299_;
			{
				GeeIterator* _path_it = NULL;
				GeeHashMultiMap* _tmp280_;
				GeeCollection* _tmp281_;
				GeeCollection* _tmp282_;
				GeeIterator* _tmp283_;
				GeeIterator* _tmp284_;
#line 416 "../src/Composer.vala"
				_tmp280_ = _result_;
#line 416 "../src/Composer.vala"
				_tmp281_ = gee_multi_map_get ((GeeMultiMap*) _tmp280_, "attachment");
#line 416 "../src/Composer.vala"
				_tmp282_ = _tmp281_;
#line 416 "../src/Composer.vala"
				_tmp283_ = gee_iterable_iterator ((GeeIterable*) _tmp282_);
#line 416 "../src/Composer.vala"
				_tmp284_ = _tmp283_;
#line 416 "../src/Composer.vala"
				_g_object_unref0 (_tmp282_);
#line 416 "../src/Composer.vala"
				_path_it = _tmp284_;
#line 416 "../src/Composer.vala"
				while (TRUE) {
#line 9243 "Composer.c"
					GeeIterator* _tmp285_;
					gchar* path = NULL;
					GeeIterator* _tmp286_;
					gpointer _tmp287_;
					GFile* _tmp288_ = NULL;
					const gchar* _tmp289_;
					GFile* file = NULL;
					GFile* _tmp294_;
					GtkFlowBox* _tmp295_;
					GFile* _tmp296_;
					MailComposerAttachment* _tmp297_;
					MailComposerAttachment* _tmp298_;
#line 416 "../src/Composer.vala"
					_tmp285_ = _path_it;
#line 416 "../src/Composer.vala"
					if (!gee_iterator_next (_tmp285_)) {
#line 416 "../src/Composer.vala"
						break;
#line 9262 "Composer.c"
					}
#line 416 "../src/Composer.vala"
					_tmp286_ = _path_it;
#line 416 "../src/Composer.vala"
					_tmp287_ = gee_iterator_get (_tmp286_);
#line 416 "../src/Composer.vala"
					path = (gchar*) _tmp287_;
#line 417 "../src/Composer.vala"
					_tmp289_ = path;
#line 417 "../src/Composer.vala"
					if (g_str_has_prefix (_tmp289_, "file://")) {
#line 9274 "Composer.c"
						const gchar* _tmp290_;
						GFile* _tmp291_;
#line 417 "../src/Composer.vala"
						_tmp290_ = path;
#line 417 "../src/Composer.vala"
						_tmp291_ = g_file_new_for_uri (_tmp290_);
#line 417 "../src/Composer.vala"
						_g_object_unref0 (_tmp288_);
#line 417 "../src/Composer.vala"
						_tmp288_ = _tmp291_;
#line 9285 "Composer.c"
					} else {
						const gchar* _tmp292_;
						GFile* _tmp293_;
#line 417 "../src/Composer.vala"
						_tmp292_ = path;
#line 417 "../src/Composer.vala"
						_tmp293_ = g_file_new_for_path (_tmp292_);
#line 417 "../src/Composer.vala"
						_g_object_unref0 (_tmp288_);
#line 417 "../src/Composer.vala"
						_tmp288_ = _tmp293_;
#line 9297 "Composer.c"
					}
#line 417 "../src/Composer.vala"
					_tmp294_ = _g_object_ref0 (_tmp288_);
#line 417 "../src/Composer.vala"
					file = _tmp294_;
#line 419 "../src/Composer.vala"
					_tmp295_ = self->priv->attachment_box;
#line 419 "../src/Composer.vala"
					_tmp296_ = file;
#line 419 "../src/Composer.vala"
					_tmp297_ = mail_composer_attachment_new (_tmp296_, MAIL_COMPOSER_ATTACHMENT_DISPOSITION_ATTACHMENT);
#line 419 "../src/Composer.vala"
					g_object_ref_sink (_tmp297_);
#line 419 "../src/Composer.vala"
					_tmp298_ = _tmp297_;
#line 419 "../src/Composer.vala"
					gtk_container_add ((GtkContainer*) _tmp295_, (GtkWidget*) _tmp298_);
#line 419 "../src/Composer.vala"
					_g_object_unref0 (_tmp298_);
#line 416 "../src/Composer.vala"
					_g_object_unref0 (file);
#line 416 "../src/Composer.vala"
					_g_object_unref0 (_tmp288_);
#line 416 "../src/Composer.vala"
					_g_free0 (path);
#line 9323 "Composer.c"
				}
#line 416 "../src/Composer.vala"
				_g_object_unref0 (_path_it);
#line 9327 "Composer.c"
			}
#line 421 "../src/Composer.vala"
			_tmp299_ = self->priv->attachment_box;
#line 421 "../src/Composer.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp299_);
#line 9333 "Composer.c"
		}
#line 371 "../src/Composer.vala"
		params = (_vala_array_free (params, params_length1, (GDestroyNotify) g_free), NULL);
#line 371 "../src/Composer.vala"
		_g_object_unref0 (_result_);
#line 9339 "Composer.c"
	}
#line 66 "../src/Composer.vala"
	_g_object_unref0 (contact_manager);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (main_box);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (view_overlay);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (action_bar);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (send);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (signature_button);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (attach);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (discard);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (editor_toolbar);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (image);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (recipient_grid);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (size_group);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (bcc_box);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (bcc_label);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (cc_box);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (cc_label);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (subject_label);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (to_label);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (from_revealer);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (from_box);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (from_label);
#line 66 "../src/Composer.vala"
	_g_object_unref0 (headerbar);
#line 66 "../src/Composer.vala"
	block17_data_unref (_data17_);
#line 66 "../src/Composer.vala"
	_data17_ = NULL;
#line 66 "../src/Composer.vala"
	return obj;
#line 9391 "Composer.c"
}

static void
mail_composer_class_init (MailComposerClass * klass,
                          gpointer klass_data)
{
#line 8 "../src/Composer.vala"
	mail_composer_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Composer.vala"
	g_type_class_adjust_private_offset (klass, &MailComposer_private_offset);
#line 8 "../src/Composer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_mail_composer_get_property;
#line 8 "../src/Composer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_mail_composer_set_property;
#line 8 "../src/Composer.vala"
	G_OBJECT_CLASS (klass)->constructor = mail_composer_constructor;
#line 8 "../src/Composer.vala"
	G_OBJECT_CLASS (klass)->finalize = mail_composer_finalize;
#line 8 "../src/Composer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_COMPOSER_HAS_RECIPIENTS_PROPERTY, mail_composer_properties[MAIL_COMPOSER_HAS_RECIPIENTS_PROPERTY] = g_param_spec_boolean ("has-recipients", "has-recipients", "has-recipients", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "../src/Composer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_COMPOSER_TO_PROPERTY, mail_composer_properties[MAIL_COMPOSER_TO_PROPERTY] = g_param_spec_string ("to", "to", "to", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Composer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_COMPOSER_MAILTO_QUERY_PROPERTY, mail_composer_properties[MAIL_COMPOSER_MAILTO_QUERY_PROPERTY] = g_param_spec_string ("mailto-query", "mailto-query", "mailto-query", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Composer.vala"
	mail_composer_signals[MAIL_COMPOSER_FINISHED_SIGNAL] = g_signal_new ("finished", MAIL_TYPE_COMPOSER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 9418 "Composer.c"
}

static void
mail_composer_instance_init (MailComposer * self,
                             gpointer klass)
{
#line 8 "../src/Composer.vala"
	self->priv = mail_composer_get_instance_private (self);
#line 24 "../src/Composer.vala"
	self->priv->discard_draft = FALSE;
#line 25 "../src/Composer.vala"
	self->priv->ancestor_message_info = NULL;
#line 9431 "Composer.c"
}

static void
mail_composer_finalize (GObject * obj)
{
	MailComposer * self;
#line 8 "../src/Composer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_COMPOSER, MailComposer);
#line 21 "../src/Composer.vala"
	_g_free0 (self->priv->_to);
#line 22 "../src/Composer.vala"
	_g_free0 (self->priv->_mailto_query);
#line 25 "../src/Composer.vala"
	_g_object_unref0 (self->priv->ancestor_message_info);
#line 27 "../src/Composer.vala"
	_g_object_unref0 (self->priv->web_view);
#line 28 "../src/Composer.vala"
	_g_object_unref0 (self->priv->to_val);
#line 29 "../src/Composer.vala"
	_g_object_unref0 (self->priv->cc_val);
#line 30 "../src/Composer.vala"
	_g_object_unref0 (self->priv->bcc_val);
#line 31 "../src/Composer.vala"
	_g_object_unref0 (self->priv->attachment_box);
#line 32 "../src/Composer.vala"
	_g_object_unref0 (self->priv->cc_revealer);
#line 33 "../src/Composer.vala"
	_g_object_unref0 (self->priv->bcc_revealer);
#line 34 "../src/Composer.vala"
	_g_object_unref0 (self->priv->cc_button);
#line 35 "../src/Composer.vala"
	_g_object_unref0 (self->priv->message_url_overlay);
#line 36 "../src/Composer.vala"
	_g_object_unref0 (self->priv->from_combo);
#line 37 "../src/Composer.vala"
	_g_object_unref0 (self->priv->subject_val);
#line 8 "../src/Composer.vala"
	G_OBJECT_CLASS (mail_composer_parent_class)->finalize (obj);
#line 9470 "Composer.c"
}

static GType
mail_composer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailComposerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_composer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailComposer), 0, (GInstanceInitFunc) mail_composer_instance_init, NULL };
	GType mail_composer_type_id;
	mail_composer_type_id = g_type_register_static (hdy_application_window_get_type (), "MailComposer", &g_define_type_info, 0);
	MailComposer_private_offset = g_type_add_instance_private (mail_composer_type_id, sizeof (MailComposerPrivate));
	return mail_composer_type_id;
}

GType
mail_composer_get_type (void)
{
	static volatile gsize mail_composer_type_id__once = 0;
	if (g_once_init_enter (&mail_composer_type_id__once)) {
		GType mail_composer_type_id;
		mail_composer_type_id = mail_composer_get_type_once ();
		g_once_init_leave (&mail_composer_type_id__once, mail_composer_type_id);
	}
	return mail_composer_type_id__once;
}

static void
_vala_mail_composer_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	MailComposer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_TYPE_COMPOSER, MailComposer);
#line 8 "../src/Composer.vala"
	switch (property_id) {
#line 8 "../src/Composer.vala"
		case MAIL_COMPOSER_HAS_RECIPIENTS_PROPERTY:
#line 8 "../src/Composer.vala"
		g_value_set_boolean (value, mail_composer_get_has_recipients (self));
#line 8 "../src/Composer.vala"
		break;
#line 8 "../src/Composer.vala"
		case MAIL_COMPOSER_TO_PROPERTY:
#line 8 "../src/Composer.vala"
		g_value_set_string (value, mail_composer_get_to (self));
#line 8 "../src/Composer.vala"
		break;
#line 8 "../src/Composer.vala"
		case MAIL_COMPOSER_MAILTO_QUERY_PROPERTY:
#line 8 "../src/Composer.vala"
		g_value_set_string (value, mail_composer_get_mailto_query (self));
#line 8 "../src/Composer.vala"
		break;
#line 9523 "Composer.c"
		default:
#line 8 "../src/Composer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Composer.vala"
		break;
#line 9529 "Composer.c"
	}
}

static void
_vala_mail_composer_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	MailComposer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_TYPE_COMPOSER, MailComposer);
#line 8 "../src/Composer.vala"
	switch (property_id) {
#line 8 "../src/Composer.vala"
		case MAIL_COMPOSER_HAS_RECIPIENTS_PROPERTY:
#line 8 "../src/Composer.vala"
		mail_composer_set_has_recipients (self, g_value_get_boolean (value));
#line 8 "../src/Composer.vala"
		break;
#line 8 "../src/Composer.vala"
		case MAIL_COMPOSER_TO_PROPERTY:
#line 8 "../src/Composer.vala"
		mail_composer_set_to (self, g_value_get_string (value));
#line 8 "../src/Composer.vala"
		break;
#line 8 "../src/Composer.vala"
		case MAIL_COMPOSER_MAILTO_QUERY_PROPERTY:
#line 8 "../src/Composer.vala"
		mail_composer_set_mailto_query (self, g_value_get_string (value));
#line 8 "../src/Composer.vala"
		break;
#line 9561 "Composer.c"
		default:
#line 8 "../src/Composer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Composer.vala"
		break;
#line 9567 "Composer.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

